// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('javascript_externs_generator.extern');
goog.require('cljs.core');
goog.require('goog.dom');
goog.require('goog.object');
goog.require('clojure.string');
/**
 * Differentiate between function property and object property
 */
javascript_externs_generator.extern.prop_type = (function javascript_externs_generator$extern$prop_type(obj){
if(cljs.core.fn_QMARK_.call(null,obj)){
return new cljs.core.Keyword(null,"function","function",-2127255473);
} else {
return new cljs.core.Keyword(null,"object","object",1474613949);
}
});
/**
 * Is it possible for this object to have child properties?
 */
javascript_externs_generator.extern.parent_type_QMARK_ = (function javascript_externs_generator$extern$parent_type_QMARK_(obj){
return ((cljs.core._EQ_.call(null,goog.typeOf(obj),"object")) || (cljs.core.fn_QMARK_.call(null,obj)));
});
/**
 * Build a recursive tree representation of the JavaScript object
 *   and metadata about its properties, prototype, and functions
 */
javascript_externs_generator.extern.generate_object_tree = (function javascript_externs_generator$extern$generate_object_tree(var_args){
var G__2035 = arguments.length;
switch (G__2035) {
case 2:
return javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$2 = (function (obj,name){
return javascript_externs_generator.extern.generate_object_tree.call(null,obj,name,cljs.core.PersistentHashSet.EMPTY);
});

javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$3 = (function (obj,name,seen){
return new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"name","name",1843675177),name,new cljs.core.Keyword(null,"type","type",1174270348),javascript_externs_generator.extern.prop_type.call(null,obj),new cljs.core.Keyword(null,"props","props",453281727),(function (){var iter__4292__auto__ = (function javascript_externs_generator$extern$iter__2036(s__2037){
return (new cljs.core.LazySeq(null,(function (){
var s__2037__$1 = s__2037;
while(true){
var temp__4657__auto__ = cljs.core.seq.call(null,s__2037__$1);
if(temp__4657__auto__){
var s__2037__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__2037__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__2037__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__2039 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__2038 = (0);
while(true){
if((i__2038 < size__4291__auto__)){
var prop_name = cljs.core._nth.call(null,c__4290__auto__,i__2038);
var child = goog.object.get(obj,prop_name);
cljs.core.chunk_append.call(null,b__2039,(cljs.core.truth_((function (){var and__3911__auto__ = javascript_externs_generator.extern.parent_type_QMARK_.call(null,child);
if(cljs.core.truth_(and__3911__auto__)){
return ((!(cljs.core.contains_QMARK_.call(null,seen,child))) && (cljs.core.not.call(null,child.nodeType)));
} else {
return and__3911__auto__;
}
})())?javascript_externs_generator.extern.generate_object_tree.call(null,child,prop_name,cljs.core.conj.call(null,seen,child)):new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),javascript_externs_generator.extern.prop_type.call(null,child)], null)));

var G__2045 = (i__2038 + (1));
i__2038 = G__2045;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2039),javascript_externs_generator$extern$iter__2036.call(null,cljs.core.chunk_rest.call(null,s__2037__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2039),null);
}
} else {
var prop_name = cljs.core.first.call(null,s__2037__$2);
var child = goog.object.get(obj,prop_name);
return cljs.core.cons.call(null,(cljs.core.truth_((function (){var and__3911__auto__ = javascript_externs_generator.extern.parent_type_QMARK_.call(null,child);
if(cljs.core.truth_(and__3911__auto__)){
return ((!(cljs.core.contains_QMARK_.call(null,seen,child))) && (cljs.core.not.call(null,child.nodeType)));
} else {
return and__3911__auto__;
}
})())?javascript_externs_generator.extern.generate_object_tree.call(null,child,prop_name,cljs.core.conj.call(null,seen,child)):new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),javascript_externs_generator.extern.prop_type.call(null,child)], null)),javascript_externs_generator$extern$iter__2036.call(null,cljs.core.rest.call(null,s__2037__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,cljs.core.sort.call(null,goog.object.getKeys(obj)));
})(),new cljs.core.Keyword(null,"prototype","prototype",-1121365005),(function (){var iter__4292__auto__ = (function javascript_externs_generator$extern$iter__2040(s__2041){
return (new cljs.core.LazySeq(null,(function (){
var s__2041__$1 = s__2041;
while(true){
var temp__4657__auto__ = cljs.core.seq.call(null,s__2041__$1);
if(temp__4657__auto__){
var s__2041__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__2041__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__2041__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__2043 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__2042 = (0);
while(true){
if((i__2042 < size__4291__auto__)){
var prop_name = cljs.core._nth.call(null,c__4290__auto__,i__2042);
cljs.core.chunk_append.call(null,b__2043,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"function","function",-2127255473)], null));

var G__2046 = (i__2042 + (1));
i__2042 = G__2046;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2043),javascript_externs_generator$extern$iter__2040.call(null,cljs.core.chunk_rest.call(null,s__2041__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2043),null);
}
} else {
var prop_name = cljs.core.first.call(null,s__2041__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"function","function",-2127255473)], null),javascript_externs_generator$extern$iter__2040.call(null,cljs.core.rest.call(null,s__2041__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,cljs.core.sort.call(null,goog.object.getKeys(obj.prototype)));
})()], null);
});

javascript_externs_generator.extern.generate_object_tree.cljs$lang$maxFixedArity = 3;

/**
 * Return recursive string representation of an object's properties
 */
javascript_externs_generator.extern.emit_props_extern = (function javascript_externs_generator$extern$emit_props_extern(obj){
var map__2047 = obj;
var map__2047__$1 = ((((!((map__2047 == null)))?(((((map__2047.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__2047.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__2047):map__2047);
var name = cljs.core.get.call(null,map__2047__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var type = cljs.core.get.call(null,map__2047__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var props = cljs.core.get.call(null,map__2047__$1,new cljs.core.Keyword(null,"props","props",453281727));
var function_str = ((((cljs.core._EQ_.call(null,type,new cljs.core.Keyword(null,"function","function",-2127255473))) && (cljs.core.empty_QMARK_.call(null,props))))?"function()":"");
var props_extern = ["{",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,",",(function (){var iter__4292__auto__ = ((function (map__2047,map__2047__$1,name,type,props,function_str){
return (function javascript_externs_generator$extern$emit_props_extern_$_iter__2049(s__2050){
return (new cljs.core.LazySeq(null,((function (map__2047,map__2047__$1,name,type,props,function_str){
return (function (){
var s__2050__$1 = s__2050;
while(true){
var temp__4657__auto__ = cljs.core.seq.call(null,s__2050__$1);
if(temp__4657__auto__){
var s__2050__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__2050__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__2050__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__2052 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__2051 = (0);
while(true){
if((i__2051 < size__4291__auto__)){
var p = cljs.core._nth.call(null,c__4290__auto__,i__2051);
cljs.core.chunk_append.call(null,b__2052,javascript_externs_generator.extern.emit_props_extern.call(null,p));

var G__2053 = (i__2051 + (1));
i__2051 = G__2053;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2052),javascript_externs_generator$extern$emit_props_extern_$_iter__2049.call(null,cljs.core.chunk_rest.call(null,s__2050__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2052),null);
}
} else {
var p = cljs.core.first.call(null,s__2050__$2);
return cljs.core.cons.call(null,javascript_externs_generator.extern.emit_props_extern.call(null,p),javascript_externs_generator$extern$emit_props_extern_$_iter__2049.call(null,cljs.core.rest.call(null,s__2050__$2)));
}
} else {
return null;
}
break;
}
});})(map__2047,map__2047__$1,name,type,props,function_str))
,null,null));
});})(map__2047,map__2047__$1,name,type,props,function_str))
;
return iter__4292__auto__.call(null,props);
})())),"}"].join('');
if(cljs.core.truth_(cljs.core.get.call(null,obj,new cljs.core.Keyword(null,"root","root",-448657453)))){
return ["var ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)," = ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(function_str),cljs.core.str.cljs$core$IFn$_invoke$arity$1(props_extern),";"].join('');
} else {
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.quote_string.call(null,name)),": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(function_str),cljs.core.str.cljs$core$IFn$_invoke$arity$1(props_extern)].join('');
}
});
/**
 * Return string representation of an object's prototype/functions
 */
javascript_externs_generator.extern.emit_prototype = (function javascript_externs_generator$extern$emit_prototype(namespace,prototype){
if(cljs.core.seq.call(null,prototype)){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(namespace),".prototype = {",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,",",(function (){var iter__4292__auto__ = (function javascript_externs_generator$extern$emit_prototype_$_iter__2054(s__2055){
return (new cljs.core.LazySeq(null,(function (){
var s__2055__$1 = s__2055;
while(true){
var temp__4657__auto__ = cljs.core.seq.call(null,s__2055__$1);
if(temp__4657__auto__){
var s__2055__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__2055__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__2055__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__2057 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__2056 = (0);
while(true){
if((i__2056 < size__4291__auto__)){
var p = cljs.core._nth.call(null,c__4290__auto__,i__2056);
cljs.core.chunk_append.call(null,b__2057,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.quote_string.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))),": function(){}"].join(''));

var G__2058 = (i__2056 + (1));
i__2056 = G__2058;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2057),javascript_externs_generator$extern$emit_prototype_$_iter__2054.call(null,cljs.core.chunk_rest.call(null,s__2055__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2057),null);
}
} else {
var p = cljs.core.first.call(null,s__2055__$2);
return cljs.core.cons.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.quote_string.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))),": function(){}"].join(''),javascript_externs_generator$extern$emit_prototype_$_iter__2054.call(null,cljs.core.rest.call(null,s__2055__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,prototype);
})())),"};"].join('');
} else {
return null;
}
});
/**
 * Return recursive string representation of an object's prototype chain
 */
javascript_externs_generator.extern.emit_prototype_extern = (function javascript_externs_generator$extern$emit_prototype_extern(obj,namespace){
var map__2059 = obj;
var map__2059__$1 = ((((!((map__2059 == null)))?(((((map__2059.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__2059.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__2059):map__2059);
var name = cljs.core.get.call(null,map__2059__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var props = cljs.core.get.call(null,map__2059__$1,new cljs.core.Keyword(null,"props","props",453281727));
var prototype = cljs.core.get.call(null,map__2059__$1,new cljs.core.Keyword(null,"prototype","prototype",-1121365005));
var prototype_extern = javascript_externs_generator.extern.emit_prototype.call(null,namespace,prototype);
var child_prototype_externs = (function (){var iter__4292__auto__ = ((function (map__2059,map__2059__$1,name,props,prototype,prototype_extern){
return (function javascript_externs_generator$extern$emit_prototype_extern_$_iter__2061(s__2062){
return (new cljs.core.LazySeq(null,((function (map__2059,map__2059__$1,name,props,prototype,prototype_extern){
return (function (){
var s__2062__$1 = s__2062;
while(true){
var temp__4657__auto__ = cljs.core.seq.call(null,s__2062__$1);
if(temp__4657__auto__){
var s__2062__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__2062__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__2062__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__2064 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__2063 = (0);
while(true){
if((i__2063 < size__4291__auto__)){
var p = cljs.core._nth.call(null,c__4290__auto__,i__2063);
cljs.core.chunk_append.call(null,b__2064,javascript_externs_generator.extern.emit_prototype_extern.call(null,p,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(namespace),".",cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))].join('')));

var G__2065 = (i__2063 + (1));
i__2063 = G__2065;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2064),javascript_externs_generator$extern$emit_prototype_extern_$_iter__2061.call(null,cljs.core.chunk_rest.call(null,s__2062__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__2064),null);
}
} else {
var p = cljs.core.first.call(null,s__2062__$2);
return cljs.core.cons.call(null,javascript_externs_generator.extern.emit_prototype_extern.call(null,p,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(namespace),".",cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))].join('')),javascript_externs_generator$extern$emit_prototype_extern_$_iter__2061.call(null,cljs.core.rest.call(null,s__2062__$2)));
}
} else {
return null;
}
break;
}
});})(map__2059,map__2059__$1,name,props,prototype,prototype_extern))
,null,null));
});})(map__2059,map__2059__$1,name,props,prototype,prototype_extern))
;
return iter__4292__auto__.call(null,props);
})();
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prototype_extern),cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,child_prototype_externs))].join('');
});
/**
 * Recursively extract properties and prototypes from a JavaScript object
 *   into an extern for use with the Google Closure Compiler
 */
javascript_externs_generator.extern.extract = (function javascript_externs_generator$extern$extract(name,js_object){
var tree = cljs.core.assoc.call(null,javascript_externs_generator.extern.generate_object_tree.call(null,js_object,name),new cljs.core.Keyword(null,"root","root",-448657453),true);
var props_extern = javascript_externs_generator.extern.emit_props_extern.call(null,tree);
var prototype_extern = javascript_externs_generator.extern.emit_prototype_extern.call(null,tree,name);
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(props_extern),cljs.core.str.cljs$core$IFn$_invoke$arity$1(prototype_extern)].join('');
});
/**
 * Add header and footer to extern output
 */
javascript_externs_generator.extern.wrap_extern = (function javascript_externs_generator$extern$wrap_extern(name,extern){
var header = ["/**********************************************************************\n"," * Extern for ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"\n"," * Generated by http://jmmk.github.io/javascript-externs-generator\n"," **********************************************************************/\n"].join('');
var footer = ["/**********************************************************************\n"," * End Generated Extern for ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"\n","/**********************************************************************/\n"].join('');
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(header),cljs.core.str.cljs$core$IFn$_invoke$arity$1(extern),"\n",cljs.core.str.cljs$core$IFn$_invoke$arity$1(footer)].join('');
});
/**
 * Grab a loaded JavaScript object to extract an extern
 */
javascript_externs_generator.extern.extract_loaded = (function javascript_externs_generator$extern$extract_loaded(name){
var sandbox = goog.dom.getElement("sandbox");
var js_object = goog.object.get(goog.object.get(sandbox,"contentWindow"),name);
if((js_object == null)){
throw ["Namespace '",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"' was not found. Make sure the library is loaded and the name is spelled correctly."].join('');
} else {
}

return javascript_externs_generator.extern.wrap_extern.call(null,name,javascript_externs_generator.extern.extract.call(null,name,js_object));
});

//# sourceMappingURL=extern.js.map
