// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('javascript_externs_generator.ui.handlers');
goog.require('cljs.core');
goog.require('re_frame.core');
goog.require('clojure.string');
goog.require('goog.net.jsloader');
goog.require('goog.dom');
goog.require('goog.object');
goog.require('goog.html.legacyconversions');
cljs.core.load_file("out-cli/cljsjs/js-beautify/development/beautify.inc.js");
goog.require('javascript_externs_generator.ui.db');
goog.require('javascript_externs_generator.extern');
javascript_externs_generator.ui.handlers.default_middleware = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_frame.core.trim_v], null);
javascript_externs_generator.ui.handlers.load_script = (function javascript_externs_generator$ui$handlers$load_script(url,success,err){
var converted_url = goog.html.legacyconversions.trustedResourceUrlFromString(url);
var sandbox = goog.dom.getElement("sandbox");
var options = ({"document": goog.object.get(sandbox,"contentDocument")});
return goog.net.jsloader.safeLoad(converted_url,options).addCallbacks(success,err);
});
javascript_externs_generator.ui.handlers.error_string = (function javascript_externs_generator$ui$handlers$error_string(error){
var check_console = "Check console for stack trace.";
if((error == null)){
return ["Unknown Error: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(check_console)].join('');
} else {
if(typeof error === 'string'){
return error;
} else {
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(error.name),": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(error.message),". ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(check_console)].join('');

}
}
});
javascript_externs_generator.ui.handlers.beautify_options = cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"indent_size","indent_size",1036606414),(2),new cljs.core.Keyword(null,"indent_char","indent_char",-1442870146)," ",new cljs.core.Keyword(null,"preserve_newlines","preserve_newlines",643809793),true,new cljs.core.Keyword(null,"space_after_anon_function","space_after_anon_function",1585946861),true,new cljs.core.Keyword(null,"jslint_happy","jslint_happy",139458065),false], null));
javascript_externs_generator.ui.handlers.beautify = (function javascript_externs_generator$ui$handlers$beautify(output){
return js_beautify(output,javascript_externs_generator.ui.handlers.beautify_options);
});
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"initialize","initialize",609952913),(function (_,___$1){
return javascript_externs_generator.ui.db.default_state;
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"load-script","load-script",-1498395223),(function (db,_){
var url = new cljs.core.Keyword(null,"url-text","url-text",-1921657750).cljs$core$IFn$_invoke$arity$1(db);
if(clojure.string.blank_QMARK_.call(null,url)){
re_frame.core.dispatch.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"alert","alert",-571950580),"Blank Field Error","Please enter the url of your JavaScript file to be loaded"], null));

return db;
} else {
javascript_externs_generator.ui.handlers.load_script.call(null,url,((function (url){
return (function (){
return re_frame.core.dispatch.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"load-succeeded","load-succeeded",257244510),url], null));
});})(url))
,((function (url){
return (function (){
return re_frame.core.dispatch.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"load-failed","load-failed",1391682794),url], null));
});})(url))
);

return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"loading-js","loading-js",767153012),true);
}
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"generate-extern","generate-extern",926274329),(function (db,_){
var map__9299 = db;
var map__9299__$1 = ((((!((map__9299 == null)))?(((((map__9299.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__9299.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__9299):map__9299);
var externed_namespaces = cljs.core.get.call(null,map__9299__$1,new cljs.core.Keyword(null,"externed-namespaces","externed-namespaces",383598032));
var namespace_text = cljs.core.get.call(null,map__9299__$1,new cljs.core.Keyword(null,"namespace-text","namespace-text",2126189174));
if(clojure.string.blank_QMARK_.call(null,namespace_text)){
re_frame.core.dispatch.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"alert","alert",-571950580),"Blank Field Error","Please enter a namespace to generate an extern"], null));

return db;
} else {
re_frame.core.dispatch.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"namespace-text-change","namespace-text-change",1910567535),""], null));

try{return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"current-namespace","current-namespace",-1512089502),namespace_text,new cljs.core.Keyword(null,"externed-namespaces","externed-namespaces",383598032),cljs.core.assoc.call(null,externed_namespaces,namespace_text,javascript_externs_generator.ui.handlers.beautify.call(null,javascript_externs_generator.extern.extract_loaded.call(null,namespace_text))));
}catch (e9301){var e = e9301;
console.error(e);

re_frame.core.dispatch.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"alert","alert",-571950580),"Error generating extern",javascript_externs_generator.ui.handlers.error_string.call(null,e)], null));

return db;
}}
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"alert","alert",-571950580),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [javascript_externs_generator.ui.handlers.default_middleware], null),(function (db,p__9302){
var vec__9303 = p__9302;
var heading = cljs.core.nth.call(null,vec__9303,(0),null);
var text = cljs.core.nth.call(null,vec__9303,(1),null);
return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"alert","alert",-571950580),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"heading","heading",-1312171873),heading,new cljs.core.Keyword(null,"text","text",-1790561697),text], null));
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"close-alert","close-alert",-638815570),(function (db,_){
return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"alert","alert",-571950580),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"heading","heading",-1312171873),"",new cljs.core.Keyword(null,"text","text",-1790561697),""], null));
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"load-failed","load-failed",1391682794),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [javascript_externs_generator.ui.handlers.default_middleware], null),(function (db,p__9306){
var vec__9307 = p__9306;
var url = cljs.core.nth.call(null,vec__9307,(0),null);
return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"loading-js","loading-js",767153012),false);
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"load-succeeded","load-succeeded",257244510),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [javascript_externs_generator.ui.handlers.default_middleware], null),(function (db,p__9310){
var vec__9311 = p__9310;
var url = cljs.core.nth.call(null,vec__9311,(0),null);
re_frame.core.dispatch.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"url-text-change","url-text-change",336973163),""], null));

return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"loading-js","loading-js",767153012),false,new cljs.core.Keyword(null,"loaded-urls","loaded-urls",-1460296774),cljs.core.conj.call(null,new cljs.core.Keyword(null,"loaded-urls","loaded-urls",-1460296774).cljs$core$IFn$_invoke$arity$1(db),url));
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"show-namespace","show-namespace",-823174078),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [javascript_externs_generator.ui.handlers.default_middleware], null),(function (db,p__9314){
var vec__9315 = p__9314;
var namespace = cljs.core.nth.call(null,vec__9315,(0),null);
return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"current-namespace","current-namespace",-1512089502),namespace);
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"url-text-change","url-text-change",336973163),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [javascript_externs_generator.ui.handlers.default_middleware], null),(function (db,p__9318){
var vec__9319 = p__9318;
var url_text = cljs.core.nth.call(null,vec__9319,(0),null);
return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"url-text","url-text",-1921657750),url_text);
}));
re_frame.core.register_handler.call(null,new cljs.core.Keyword(null,"namespace-text-change","namespace-text-change",1910567535),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [javascript_externs_generator.ui.handlers.default_middleware], null),(function (db,p__9322){
var vec__9323 = p__9322;
var namespace_text = cljs.core.nth.call(null,vec__9323,(0),null);
return cljs.core.assoc.call(null,db,new cljs.core.Keyword(null,"namespace-text","namespace-text",2126189174),namespace_text);
}));

//# sourceMappingURL=handlers.js.map
