// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('re_com.typeahead');
goog.require('cljs.core');
goog.require('cljs.core.async');
goog.require('re_com.misc');
goog.require('re_com.util');
goog.require('re_com.popover');
goog.require('re_com.box');
goog.require('re_com.validate');
goog.require('reagent.core');
goog.require('goog.events.KeyCodes');

/**
 * Return an initial value for the typeahead state, given `args`.
 */
re_com.typeahead.make_typeahead_state = (function re_com$typeahead$make_typeahead_state(p__6885){
var map__6886 = p__6885;
var map__6886__$1 = ((((!((map__6886 == null)))?(((((map__6886.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6886.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6886):map__6886);
var args = map__6886__$1;
var on_change = cljs.core.get.call(null,map__6886__$1,new cljs.core.Keyword(null,"on-change","on-change",-732046149));
var rigid_QMARK_ = cljs.core.get.call(null,map__6886__$1,new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118));
var change_on_blur_QMARK_ = cljs.core.get.call(null,map__6886__$1,new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925));
var data_source = cljs.core.get.call(null,map__6886__$1,new cljs.core.Keyword(null,"data-source","data-source",-658934676));
var suggestion_to_string = cljs.core.get.call(null,map__6886__$1,new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962));
var debounce_delay = cljs.core.get.call(null,map__6886__$1,new cljs.core.Keyword(null,"debounce-delay","debounce-delay",-608187982));
var model = cljs.core.get.call(null,map__6886__$1,new cljs.core.Keyword(null,"model","model",331153215));
var external_model_value = re_com.util.deref_or_value.call(null,model);
var G__6888 = (function (){var c_input = cljs.core.async.chan.call(null);
return cljs.core.PersistentHashMap.fromArrays([new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962),new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),new cljs.core.Keyword(null,"input-text","input-text",-1336297114),new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118),new cljs.core.Keyword(null,"data-source","data-source",-658934676),new cljs.core.Keyword(null,"c-search","c-search",1832536180),new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925),new cljs.core.Keyword(null,"suggestions","suggestions",-859472618),new cljs.core.Keyword(null,"c-input","c-input",-1821004232),new cljs.core.Keyword(null,"on-change","on-change",-732046149),new cljs.core.Keyword(null,"external-model","external-model",506095421),new cljs.core.Keyword(null,"model","model",331153215)],[false,(function (){var or__3922__auto__ = suggestion_to_string;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.str;
}
})(),false,"",rigid_QMARK_,data_source,re_com.typeahead.debounce.call(null,c_input,debounce_delay),change_on_blur_QMARK_,cljs.core.PersistentVector.EMPTY,c_input,on_change,re_com.util.deref_or_value.call(null,model),re_com.util.deref_or_value.call(null,model)]);
})();
if(cljs.core.truth_(external_model_value)){
return re_com.typeahead.display_suggestion.call(null,G__6888,external_model_value);
} else {
return G__6888;
}
});
/**
 * Should `event` update the `typeahead` `model`?
 */
re_com.typeahead.event_updates_model_QMARK_ = (function re_com$typeahead$event_updates_model_QMARK_(p__6889,event){
var map__6890 = p__6889;
var map__6890__$1 = ((((!((map__6890 == null)))?(((((map__6890.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6890.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6890):map__6890);
var state = map__6890__$1;
var change_on_blur_QMARK_ = cljs.core.get.call(null,map__6890__$1,new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925));
var rigid_QMARK_ = cljs.core.get.call(null,map__6890__$1,new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118));
var change_on_blur_QMARK___$1 = re_com.util.deref_or_value.call(null,change_on_blur_QMARK_);
var rigid_QMARK___$1 = re_com.util.deref_or_value.call(null,rigid_QMARK_);
var G__6892 = event;
var G__6892__$1 = (((G__6892 instanceof cljs.core.Keyword))?G__6892.fqn:null);
switch (G__6892__$1) {
case "input-text-blurred":
var and__3911__auto__ = change_on_blur_QMARK___$1;
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core.not.call(null,rigid_QMARK___$1);
} else {
return and__3911__auto__;
}

break;
case "suggestion-activated":
return cljs.core.not.call(null,change_on_blur_QMARK___$1);

break;
case "input-text-changed":
return cljs.core.not.call(null,(function (){var or__3922__auto__ = change_on_blur_QMARK___$1;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return rigid_QMARK___$1;
}
})());

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__6892__$1)].join('')));

}
});
/**
 * Should `event` cause the `input-text` value to be used to show the active suggestion?
 */
re_com.typeahead.event_displays_suggestion_QMARK_ = (function re_com$typeahead$event_displays_suggestion_QMARK_(p__6894,event){
var map__6895 = p__6894;
var map__6895__$1 = ((((!((map__6895 == null)))?(((((map__6895.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6895.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6895):map__6895);
var state = map__6895__$1;
var change_on_blur_QMARK_ = cljs.core.get.call(null,map__6895__$1,new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925));
var change_on_blur_QMARK___$1 = re_com.util.deref_or_value.call(null,change_on_blur_QMARK_);
var G__6897 = event;
var G__6897__$1 = (((G__6897 instanceof cljs.core.Keyword))?G__6897.fqn:null);
switch (G__6897__$1) {
case "suggestion-activated":
return cljs.core.not.call(null,change_on_blur_QMARK___$1);

break;
default:
return false;

}
});
/**
 * Change the `typeahead` `model` value to `new-value`
 */
re_com.typeahead.update_model = (function re_com$typeahead$update_model(p__6899,new_value){
var map__6900 = p__6899;
var map__6900__$1 = ((((!((map__6900 == null)))?(((((map__6900.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6900.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6900):map__6900);
var state = map__6900__$1;
var on_change = cljs.core.get.call(null,map__6900__$1,new cljs.core.Keyword(null,"on-change","on-change",-732046149));
if(cljs.core.truth_(on_change)){
on_change.call(null,new_value);
} else {
}

return cljs.core.assoc.call(null,state,new cljs.core.Keyword(null,"model","model",331153215),new_value);
});
/**
 * Change the `input-text` `model` to the string representation of `suggestion`
 */
re_com.typeahead.display_suggestion = (function re_com$typeahead$display_suggestion(p__6902,suggestion){
var map__6903 = p__6902;
var map__6903__$1 = ((((!((map__6903 == null)))?(((((map__6903.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6903.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6903):map__6903);
var state = map__6903__$1;
var suggestion_to_string = cljs.core.get.call(null,map__6903__$1,new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962));
var suggestion_string = suggestion_to_string.call(null,suggestion);
var G__6905 = state;
if(cljs.core.truth_(suggestion_string)){
return cljs.core.assoc.call(null,G__6905,new cljs.core.Keyword(null,"input-text","input-text",-1336297114),suggestion_string,new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),true);
} else {
return G__6905;
}
});
re_com.typeahead.clear_suggestions = (function re_com$typeahead$clear_suggestions(state){
return cljs.core.dissoc.call(null,state,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618),new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
});
/**
 * Make the suggestion at `index` the active suggestion
 */
re_com.typeahead.activate_suggestion_by_index = (function re_com$typeahead$activate_suggestion_by_index(p__6906,index){
var map__6907 = p__6906;
var map__6907__$1 = ((((!((map__6907 == null)))?(((((map__6907.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6907.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6907):map__6907);
var state = map__6907__$1;
var suggestions = cljs.core.get.call(null,map__6907__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion = cljs.core.nth.call(null,suggestions,index);
var G__6909 = state;
var G__6909__$1 = cljs.core.assoc.call(null,G__6909,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728),index)
;
var G__6909__$2 = (cljs.core.truth_(re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"suggestion-activated","suggestion-activated",316961778)))?re_com.typeahead.update_model.call(null,G__6909__$1,suggestion):G__6909__$1);
if(cljs.core.truth_(re_com.typeahead.event_displays_suggestion_QMARK_.call(null,state,new cljs.core.Keyword(null,"suggestion-activated","suggestion-activated",316961778)))){
return re_com.typeahead.display_suggestion.call(null,G__6909__$2,suggestion);
} else {
return G__6909__$2;
}
});
/**
 * Choose the suggestion at `index`
 */
re_com.typeahead.choose_suggestion_by_index = (function re_com$typeahead$choose_suggestion_by_index(p__6910,index){
var map__6911 = p__6910;
var map__6911__$1 = ((((!((map__6911 == null)))?(((((map__6911.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6911.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6911):map__6911);
var state = map__6911__$1;
var suggestions = cljs.core.get.call(null,map__6911__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion = cljs.core.nth.call(null,suggestions,index);
return re_com.typeahead.clear_suggestions.call(null,re_com.typeahead.display_suggestion.call(null,re_com.typeahead.update_model.call(null,re_com.typeahead.activate_suggestion_by_index.call(null,state,index),suggestion),suggestion));
});
re_com.typeahead.choose_suggestion_active = (function re_com$typeahead$choose_suggestion_active(p__6913){
var map__6914 = p__6913;
var map__6914__$1 = ((((!((map__6914 == null)))?(((((map__6914.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6914.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6914):map__6914);
var state = map__6914__$1;
var suggestion_active_index = cljs.core.get.call(null,map__6914__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var G__6916 = state;
if(cljs.core.truth_(suggestion_active_index)){
return re_com.typeahead.choose_suggestion_by_index.call(null,G__6916,suggestion_active_index);
} else {
return G__6916;
}
});
re_com.typeahead.wrap = (function re_com$typeahead$wrap(index,count){
return cljs.core.mod.call(null,(count + index),count);
});
re_com.typeahead.activate_suggestion_next = (function re_com$typeahead$activate_suggestion_next(p__6917){
var map__6918 = p__6917;
var map__6918__$1 = ((((!((map__6918 == null)))?(((((map__6918.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6918.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6918):map__6918);
var state = map__6918__$1;
var suggestions = cljs.core.get.call(null,map__6918__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion_active_index = cljs.core.get.call(null,map__6918__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var G__6920 = state;
if(cljs.core.truth_(suggestions)){
return re_com.typeahead.activate_suggestion_by_index.call(null,G__6920,re_com.typeahead.wrap.call(null,((function (){var or__3922__auto__ = suggestion_active_index;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return (-1);
}
})() + (1)),cljs.core.count.call(null,suggestions)));
} else {
return G__6920;
}
});
re_com.typeahead.activate_suggestion_prev = (function re_com$typeahead$activate_suggestion_prev(p__6921){
var map__6922 = p__6921;
var map__6922__$1 = ((((!((map__6922 == null)))?(((((map__6922.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6922.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6922):map__6922);
var state = map__6922__$1;
var suggestions = cljs.core.get.call(null,map__6922__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var suggestion_active_index = cljs.core.get.call(null,map__6922__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var G__6924 = state;
if(cljs.core.truth_(suggestions)){
return re_com.typeahead.activate_suggestion_by_index.call(null,G__6924,re_com.typeahead.wrap.call(null,((function (){var or__3922__auto__ = suggestion_active_index;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return (0);
}
})() - (1)),cljs.core.count.call(null,suggestions)));
} else {
return G__6924;
}
});
re_com.typeahead.reset_typeahead = (function re_com$typeahead$reset_typeahead(state){
var G__6925 = state;
var G__6925__$1 = re_com.typeahead.clear_suggestions.call(null,G__6925)
;
var G__6925__$2 = cljs.core.assoc.call(null,G__6925__$1,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),false,new cljs.core.Keyword(null,"input-text","input-text",-1336297114),"",new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),false)
;
if(cljs.core.truth_(re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"input-text-changed","input-text-changed",-1906799535)))){
return re_com.typeahead.update_model.call(null,G__6925__$2,null);
} else {
return G__6925__$2;
}
});
/**
 * Update state when new suggestions are available
 */
re_com.typeahead.got_suggestions = (function re_com$typeahead$got_suggestions(state,suggestions){
return cljs.core.assoc.call(null,state,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618),suggestions,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),false,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728),null);
});
/**
 * Update state when the `input-text` is about to lose focus.
 */
re_com.typeahead.input_text_will_blur = (function re_com$typeahead$input_text_will_blur(p__6926){
var map__6927 = p__6926;
var map__6927__$1 = ((((!((map__6927 == null)))?(((((map__6927.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6927.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6927):map__6927);
var state = map__6927__$1;
var input_text = cljs.core.get.call(null,map__6927__$1,new cljs.core.Keyword(null,"input-text","input-text",-1336297114));
var displaying_suggestion_QMARK_ = cljs.core.get.call(null,map__6927__$1,new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862));
var G__6929 = state;
if(cljs.core.truth_((function (){var and__3911__auto__ = cljs.core.not.call(null,displaying_suggestion_QMARK_);
if(and__3911__auto__){
return re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"input-text-blurred","input-text-blurred",-501892307));
} else {
return and__3911__auto__;
}
})())){
return re_com.typeahead.update_model.call(null,G__6929,input_text);
} else {
return G__6929;
}
});
/**
 * Update `state` given a new `data-source`. Resets the typeahead since any existing suggestions
 *   came from the old `data-source`.
 */
re_com.typeahead.change_data_source = (function re_com$typeahead$change_data_source(state,data_source){
return cljs.core.assoc.call(null,re_com.typeahead.reset_typeahead.call(null,state),new cljs.core.Keyword(null,"data-source","data-source",-658934676),data_source);
});
/**
 * Update state when the external model value has changed.
 */
re_com.typeahead.external_model_changed = (function re_com$typeahead$external_model_changed(state,new_value){
return re_com.typeahead.clear_suggestions.call(null,re_com.typeahead.display_suggestion.call(null,re_com.typeahead.update_model.call(null,state,new_value),new_value));
});
/**
 * Call the `data-source` fn with `text`, and then call `got-suggestions` with the result
 *   (asynchronously, if `data-source` does not return a truthy value).
 */
re_com.typeahead.search_data_source_BANG_ = (function re_com$typeahead$search_data_source_BANG_(data_source,state_atom,text){
var temp__4655__auto__ = data_source.call(null,text,(function (p1__6930_SHARP_){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.got_suggestions,p1__6930_SHARP_);
}));
if(cljs.core.truth_(temp__4655__auto__)){
var return_value = temp__4655__auto__;
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.got_suggestions,return_value);
} else {
return cljs.core.swap_BANG_.call(null,state_atom,cljs.core.assoc,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215),true);
}
});
/**
 * For every value arriving on the `c-search` channel, call `search-data-source!`.
 */
re_com.typeahead.search_data_source_loop_BANG_ = (function re_com$typeahead$search_data_source_loop_BANG_(state_atom,c_search){
var c__4605__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto__){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto__){
return (function (state_6947){
var state_val_6948 = (state_6947[(1)]);
if((state_val_6948 === (1))){
var state_6947__$1 = state_6947;
var statearr_6949_6961 = state_6947__$1;
(statearr_6949_6961[(2)] = null);

(statearr_6949_6961[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6948 === (2))){
var state_6947__$1 = state_6947;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6947__$1,(4),c_search);
} else {
if((state_val_6948 === (3))){
var inst_6945 = (state_6947[(2)]);
var state_6947__$1 = state_6947;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6947__$1,inst_6945);
} else {
if((state_val_6948 === (4))){
var inst_6933 = (state_6947[(7)]);
var inst_6933__$1 = (state_6947[(2)]);
var inst_6934 = cljs.core.deref.call(null,state_atom);
var inst_6935 = new cljs.core.Keyword(null,"data-source","data-source",-658934676).cljs$core$IFn$_invoke$arity$1(inst_6934);
var inst_6936 = cljs.core._EQ_.call(null,"",inst_6933__$1);
var state_6947__$1 = (function (){var statearr_6950 = state_6947;
(statearr_6950[(8)] = inst_6935);

(statearr_6950[(7)] = inst_6933__$1);

return statearr_6950;
})();
if(inst_6936){
var statearr_6951_6962 = state_6947__$1;
(statearr_6951_6962[(1)] = (5));

} else {
var statearr_6952_6963 = state_6947__$1;
(statearr_6952_6963[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6948 === (5))){
var inst_6938 = cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.reset_typeahead);
var state_6947__$1 = state_6947;
var statearr_6953_6964 = state_6947__$1;
(statearr_6953_6964[(2)] = inst_6938);

(statearr_6953_6964[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6948 === (6))){
var inst_6935 = (state_6947[(8)]);
var inst_6933 = (state_6947[(7)]);
var inst_6940 = re_com.typeahead.search_data_source_BANG_.call(null,inst_6935,state_atom,inst_6933);
var state_6947__$1 = state_6947;
var statearr_6954_6965 = state_6947__$1;
(statearr_6954_6965[(2)] = inst_6940);

(statearr_6954_6965[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6948 === (7))){
var inst_6942 = (state_6947[(2)]);
var state_6947__$1 = (function (){var statearr_6955 = state_6947;
(statearr_6955[(9)] = inst_6942);

return statearr_6955;
})();
var statearr_6956_6966 = state_6947__$1;
(statearr_6956_6966[(2)] = null);

(statearr_6956_6966[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(c__4605__auto__))
;
return ((function (switch__4517__auto__,c__4605__auto__){
return (function() {
var re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto__ = null;
var re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto____0 = (function (){
var statearr_6957 = [null,null,null,null,null,null,null,null,null,null];
(statearr_6957[(0)] = re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto__);

(statearr_6957[(1)] = (1));

return statearr_6957;
});
var re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto____1 = (function (state_6947){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_6947);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6958){if((e6958 instanceof Object)){
var ex__4521__auto__ = e6958;
var statearr_6959_6967 = state_6947;
(statearr_6959_6967[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6947);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6958;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6968 = state_6947;
state_6947 = G__6968;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto__ = function(state_6947){
switch(arguments.length){
case 0:
return re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto____0.call(this);
case 1:
return re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto____1.call(this,state_6947);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto____0;
re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto____1;
return re_com$typeahead$search_data_source_loop_BANG__$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto__))
})();
var state__4607__auto__ = (function (){var statearr_6960 = f__4606__auto__.call(null);
(statearr_6960[(6)] = c__4605__auto__);

return statearr_6960;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto__))
);

return c__4605__auto__;
});
/**
 * Update state in response to `input-text` `on-change`, and put text on the `c-input` channel
 */
re_com.typeahead.input_text_on_change_BANG_ = (function re_com$typeahead$input_text_on_change_BANG_(state_atom,new_text){
var map__6970 = cljs.core.deref.call(null,state_atom);
var map__6970__$1 = ((((!((map__6970 == null)))?(((((map__6970.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6970.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6970):map__6970);
var state = map__6970__$1;
var input_text = cljs.core.get.call(null,map__6970__$1,new cljs.core.Keyword(null,"input-text","input-text",-1336297114));
var c_input = cljs.core.get.call(null,map__6970__$1,new cljs.core.Keyword(null,"c-input","c-input",-1821004232));
if(cljs.core._EQ_.call(null,new_text,input_text)){
return state;
} else {
if(clojure.string.blank_QMARK_.call(null,new_text)){
} else {
cljs.core.async.put_BANG_.call(null,c_input,new_text);
}

return cljs.core.swap_BANG_.call(null,state_atom,((function (map__6970,map__6970__$1,state,input_text,c_input){
return (function (p1__6969_SHARP_){
var G__6972 = p1__6969_SHARP_;
var G__6972__$1 = cljs.core.assoc.call(null,G__6972,new cljs.core.Keyword(null,"input-text","input-text",-1336297114),new_text,new cljs.core.Keyword(null,"displaying-suggestion?","displaying-suggestion?",1244493862),false)
;
if(cljs.core.truth_(re_com.typeahead.event_updates_model_QMARK_.call(null,state,new cljs.core.Keyword(null,"input-text-changed","input-text-changed",-1906799535)))){
return re_com.typeahead.update_model.call(null,G__6972__$1,new_text);
} else {
return G__6972__$1;
}
});})(map__6970,map__6970__$1,state,input_text,c_input))
);
}
});
re_com.typeahead.input_text_on_key_down_BANG_ = (function re_com$typeahead$input_text_on_key_down_BANG_(state_atom,event){
var pred__6973 = cljs.core._EQ_;
var expr__6974 = event.which;
if(cljs.core.truth_(pred__6973.call(null,goog.events.KeyCodes.UP,expr__6974))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_prev);
} else {
if(cljs.core.truth_(pred__6973.call(null,goog.events.KeyCodes.DOWN,expr__6974))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_next);
} else {
if(cljs.core.truth_(pred__6973.call(null,goog.events.KeyCodes.ENTER,expr__6974))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.choose_suggestion_active);
} else {
if(cljs.core.truth_(pred__6973.call(null,goog.events.KeyCodes.ESC,expr__6974))){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.reset_typeahead);
} else {
if(cljs.core.truth_(pred__6973.call(null,goog.events.KeyCodes.TAB,expr__6974))){
if(cljs.core.truth_(cljs.core.not_empty.call(null,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,state_atom))))){
cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_next);

return event.preventDefault();
} else {
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.input_text_will_blur);
}
} else {
return true;
}
}
}
}
}
});
re_com.typeahead.typeahead_args_desc = new cljs.core.PersistentVector(null, 18, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"data-source","data-source",-658934676),new cljs.core.Keyword(null,"required","required",1807647006),true,new cljs.core.Keyword(null,"type","type",1174270348),"fn",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null)," supplies suggestion objects. This can either accept a single string argument (the search term), or a string and a callback. For the first case, the fn should return a collection of suggestion objects (which can be anything). For the second case, the fn should return ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"nil"], null),", and eventually result in a call to the callback with a collection of suggestion objects."], null)], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"on-change","on-change",-732046149),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),null,new cljs.core.Keyword(null,"type","type",1174270348),"string -> nil",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":change-on-blur?"], null)," controls when it is called. It is passed a suggestion object."], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),true,new cljs.core.Keyword(null,"type","type",1174270348),"boolean | atom",new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 8, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"when true, invoke ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":on-change"], null)," when the user chooses a suggestion, otherwise invoke it on every change (navigating through suggestions with the mouse or keyboard, or if ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"rigid?"], null)," is also ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"false"], null),", invoke it on every character typed.)"], null)], null),cljs.core.PersistentArrayMap.createAsIfByAssoc([new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"model","model",331153215),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),null,new cljs.core.Keyword(null,"type","type",1174270348),"object | atom",new cljs.core.Keyword(null,"description","description",-1428560544),"The initial value of the typeahead (should match the suggestion objects returned by ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null),")."]),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"debounce-delay","debounce-delay",-608187982),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),(250),new cljs.core.Keyword(null,"type","type",1174270348),"integer",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.integer_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"After receiving input, the typeahead will wait this many milliseconds without receiving new input before calling ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null),"."], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"render-suggestion","render-suggestion",1472406503),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"render fn",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"override the rendering of the suggestion items by passing a fn that returns hiccup forms. The fn will receive two arguments: the search term, and the suggestion object."], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"suggestion-to-string","suggestion-to-string",1991188962),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"suggestion -> string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.fn_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"When a suggestion is chosen, the input-text value will be set to the result of calling this fn with the suggestion object."], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"rigid?","rigid?",-1498832118),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),true,new cljs.core.Keyword(null,"type","type",1174270348),"boolean | atom",new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"If ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"false"], null)," the user will be allowed to choose arbitrary text input rather than a suggestion from ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":data-source"], null),". In this case, a string will be supplied in lieu of a suggestion object."], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"keyword",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.input_status_type_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"validation status. ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),"nil/omitted"], null)," for normal status or one of: ",re_com.validate.input_status_types_list], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"status-icon?","status-icon?",1328423612),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),false,new cljs.core.Keyword(null,"type","type",1174270348),"boolean",new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"when true, display an icon to match ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":status"], null)," (no icon for nil)"], null)], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"status-tooltip","status-tooltip",1912159007),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"displayed in status icon's tooltip"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"placeholder","placeholder",-104873083),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"background text shown when empty"], null),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"width","width",-384071477),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),"250px",new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"standard CSS width setting for this input"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"height","height",1025178622),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"standard CSS height setting for this input"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"disabled?","disabled?",-1523234181),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"default","default",-1987822328),false,new cljs.core.Keyword(null,"type","type",1174270348),"boolean | atom",new cljs.core.Keyword(null,"description","description",-1428560544),"if true, the user can't interact (input anything)"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"class","class",-2030961996),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"string",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),cljs.core.string_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS class names, space separated"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"CSS style map",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.css_style_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),"CSS styles to add or override"], null),new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"name","name",1843675177),new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.Keyword(null,"required","required",1807647006),false,new cljs.core.Keyword(null,"type","type",1174270348),"HTML attr map",new cljs.core.Keyword(null,"validate-fn","validate-fn",1430169944),re_com.validate.html_attr_QMARK_,new cljs.core.Keyword(null,"description","description",-1428560544),new cljs.core.PersistentVector(null, 9, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"span","span",1394872991),"HTML attributes, like ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":on-mouse-move"], null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"br","br",934104792)], null),"No ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":class"], null)," or ",new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"code","code",1586293142),":style"], null),"allowed"], null)], null)], null);
/**
 * typeahead reagent component
 */
re_com.typeahead.typeahead = (function re_com$typeahead$typeahead(var_args){
var args__4502__auto__ = [];
var len__4499__auto___6998 = arguments.length;
var i__4500__auto___6999 = (0);
while(true){
if((i__4500__auto___6999 < len__4499__auto___6998)){
args__4502__auto__.push((arguments[i__4500__auto___6999]));

var G__7000 = (i__4500__auto___6999 + (1));
i__4500__auto___6999 = G__7000;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((0) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((0)),(0),null)):null);
return re_com.typeahead.typeahead.cljs$core$IFn$_invoke$arity$variadic(argseq__4503__auto__);
});

re_com.typeahead.typeahead.cljs$core$IFn$_invoke$arity$variadic = (function (p__6978){
var map__6979 = p__6978;
var map__6979__$1 = ((((!((map__6979 == null)))?(((((map__6979.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6979.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6979):map__6979);
var args = map__6979__$1;
if(cljs.core.truth_(((!(goog.DEBUG))?true:re_com.validate.validate_args.call(null,re_com.validate.extract_arg_data.call(null,re_com.typeahead.typeahead_args_desc),args,"typeahead")))){
} else {
throw (new Error("Assert failed: (validate-args-macro typeahead-args-desc args \"typeahead\")"));
}

var map__6981 = re_com.typeahead.make_typeahead_state.call(null,args);
var map__6981__$1 = ((((!((map__6981 == null)))?(((((map__6981.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6981.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6981):map__6981);
var state = map__6981__$1;
var c_search = cljs.core.get.call(null,map__6981__$1,new cljs.core.Keyword(null,"c-search","c-search",1832536180));
var c_input = cljs.core.get.call(null,map__6981__$1,new cljs.core.Keyword(null,"c-input","c-input",-1821004232));
var state_atom = reagent.core.atom.call(null,state);
var input_text_model = reagent.core.cursor.call(null,state_atom,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"input-text","input-text",-1336297114)], null));
re_com.typeahead.search_data_source_loop_BANG_.call(null,state_atom,c_search);

return ((function (map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args){
return (function() { 
var G__7001__delegate = function (p__6983){
var map__6984 = p__6983;
var map__6984__$1 = ((((!((map__6984 == null)))?(((((map__6984.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6984.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6984):map__6984);
var args__$1 = map__6984__$1;
var disabled_QMARK_ = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"disabled?","disabled?",-1523234181));
var status_icon_QMARK_ = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"status-icon?","status-icon?",1328423612));
var height = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"height","height",1025178622));
var status_tooltip = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"status-tooltip","status-tooltip",1912159007));
var model = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"model","model",331153215));
var _debounce_delay = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"_debounce-delay","_debounce-delay",-1476744225));
var _on_change = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"_on-change","_on-change",156649312));
var placeholder = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"placeholder","placeholder",-104873083));
var render_suggestion = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"render-suggestion","render-suggestion",1472406503));
var _suggestion_to_string = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"_suggestion-to-string","_suggestion-to-string",795407399));
var width = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"width","width",-384071477));
var data_source = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"data-source","data-source",-658934676));
var _rigid_QMARK_ = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"_rigid?","_rigid?",1424449294));
var style = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"style","style",-496642736));
var _change_on_blur_QMARK_ = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"_change-on-blur?","_change-on-blur?",1219941073));
var status = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"status","status",-1997798413));
var class$ = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"class","class",-2030961996));
var _attr = cljs.core.get.call(null,map__6984__$1,new cljs.core.Keyword(null,"_attr","_attr",299438964));
if(cljs.core.truth_(((!(goog.DEBUG))?true:re_com.validate.validate_args.call(null,re_com.validate.extract_arg_data.call(null,re_com.typeahead.typeahead_args_desc),args__$1,"typeahead")))){
} else {
throw (new Error("Assert failed: (validate-args-macro typeahead-args-desc args \"typeahead\")"));
}

var map__6986 = cljs.core.deref.call(null,state_atom);
var map__6986__$1 = ((((!((map__6986 == null)))?(((((map__6986.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__6986.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__6986):map__6986);
var state__$1 = map__6986__$1;
var suggestions = cljs.core.get.call(null,map__6986__$1,new cljs.core.Keyword(null,"suggestions","suggestions",-859472618));
var waiting_QMARK_ = cljs.core.get.call(null,map__6986__$1,new cljs.core.Keyword(null,"waiting?","waiting?",-2117257215));
var suggestion_active_index = cljs.core.get.call(null,map__6986__$1,new cljs.core.Keyword(null,"suggestion-active-index","suggestion-active-index",-1593564728));
var external_model = cljs.core.get.call(null,map__6986__$1,new cljs.core.Keyword(null,"external-model","external-model",506095421));
var last_data_source = new cljs.core.Keyword(null,"data-source","data-source",-658934676).cljs$core$IFn$_invoke$arity$1(state__$1);
var latest_external_model = re_com.util.deref_or_value.call(null,model);
var width__$1 = (function (){var or__3922__auto__ = width;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return "250px";
}
})();
if(cljs.core.not_EQ_.call(null,last_data_source,data_source)){
cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.change_data_source,data_source);
} else {
}

if(cljs.core.not_EQ_.call(null,latest_external_model,external_model)){
cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.external_model_changed,latest_external_model);
} else {
}

return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.v_box,new cljs.core.Keyword(null,"width","width",-384071477),width__$1,new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentVector(null, 27, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.misc.input_text,new cljs.core.Keyword(null,"model","model",331153215),input_text_model,new cljs.core.Keyword(null,"class","class",-2030961996),class$,new cljs.core.Keyword(null,"style","style",-496642736),style,new cljs.core.Keyword(null,"disabled?","disabled?",-1523234181),disabled_QMARK_,new cljs.core.Keyword(null,"status-icon?","status-icon?",1328423612),status_icon_QMARK_,new cljs.core.Keyword(null,"status","status",-1997798413),status,new cljs.core.Keyword(null,"status-tooltip","status-tooltip",1912159007),status_tooltip,new cljs.core.Keyword(null,"width","width",-384071477),width__$1,new cljs.core.Keyword(null,"height","height",1025178622),height,new cljs.core.Keyword(null,"placeholder","placeholder",-104873083),placeholder,new cljs.core.Keyword(null,"on-change","on-change",-732046149),cljs.core.partial.call(null,re_com.typeahead.input_text_on_change_BANG_,state_atom),new cljs.core.Keyword(null,"change-on-blur?","change-on-blur?",854283925),false,new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"on-key-down","on-key-down",-1374733765),cljs.core.partial.call(null,re_com.typeahead.input_text_on_key_down_BANG_,state_atom)], null)], null),(cljs.core.truth_((function (){var or__3922__auto__ = cljs.core.not_empty.call(null,suggestions);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return waiting_QMARK_;
}
})())?new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.box,new cljs.core.Keyword(null,"style","style",-496642736),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"position","position",-2011731912),"relative"], null),new cljs.core.Keyword(null,"child","child",623967545),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.v_box,new cljs.core.Keyword(null,"class","class",-2030961996),"rc-typeahead-suggestions-container",new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [(cljs.core.truth_(waiting_QMARK_)?new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.box,new cljs.core.Keyword(null,"align","align",1964212802),new cljs.core.Keyword(null,"center","center",-748944368),new cljs.core.Keyword(null,"child","child",623967545),new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.misc.throbber,new cljs.core.Keyword(null,"size","size",1098693007),new cljs.core.Keyword(null,"small","small",2133478704),new cljs.core.Keyword(null,"class","class",-2030961996),"rc-typeahead-throbber"], null)], null):null),(function (){var iter__4292__auto__ = ((function (map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args){
return (function re_com$typeahead$iter__6988(s__6989){
return (new cljs.core.LazySeq(null,((function (map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args){
return (function (){
var s__6989__$1 = s__6989;
while(true){
var temp__4657__auto__ = cljs.core.seq.call(null,s__6989__$1);
if(temp__4657__auto__){
var s__6989__$2 = temp__4657__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__6989__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__6989__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__6991 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__6990 = (0);
while(true){
if((i__6990 < size__4291__auto__)){
var vec__6992 = cljs.core._nth.call(null,c__4290__auto__,i__6990);
var i = cljs.core.nth.call(null,vec__6992,(0),null);
var s = cljs.core.nth.call(null,vec__6992,(1),null);
var selected_QMARK_ = cljs.core._EQ_.call(null,suggestion_active_index,i);
cljs.core.chunk_append.call(null,b__6991,cljs.core.with_meta(new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.box,new cljs.core.Keyword(null,"child","child",623967545),(cljs.core.truth_(render_suggestion)?render_suggestion.call(null,s):s),new cljs.core.Keyword(null,"class","class",-2030961996),["rc-typeahead-suggestion",cljs.core.str.cljs$core$IFn$_invoke$arity$1(((selected_QMARK_)?" active":null))].join(''),new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"on-mouse-over","on-mouse-over",-858472552),((function (i__6990,selected_QMARK_,vec__6992,i,s,c__4290__auto__,size__4291__auto__,b__6991,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args){
return (function (){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_by_index,i);
});})(i__6990,selected_QMARK_,vec__6992,i,s,c__4290__auto__,size__4291__auto__,b__6991,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args))
,new cljs.core.Keyword(null,"on-mouse-down","on-mouse-down",1147755470),((function (i__6990,selected_QMARK_,vec__6992,i,s,c__4290__auto__,size__4291__auto__,b__6991,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args){
return (function (p1__6976_SHARP_){
p1__6976_SHARP_.preventDefault();

return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.choose_suggestion_by_index,i);
});})(i__6990,selected_QMARK_,vec__6992,i,s,c__4290__auto__,size__4291__auto__,b__6991,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args))
], null)], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"key","key",-1516042587),i], null)));

var G__7002 = (i__6990 + (1));
i__6990 = G__7002;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__6991),re_com$typeahead$iter__6988.call(null,cljs.core.chunk_rest.call(null,s__6989__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__6991),null);
}
} else {
var vec__6995 = cljs.core.first.call(null,s__6989__$2);
var i = cljs.core.nth.call(null,vec__6995,(0),null);
var s = cljs.core.nth.call(null,vec__6995,(1),null);
var selected_QMARK_ = cljs.core._EQ_.call(null,suggestion_active_index,i);
return cljs.core.cons.call(null,cljs.core.with_meta(new cljs.core.PersistentVector(null, 7, 5, cljs.core.PersistentVector.EMPTY_NODE, [re_com.box.box,new cljs.core.Keyword(null,"child","child",623967545),(cljs.core.truth_(render_suggestion)?render_suggestion.call(null,s):s),new cljs.core.Keyword(null,"class","class",-2030961996),["rc-typeahead-suggestion",cljs.core.str.cljs$core$IFn$_invoke$arity$1(((selected_QMARK_)?" active":null))].join(''),new cljs.core.Keyword(null,"attr","attr",-604132353),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"on-mouse-over","on-mouse-over",-858472552),((function (selected_QMARK_,vec__6995,i,s,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args){
return (function (){
return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.activate_suggestion_by_index,i);
});})(selected_QMARK_,vec__6995,i,s,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args))
,new cljs.core.Keyword(null,"on-mouse-down","on-mouse-down",1147755470),((function (selected_QMARK_,vec__6995,i,s,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args){
return (function (p1__6976_SHARP_){
p1__6976_SHARP_.preventDefault();

return cljs.core.swap_BANG_.call(null,state_atom,re_com.typeahead.choose_suggestion_by_index,i);
});})(selected_QMARK_,vec__6995,i,s,s__6989__$2,temp__4657__auto__,map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args))
], null)], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"key","key",-1516042587),i], null)),re_com$typeahead$iter__6988.call(null,cljs.core.rest.call(null,s__6989__$2)));
}
} else {
return null;
}
break;
}
});})(map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args))
,null,null));
});})(map__6986,map__6986__$1,state__$1,suggestions,waiting_QMARK_,suggestion_active_index,external_model,last_data_source,latest_external_model,width__$1,map__6984,map__6984__$1,args__$1,disabled_QMARK_,status_icon_QMARK_,height,status_tooltip,model,_debounce_delay,_on_change,placeholder,render_suggestion,_suggestion_to_string,width,data_source,_rigid_QMARK_,style,_change_on_blur_QMARK_,status,class$,_attr,map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args))
;
return iter__4292__auto__.call(null,cljs.core.map.call(null,cljs.core.vector,cljs.core.range.call(null),suggestions));
})()], null)], null)], null):null)], null)], null);
};
var G__7001 = function (var_args){
var p__6983 = null;
if (arguments.length > 0) {
var G__7003__i = 0, G__7003__a = new Array(arguments.length -  0);
while (G__7003__i < G__7003__a.length) {G__7003__a[G__7003__i] = arguments[G__7003__i + 0]; ++G__7003__i;}
  p__6983 = new cljs.core.IndexedSeq(G__7003__a,0,null);
} 
return G__7001__delegate.call(this,p__6983);};
G__7001.cljs$lang$maxFixedArity = 0;
G__7001.cljs$lang$applyTo = (function (arglist__7004){
var p__6983 = cljs.core.seq(arglist__7004);
return G__7001__delegate(p__6983);
});
G__7001.cljs$core$IFn$_invoke$arity$variadic = G__7001__delegate;
return G__7001;
})()
;
;})(map__6981,map__6981__$1,state,c_search,c_input,state_atom,input_text_model,map__6979,map__6979__$1,args))
});

re_com.typeahead.typeahead.cljs$lang$maxFixedArity = (0);

/** @this {Function} */
re_com.typeahead.typeahead.cljs$lang$applyTo = (function (seq6977){
var self__4487__auto__ = this;
return self__4487__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq6977));
});

/**
 * Return a channel which will receive a value from the `in` channel only
 *   if no further value is received on the `in` channel in the next `ms` milliseconds.
 */
re_com.typeahead.debounce = (function re_com$typeahead$debounce(in$,ms){
var out = cljs.core.async.chan.call(null);
var c__4605__auto___7085 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___7085,out){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___7085,out){
return (function (state_7055){
var state_val_7056 = (state_7055[(1)]);
if((state_val_7056 === (7))){
var inst_7010 = (state_7055[(2)]);
var state_7055__$1 = state_7055;
var statearr_7057_7086 = state_7055__$1;
(statearr_7057_7086[(2)] = inst_7010);

(statearr_7057_7086[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (1))){
var inst_7005 = null;
var state_7055__$1 = (function (){var statearr_7058 = state_7055;
(statearr_7058[(7)] = inst_7005);

return statearr_7058;
})();
var statearr_7059_7087 = state_7055__$1;
(statearr_7059_7087[(2)] = null);

(statearr_7059_7087[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (4))){
var state_7055__$1 = state_7055;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_7055__$1,(7),in$);
} else {
if((state_val_7056 === (15))){
var inst_7040 = (state_7055[(2)]);
var state_7055__$1 = (function (){var statearr_7060 = state_7055;
(statearr_7060[(8)] = inst_7040);

return statearr_7060;
})();
var statearr_7061_7088 = state_7055__$1;
(statearr_7061_7088[(2)] = null);

(statearr_7061_7088[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (13))){
var inst_7028 = (state_7055[(9)]);
var inst_7042 = cljs.core._EQ_.call(null,inst_7028,new cljs.core.Keyword(null,"default","default",-1987822328));
var state_7055__$1 = state_7055;
if(inst_7042){
var statearr_7062_7089 = state_7055__$1;
(statearr_7062_7089[(1)] = (16));

} else {
var statearr_7063_7090 = state_7055__$1;
(statearr_7063_7090[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (6))){
var inst_7014 = (state_7055[(10)]);
var inst_7013 = (state_7055[(2)]);
var inst_7014__$1 = cljs.core.async.timeout.call(null,ms);
var inst_7022 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_7023 = [in$,inst_7014__$1];
var inst_7024 = (new cljs.core.PersistentVector(null,2,(5),inst_7022,inst_7023,null));
var state_7055__$1 = (function (){var statearr_7064 = state_7055;
(statearr_7064[(10)] = inst_7014__$1);

(statearr_7064[(11)] = inst_7013);

return statearr_7064;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_7055__$1,(8),inst_7024);
} else {
if((state_val_7056 === (17))){
var state_7055__$1 = state_7055;
var statearr_7065_7091 = state_7055__$1;
(statearr_7065_7091[(2)] = null);

(statearr_7065_7091[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (3))){
var inst_7053 = (state_7055[(2)]);
var state_7055__$1 = state_7055;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_7055__$1,inst_7053);
} else {
if((state_val_7056 === (12))){
var inst_7013 = (state_7055[(11)]);
var state_7055__$1 = state_7055;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_7055__$1,(15),out,inst_7013);
} else {
if((state_val_7056 === (2))){
var inst_7005 = (state_7055[(7)]);
var inst_7007 = (inst_7005 == null);
var state_7055__$1 = state_7055;
if(cljs.core.truth_(inst_7007)){
var statearr_7066_7092 = state_7055__$1;
(statearr_7066_7092[(1)] = (4));

} else {
var statearr_7067_7093 = state_7055__$1;
(statearr_7067_7093[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (11))){
var inst_7050 = (state_7055[(2)]);
var inst_7005 = inst_7050;
var state_7055__$1 = (function (){var statearr_7068 = state_7055;
(statearr_7068[(7)] = inst_7005);

return statearr_7068;
})();
var statearr_7069_7094 = state_7055__$1;
(statearr_7069_7094[(2)] = null);

(statearr_7069_7094[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (9))){
var inst_7026 = (state_7055[(12)]);
var inst_7034 = cljs.core.nth.call(null,inst_7026,(0),null);
var inst_7035 = cljs.core.nth.call(null,inst_7026,(1),null);
var state_7055__$1 = (function (){var statearr_7070 = state_7055;
(statearr_7070[(13)] = inst_7035);

return statearr_7070;
})();
var statearr_7071_7095 = state_7055__$1;
(statearr_7071_7095[(2)] = inst_7034);

(statearr_7071_7095[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (5))){
var inst_7005 = (state_7055[(7)]);
var state_7055__$1 = state_7055;
var statearr_7072_7096 = state_7055__$1;
(statearr_7072_7096[(2)] = inst_7005);

(statearr_7072_7096[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (14))){
var inst_7048 = (state_7055[(2)]);
var state_7055__$1 = state_7055;
var statearr_7073_7097 = state_7055__$1;
(statearr_7073_7097[(2)] = inst_7048);

(statearr_7073_7097[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (16))){
var inst_7027 = (state_7055[(14)]);
var state_7055__$1 = state_7055;
var statearr_7074_7098 = state_7055__$1;
(statearr_7074_7098[(2)] = inst_7027);

(statearr_7074_7098[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (10))){
var inst_7014 = (state_7055[(10)]);
var inst_7028 = (state_7055[(9)]);
var inst_7037 = cljs.core._EQ_.call(null,inst_7028,inst_7014);
var state_7055__$1 = state_7055;
if(inst_7037){
var statearr_7075_7099 = state_7055__$1;
(statearr_7075_7099[(1)] = (12));

} else {
var statearr_7076_7100 = state_7055__$1;
(statearr_7076_7100[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (18))){
var inst_7046 = (state_7055[(2)]);
var state_7055__$1 = state_7055;
var statearr_7077_7101 = state_7055__$1;
(statearr_7077_7101[(2)] = inst_7046);

(statearr_7077_7101[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_7056 === (8))){
var inst_7028 = (state_7055[(9)]);
var inst_7026 = (state_7055[(12)]);
var inst_7026__$1 = (state_7055[(2)]);
var inst_7027 = cljs.core.nth.call(null,inst_7026__$1,(0),null);
var inst_7028__$1 = cljs.core.nth.call(null,inst_7026__$1,(1),null);
var inst_7029 = cljs.core._EQ_.call(null,inst_7028__$1,in$);
var state_7055__$1 = (function (){var statearr_7078 = state_7055;
(statearr_7078[(14)] = inst_7027);

(statearr_7078[(9)] = inst_7028__$1);

(statearr_7078[(12)] = inst_7026__$1);

return statearr_7078;
})();
if(inst_7029){
var statearr_7079_7102 = state_7055__$1;
(statearr_7079_7102[(1)] = (9));

} else {
var statearr_7080_7103 = state_7055__$1;
(statearr_7080_7103[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___7085,out))
;
return ((function (switch__4517__auto__,c__4605__auto___7085,out){
return (function() {
var re_com$typeahead$debounce_$_state_machine__4518__auto__ = null;
var re_com$typeahead$debounce_$_state_machine__4518__auto____0 = (function (){
var statearr_7081 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_7081[(0)] = re_com$typeahead$debounce_$_state_machine__4518__auto__);

(statearr_7081[(1)] = (1));

return statearr_7081;
});
var re_com$typeahead$debounce_$_state_machine__4518__auto____1 = (function (state_7055){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_7055);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e7082){if((e7082 instanceof Object)){
var ex__4521__auto__ = e7082;
var statearr_7083_7104 = state_7055;
(statearr_7083_7104[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_7055);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e7082;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__7105 = state_7055;
state_7055 = G__7105;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
re_com$typeahead$debounce_$_state_machine__4518__auto__ = function(state_7055){
switch(arguments.length){
case 0:
return re_com$typeahead$debounce_$_state_machine__4518__auto____0.call(this);
case 1:
return re_com$typeahead$debounce_$_state_machine__4518__auto____1.call(this,state_7055);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
re_com$typeahead$debounce_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = re_com$typeahead$debounce_$_state_machine__4518__auto____0;
re_com$typeahead$debounce_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = re_com$typeahead$debounce_$_state_machine__4518__auto____1;
return re_com$typeahead$debounce_$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___7085,out))
})();
var state__4607__auto__ = (function (){var statearr_7084 = f__4606__auto__.call(null);
(statearr_7084[(6)] = c__4605__auto___7085);

return statearr_7084;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___7085,out))
);


return out;
});

//# sourceMappingURL=typeahead.js.map
