// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('javascript_externs_generator.cli');
goog.require('cljs.core');
goog.require('cljs.nodejs');
goog.require('javascript_externs_generator.extern');
goog.require('clojure.string');
goog.require('goog.object');
cljs.nodejs.enable_util_print_BANG_.call(null);
javascript_externs_generator.cli.fs = cljs.nodejs.require.call(null,"fs");
javascript_externs_generator.cli.jsdom = cljs.nodejs.require.call(null,"jsdom");
javascript_externs_generator.cli.js_beautify = cljs.nodejs.require.call(null,"js-beautify");
javascript_externs_generator.cli.beautify_options = ({"indent_size": (2), "indent_char": " ", "preserve_newlines": true, "space_after_anon_function": true, "jslint_happy": false});
javascript_externs_generator.cli.load_js_file = (function javascript_externs_generator$cli$load_js_file(window,filename){
var js_code = goog.object.get(javascript_externs_generator.cli.fs,"readFileSync").call(null,filename);
var script_el = goog.object.get(window,"document").createElement("script");
goog.object.set(script_el,"innerHTML",js_code);

goog.object.set(script_el,"type","text/javascript");

goog.object.set(script_el,"charset","UTF-8");

return goog.object.getValueByKeys(window,"document","head").appendChild(script_el);
});
javascript_externs_generator.cli.file_args = (function javascript_externs_generator$cli$file_args(files){
return clojure.string.split.call(null,files,/,/);
});
javascript_externs_generator.cli._main = (function javascript_externs_generator$cli$_main(){
var args = cljs.nodejs.require.call(null,"commander").option("-f, --files <files>","Comma-separated list of JS files to load",javascript_externs_generator.cli.file_args).option("-n, --namespace <namespace>","Namespace to extern").option("-o, --outfile <outfile>","Output File for extern").parse(goog.object.get(cljs.nodejs.process,"argv"));
var files = goog.object.get(args,"files");
var namespace = goog.object.get(args,"namespace");
var outfile = goog.object.get(args,"outfile");
var dom_obj = goog.object.get(javascript_externs_generator.cli.jsdom,"jsdom").call(null);
var window = goog.object.get(dom_obj,"defaultView");
if((files == null)){
console.error("Please specify one or more JavaScript files to load (e.g. -f jquery.js)");

goog.object.get(cljs.nodejs.process,"exit").call(null,(1));
} else {
}

if((namespace == null)){
console.error("Please specify namespace to extern (e.g. -n jQuery)");

goog.object.get(cljs.nodejs.process,"exit").call(null,(1));
} else {
}

if((outfile == null)){
console.error("Please specify an output file for the extern (e.g. -o jquery-extern.js)");

goog.object.get(cljs.nodejs.process,"exit").call(null,(1));
} else {
}

var seq__4787_4791 = cljs.core.seq.call(null,files);
var chunk__4788_4792 = null;
var count__4789_4793 = (0);
var i__4790_4794 = (0);
while(true){
if((i__4790_4794 < count__4789_4793)){
var file_name_4795 = cljs.core._nth.call(null,chunk__4788_4792,i__4790_4794);
javascript_externs_generator.cli.load_js_file.call(null,window,file_name_4795);


var G__4796 = seq__4787_4791;
var G__4797 = chunk__4788_4792;
var G__4798 = count__4789_4793;
var G__4799 = (i__4790_4794 + (1));
seq__4787_4791 = G__4796;
chunk__4788_4792 = G__4797;
count__4789_4793 = G__4798;
i__4790_4794 = G__4799;
continue;
} else {
var temp__5457__auto___4800 = cljs.core.seq.call(null,seq__4787_4791);
if(temp__5457__auto___4800){
var seq__4787_4801__$1 = temp__5457__auto___4800;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__4787_4801__$1)){
var c__4319__auto___4802 = cljs.core.chunk_first.call(null,seq__4787_4801__$1);
var G__4803 = cljs.core.chunk_rest.call(null,seq__4787_4801__$1);
var G__4804 = c__4319__auto___4802;
var G__4805 = cljs.core.count.call(null,c__4319__auto___4802);
var G__4806 = (0);
seq__4787_4791 = G__4803;
chunk__4788_4792 = G__4804;
count__4789_4793 = G__4805;
i__4790_4794 = G__4806;
continue;
} else {
var file_name_4807 = cljs.core.first.call(null,seq__4787_4801__$1);
javascript_externs_generator.cli.load_js_file.call(null,window,file_name_4807);


var G__4808 = cljs.core.next.call(null,seq__4787_4801__$1);
var G__4809 = null;
var G__4810 = (0);
var G__4811 = (0);
seq__4787_4791 = G__4808;
chunk__4788_4792 = G__4809;
count__4789_4793 = G__4810;
i__4790_4794 = G__4811;
continue;
}
} else {
}
}
break;
}

var js_object = goog.object.get(window,namespace);
if((js_object == null)){
throw ["Namespace '",cljs.core.str.cljs$core$IFn$_invoke$arity$1(namespace),"' was not found. Make sure the library is loaded and the name is spelled correctly."].join('');
} else {
}

var extern_string = javascript_externs_generator.extern.wrap_extern.call(null,namespace,javascript_externs_generator.extern.extract.call(null,namespace,js_object));
var beautified = goog.object.get(javascript_externs_generator.cli.js_beautify,"js_beautify").call(null,extern_string,javascript_externs_generator.cli.beautify_options);
return goog.object.get(javascript_externs_generator.cli.fs,"writeFileSync").call(null,outfile,beautified);
});
cljs.core._STAR_main_cli_fn_STAR_ = javascript_externs_generator.cli._main;
