// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('javascript_externs_generator.extern');
goog.require('cljs.core');
goog.require('goog.dom');
goog.require('goog.object');
goog.require('clojure.string');
/**
 * Differentiate between function property and object property
 */
javascript_externs_generator.extern.prop_type = (function javascript_externs_generator$extern$prop_type(obj){
if(cljs.core.fn_QMARK_.call(null,obj)){
return new cljs.core.Keyword(null,"function","function",-2127255473);
} else {
return new cljs.core.Keyword(null,"object","object",1474613949);
}
});
/**
 * Is it possible for this object to have child properties?
 */
javascript_externs_generator.extern.parent_type_QMARK_ = (function javascript_externs_generator$extern$parent_type_QMARK_(obj){
return ((cljs.core._EQ_.call(null,goog.typeOf(obj),"object")) || (cljs.core.fn_QMARK_.call(null,obj)));
});
/**
 * Build a recursive tree representation of the JavaScript object
 *   and metadata about its properties, prototype, and functions
 */
javascript_externs_generator.extern.generate_object_tree = (function javascript_externs_generator$extern$generate_object_tree(var_args){
var G__4754 = arguments.length;
switch (G__4754) {
case 2:
return javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$2 = (function (obj,name){
return javascript_externs_generator.extern.generate_object_tree.call(null,obj,name,cljs.core.PersistentHashSet.EMPTY);
});

javascript_externs_generator.extern.generate_object_tree.cljs$core$IFn$_invoke$arity$3 = (function (obj,name,seen){
return new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"name","name",1843675177),name,new cljs.core.Keyword(null,"type","type",1174270348),javascript_externs_generator.extern.prop_type.call(null,obj),new cljs.core.Keyword(null,"props","props",453281727),(function (){var iter__4292__auto__ = (function javascript_externs_generator$extern$iter__4755(s__4756){
return (new cljs.core.LazySeq(null,(function (){
var s__4756__$1 = s__4756;
while(true){
var temp__5457__auto__ = cljs.core.seq.call(null,s__4756__$1);
if(temp__5457__auto__){
var s__4756__$2 = temp__5457__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__4756__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__4756__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__4758 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__4757 = (0);
while(true){
if((i__4757 < size__4291__auto__)){
var prop_name = cljs.core._nth.call(null,c__4290__auto__,i__4757);
var child = goog.object.get(obj,prop_name);
cljs.core.chunk_append.call(null,b__4758,(cljs.core.truth_((function (){var and__3911__auto__ = javascript_externs_generator.extern.parent_type_QMARK_.call(null,child);
if(cljs.core.truth_(and__3911__auto__)){
return ((!(cljs.core.contains_QMARK_.call(null,seen,child))) && (cljs.core.not.call(null,child.nodeType)));
} else {
return and__3911__auto__;
}
})())?javascript_externs_generator.extern.generate_object_tree.call(null,child,prop_name,cljs.core.conj.call(null,seen,child)):new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),javascript_externs_generator.extern.prop_type.call(null,child)], null)));

var G__4764 = (i__4757 + (1));
i__4757 = G__4764;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4758),javascript_externs_generator$extern$iter__4755.call(null,cljs.core.chunk_rest.call(null,s__4756__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4758),null);
}
} else {
var prop_name = cljs.core.first.call(null,s__4756__$2);
var child = goog.object.get(obj,prop_name);
return cljs.core.cons.call(null,(cljs.core.truth_((function (){var and__3911__auto__ = javascript_externs_generator.extern.parent_type_QMARK_.call(null,child);
if(cljs.core.truth_(and__3911__auto__)){
return ((!(cljs.core.contains_QMARK_.call(null,seen,child))) && (cljs.core.not.call(null,child.nodeType)));
} else {
return and__3911__auto__;
}
})())?javascript_externs_generator.extern.generate_object_tree.call(null,child,prop_name,cljs.core.conj.call(null,seen,child)):new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),javascript_externs_generator.extern.prop_type.call(null,child)], null)),javascript_externs_generator$extern$iter__4755.call(null,cljs.core.rest.call(null,s__4756__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,cljs.core.sort.call(null,goog.object.getKeys(obj)));
})(),new cljs.core.Keyword(null,"prototype","prototype",-1121365005),(function (){var iter__4292__auto__ = (function javascript_externs_generator$extern$iter__4759(s__4760){
return (new cljs.core.LazySeq(null,(function (){
var s__4760__$1 = s__4760;
while(true){
var temp__5457__auto__ = cljs.core.seq.call(null,s__4760__$1);
if(temp__5457__auto__){
var s__4760__$2 = temp__5457__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__4760__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__4760__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__4762 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__4761 = (0);
while(true){
if((i__4761 < size__4291__auto__)){
var prop_name = cljs.core._nth.call(null,c__4290__auto__,i__4761);
cljs.core.chunk_append.call(null,b__4762,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"function","function",-2127255473)], null));

var G__4765 = (i__4761 + (1));
i__4761 = G__4765;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4762),javascript_externs_generator$extern$iter__4759.call(null,cljs.core.chunk_rest.call(null,s__4760__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4762),null);
}
} else {
var prop_name = cljs.core.first.call(null,s__4760__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"name","name",1843675177),prop_name,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"function","function",-2127255473)], null),javascript_externs_generator$extern$iter__4759.call(null,cljs.core.rest.call(null,s__4760__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,cljs.core.sort.call(null,goog.object.getKeys(obj.prototype)));
})()], null);
});

javascript_externs_generator.extern.generate_object_tree.cljs$lang$maxFixedArity = 3;

/**
 * Return recursive string representation of an object's properties
 */
javascript_externs_generator.extern.emit_props_extern = (function javascript_externs_generator$extern$emit_props_extern(obj){
var map__4766 = obj;
var map__4766__$1 = ((((!((map__4766 == null)))?(((((map__4766.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4766.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4766):map__4766);
var name = cljs.core.get.call(null,map__4766__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var type = cljs.core.get.call(null,map__4766__$1,new cljs.core.Keyword(null,"type","type",1174270348));
var props = cljs.core.get.call(null,map__4766__$1,new cljs.core.Keyword(null,"props","props",453281727));
var function_str = ((((cljs.core._EQ_.call(null,type,new cljs.core.Keyword(null,"function","function",-2127255473))) && (cljs.core.empty_QMARK_.call(null,props))))?"function()":"");
var props_extern = ["{",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,",",(function (){var iter__4292__auto__ = ((function (map__4766,map__4766__$1,name,type,props,function_str){
return (function javascript_externs_generator$extern$emit_props_extern_$_iter__4768(s__4769){
return (new cljs.core.LazySeq(null,((function (map__4766,map__4766__$1,name,type,props,function_str){
return (function (){
var s__4769__$1 = s__4769;
while(true){
var temp__5457__auto__ = cljs.core.seq.call(null,s__4769__$1);
if(temp__5457__auto__){
var s__4769__$2 = temp__5457__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__4769__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__4769__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__4771 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__4770 = (0);
while(true){
if((i__4770 < size__4291__auto__)){
var p = cljs.core._nth.call(null,c__4290__auto__,i__4770);
cljs.core.chunk_append.call(null,b__4771,javascript_externs_generator.extern.emit_props_extern.call(null,p));

var G__4772 = (i__4770 + (1));
i__4770 = G__4772;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4771),javascript_externs_generator$extern$emit_props_extern_$_iter__4768.call(null,cljs.core.chunk_rest.call(null,s__4769__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4771),null);
}
} else {
var p = cljs.core.first.call(null,s__4769__$2);
return cljs.core.cons.call(null,javascript_externs_generator.extern.emit_props_extern.call(null,p),javascript_externs_generator$extern$emit_props_extern_$_iter__4768.call(null,cljs.core.rest.call(null,s__4769__$2)));
}
} else {
return null;
}
break;
}
});})(map__4766,map__4766__$1,name,type,props,function_str))
,null,null));
});})(map__4766,map__4766__$1,name,type,props,function_str))
;
return iter__4292__auto__.call(null,props);
})())),"}"].join('');
if(cljs.core.truth_(cljs.core.get.call(null,obj,new cljs.core.Keyword(null,"root","root",-448657453)))){
return ["var ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)," = ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(function_str),cljs.core.str.cljs$core$IFn$_invoke$arity$1(props_extern),";"].join('');
} else {
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.quote_string.call(null,name)),": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(function_str),cljs.core.str.cljs$core$IFn$_invoke$arity$1(props_extern)].join('');
}
});
/**
 * Return string representation of an object's prototype/functions
 */
javascript_externs_generator.extern.emit_prototype = (function javascript_externs_generator$extern$emit_prototype(namespace,prototype){
if(cljs.core.seq.call(null,prototype)){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(namespace),".prototype = {",cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,",",(function (){var iter__4292__auto__ = (function javascript_externs_generator$extern$emit_prototype_$_iter__4773(s__4774){
return (new cljs.core.LazySeq(null,(function (){
var s__4774__$1 = s__4774;
while(true){
var temp__5457__auto__ = cljs.core.seq.call(null,s__4774__$1);
if(temp__5457__auto__){
var s__4774__$2 = temp__5457__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__4774__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__4774__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__4776 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__4775 = (0);
while(true){
if((i__4775 < size__4291__auto__)){
var p = cljs.core._nth.call(null,c__4290__auto__,i__4775);
cljs.core.chunk_append.call(null,b__4776,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.quote_string.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))),": function(){}"].join(''));

var G__4777 = (i__4775 + (1));
i__4775 = G__4777;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4776),javascript_externs_generator$extern$emit_prototype_$_iter__4773.call(null,cljs.core.chunk_rest.call(null,s__4774__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4776),null);
}
} else {
var p = cljs.core.first.call(null,s__4774__$2);
return cljs.core.cons.call(null,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(cljs.core.quote_string.call(null,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))),": function(){}"].join(''),javascript_externs_generator$extern$emit_prototype_$_iter__4773.call(null,cljs.core.rest.call(null,s__4774__$2)));
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4292__auto__.call(null,prototype);
})())),"};"].join('');
} else {
return null;
}
});
/**
 * https://stackoverflow.com/a/1661249
 */
javascript_externs_generator.extern.valid_variable_regex = /[a-zA-Z_$][0-9a-zA-Z_$]*/;
javascript_externs_generator.extern.append_name_to_namespace = (function javascript_externs_generator$extern$append_name_to_namespace(namespace,name){
if(cljs.core.truth_(cljs.core.re_matches.call(null,javascript_externs_generator.extern.valid_variable_regex,name))){
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(namespace),".",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name)].join('');
} else {
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(namespace),"[\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"\"]"].join('');
}
});
/**
 * Return recursive string representation of an object's prototype chain
 */
javascript_externs_generator.extern.emit_prototype_extern = (function javascript_externs_generator$extern$emit_prototype_extern(obj,namespace){
var map__4778 = obj;
var map__4778__$1 = ((((!((map__4778 == null)))?(((((map__4778.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4778.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4778):map__4778);
var name = cljs.core.get.call(null,map__4778__$1,new cljs.core.Keyword(null,"name","name",1843675177));
var props = cljs.core.get.call(null,map__4778__$1,new cljs.core.Keyword(null,"props","props",453281727));
var prototype = cljs.core.get.call(null,map__4778__$1,new cljs.core.Keyword(null,"prototype","prototype",-1121365005));
var prototype_extern = javascript_externs_generator.extern.emit_prototype.call(null,namespace,prototype);
var child_prototype_externs = (function (){var iter__4292__auto__ = ((function (map__4778,map__4778__$1,name,props,prototype,prototype_extern){
return (function javascript_externs_generator$extern$emit_prototype_extern_$_iter__4780(s__4781){
return (new cljs.core.LazySeq(null,((function (map__4778,map__4778__$1,name,props,prototype,prototype_extern){
return (function (){
var s__4781__$1 = s__4781;
while(true){
var temp__5457__auto__ = cljs.core.seq.call(null,s__4781__$1);
if(temp__5457__auto__){
var s__4781__$2 = temp__5457__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,s__4781__$2)){
var c__4290__auto__ = cljs.core.chunk_first.call(null,s__4781__$2);
var size__4291__auto__ = cljs.core.count.call(null,c__4290__auto__);
var b__4783 = cljs.core.chunk_buffer.call(null,size__4291__auto__);
if((function (){var i__4782 = (0);
while(true){
if((i__4782 < size__4291__auto__)){
var p = cljs.core._nth.call(null,c__4290__auto__,i__4782);
cljs.core.chunk_append.call(null,b__4783,javascript_externs_generator.extern.emit_prototype_extern.call(null,p,javascript_externs_generator.extern.append_name_to_namespace.call(null,namespace,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))));

var G__4784 = (i__4782 + (1));
i__4782 = G__4784;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4783),javascript_externs_generator$extern$emit_prototype_extern_$_iter__4780.call(null,cljs.core.chunk_rest.call(null,s__4781__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__4783),null);
}
} else {
var p = cljs.core.first.call(null,s__4781__$2);
return cljs.core.cons.call(null,javascript_externs_generator.extern.emit_prototype_extern.call(null,p,javascript_externs_generator.extern.append_name_to_namespace.call(null,namespace,new cljs.core.Keyword(null,"name","name",1843675177).cljs$core$IFn$_invoke$arity$1(p))),javascript_externs_generator$extern$emit_prototype_extern_$_iter__4780.call(null,cljs.core.rest.call(null,s__4781__$2)));
}
} else {
return null;
}
break;
}
});})(map__4778,map__4778__$1,name,props,prototype,prototype_extern))
,null,null));
});})(map__4778,map__4778__$1,name,props,prototype,prototype_extern))
;
return iter__4292__auto__.call(null,props);
})();
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(prototype_extern),cljs.core.str.cljs$core$IFn$_invoke$arity$1(clojure.string.join.call(null,child_prototype_externs))].join('');
});
/**
 * Recursively extract properties and prototypes from a JavaScript object
 *   into an extern for use with the Google Closure Compiler
 */
javascript_externs_generator.extern.extract = (function javascript_externs_generator$extern$extract(name,js_object){
var tree = cljs.core.assoc.call(null,javascript_externs_generator.extern.generate_object_tree.call(null,js_object,name),new cljs.core.Keyword(null,"root","root",-448657453),true);
var props_extern = javascript_externs_generator.extern.emit_props_extern.call(null,tree);
var prototype_extern = javascript_externs_generator.extern.emit_prototype_extern.call(null,tree,name);
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(props_extern),cljs.core.str.cljs$core$IFn$_invoke$arity$1(prototype_extern)].join('');
});
/**
 * Add header and footer to extern output
 */
javascript_externs_generator.extern.wrap_extern = (function javascript_externs_generator$extern$wrap_extern(name,extern){
var header = ["/**********************************************************************\n"," * Extern for ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"\n"," * Generated by http://jmmk.github.io/javascript-externs-generator\n"," **********************************************************************/\n"].join('');
var footer = ["/**********************************************************************\n"," * End Generated Extern for ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"\n","/**********************************************************************/\n"].join('');
return [cljs.core.str.cljs$core$IFn$_invoke$arity$1(header),cljs.core.str.cljs$core$IFn$_invoke$arity$1(extern),"\n",cljs.core.str.cljs$core$IFn$_invoke$arity$1(footer)].join('');
});
/**
 * Grab a loaded JavaScript object to extract an extern
 */
javascript_externs_generator.extern.extract_loaded = (function javascript_externs_generator$extern$extract_loaded(name){
var sandbox = goog.dom.getElement("sandbox");
var js_object = goog.object.get(goog.object.get(sandbox,"contentWindow"),name);
if((js_object == null)){
throw ["Namespace '",cljs.core.str.cljs$core$IFn$_invoke$arity$1(name),"' was not found. Make sure the library is loaded and the name is spelled correctly."].join('');
} else {
}

return javascript_externs_generator.extern.wrap_extern.call(null,name,javascript_externs_generator.extern.extract.call(null,name,js_object));
});
