// Compiled by ClojureScript 1.10.238 {:target :nodejs}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__4651 = arguments.length;
switch (G__4651) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async4652 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4652 = (function (f,blockable,meta4653){
this.f = f;
this.blockable = blockable;
this.meta4653 = meta4653;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4652.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_4654,meta4653__$1){
var self__ = this;
var _4654__$1 = this;
return (new cljs.core.async.t_cljs$core$async4652(self__.f,self__.blockable,meta4653__$1));
});

cljs.core.async.t_cljs$core$async4652.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_4654){
var self__ = this;
var _4654__$1 = this;
return self__.meta4653;
});

cljs.core.async.t_cljs$core$async4652.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4652.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async4652.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async4652.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async4652.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta4653","meta4653",1327091149,null)], null);
});

cljs.core.async.t_cljs$core$async4652.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4652.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4652";

cljs.core.async.t_cljs$core$async4652.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async4652");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4652.
 */
cljs.core.async.__GT_t_cljs$core$async4652 = (function cljs$core$async$__GT_t_cljs$core$async4652(f__$1,blockable__$1,meta4653){
return (new cljs.core.async.t_cljs$core$async4652(f__$1,blockable__$1,meta4653));
});

}

return (new cljs.core.async.t_cljs$core$async4652(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__4658 = arguments.length;
switch (G__4658) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__4661 = arguments.length;
switch (G__4661) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__4664 = arguments.length;
switch (G__4664) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_4666 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_4666);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_4666,ret){
return (function (){
return fn1.call(null,val_4666);
});})(val_4666,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__4668 = arguments.length;
switch (G__4668) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__4655__auto__)){
var ret = temp__4655__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__4655__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__4655__auto__)){
var retb = temp__4655__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__4655__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__4655__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4376__auto___4670 = n;
var x_4671 = (0);
while(true){
if((x_4671 < n__4376__auto___4670)){
(a[x_4671] = (0));

var G__4672 = (x_4671 + (1));
x_4671 = G__4672;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__4673 = (i + (1));
i = G__4673;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async4674 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4674 = (function (flag,meta4675){
this.flag = flag;
this.meta4675 = meta4675;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4674.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_4676,meta4675__$1){
var self__ = this;
var _4676__$1 = this;
return (new cljs.core.async.t_cljs$core$async4674(self__.flag,meta4675__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async4674.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_4676){
var self__ = this;
var _4676__$1 = this;
return self__.meta4675;
});})(flag))
;

cljs.core.async.t_cljs$core$async4674.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4674.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async4674.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async4674.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async4674.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta4675","meta4675",302148477,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async4674.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4674.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4674";

cljs.core.async.t_cljs$core$async4674.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async4674");
});})(flag))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4674.
 */
cljs.core.async.__GT_t_cljs$core$async4674 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async4674(flag__$1,meta4675){
return (new cljs.core.async.t_cljs$core$async4674(flag__$1,meta4675));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async4674(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async4677 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4677 = (function (flag,cb,meta4678){
this.flag = flag;
this.cb = cb;
this.meta4678 = meta4678;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4677.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_4679,meta4678__$1){
var self__ = this;
var _4679__$1 = this;
return (new cljs.core.async.t_cljs$core$async4677(self__.flag,self__.cb,meta4678__$1));
});

cljs.core.async.t_cljs$core$async4677.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_4679){
var self__ = this;
var _4679__$1 = this;
return self__.meta4678;
});

cljs.core.async.t_cljs$core$async4677.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4677.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async4677.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async4677.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async4677.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta4678","meta4678",-1786301561,null)], null);
});

cljs.core.async.t_cljs$core$async4677.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4677.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4677";

cljs.core.async.t_cljs$core$async4677.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async4677");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4677.
 */
cljs.core.async.__GT_t_cljs$core$async4677 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async4677(flag__$1,cb__$1,meta4678){
return (new cljs.core.async.t_cljs$core$async4677(flag__$1,cb__$1,meta4678));
});

}

return (new cljs.core.async.t_cljs$core$async4677(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__4680_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__4680_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__4681_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__4681_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__3922__auto__ = wport;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return port;
}
})()], null));
} else {
var G__4682 = (i + (1));
i = G__4682;
continue;
}
} else {
return null;
}
break;
}
})();
var or__3922__auto__ = ret;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__4657__auto__ = (function (){var and__3911__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(temp__4657__auto__)){
var got = temp__4657__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4502__auto__ = [];
var len__4499__auto___4688 = arguments.length;
var i__4500__auto___4689 = (0);
while(true){
if((i__4500__auto___4689 < len__4499__auto___4688)){
args__4502__auto__.push((arguments[i__4500__auto___4689]));

var G__4690 = (i__4500__auto___4689 + (1));
i__4500__auto___4689 = G__4690;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((1) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4503__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__4685){
var map__4686 = p__4685;
var map__4686__$1 = ((((!((map__4686 == null)))?(((((map__4686.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4686.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4686):map__4686);
var opts = map__4686__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq4683){
var G__4684 = cljs.core.first.call(null,seq4683);
var seq4683__$1 = cljs.core.next.call(null,seq4683);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__4684,seq4683__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__4692 = arguments.length;
switch (G__4692) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__4605__auto___4738 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___4738){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___4738){
return (function (state_4716){
var state_val_4717 = (state_4716[(1)]);
if((state_val_4717 === (7))){
var inst_4712 = (state_4716[(2)]);
var state_4716__$1 = state_4716;
var statearr_4718_4739 = state_4716__$1;
(statearr_4718_4739[(2)] = inst_4712);

(statearr_4718_4739[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (1))){
var state_4716__$1 = state_4716;
var statearr_4719_4740 = state_4716__$1;
(statearr_4719_4740[(2)] = null);

(statearr_4719_4740[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (4))){
var inst_4695 = (state_4716[(7)]);
var inst_4695__$1 = (state_4716[(2)]);
var inst_4696 = (inst_4695__$1 == null);
var state_4716__$1 = (function (){var statearr_4720 = state_4716;
(statearr_4720[(7)] = inst_4695__$1);

return statearr_4720;
})();
if(cljs.core.truth_(inst_4696)){
var statearr_4721_4741 = state_4716__$1;
(statearr_4721_4741[(1)] = (5));

} else {
var statearr_4722_4742 = state_4716__$1;
(statearr_4722_4742[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (13))){
var state_4716__$1 = state_4716;
var statearr_4723_4743 = state_4716__$1;
(statearr_4723_4743[(2)] = null);

(statearr_4723_4743[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (6))){
var inst_4695 = (state_4716[(7)]);
var state_4716__$1 = state_4716;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4716__$1,(11),to,inst_4695);
} else {
if((state_val_4717 === (3))){
var inst_4714 = (state_4716[(2)]);
var state_4716__$1 = state_4716;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4716__$1,inst_4714);
} else {
if((state_val_4717 === (12))){
var state_4716__$1 = state_4716;
var statearr_4724_4744 = state_4716__$1;
(statearr_4724_4744[(2)] = null);

(statearr_4724_4744[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (2))){
var state_4716__$1 = state_4716;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4716__$1,(4),from);
} else {
if((state_val_4717 === (11))){
var inst_4705 = (state_4716[(2)]);
var state_4716__$1 = state_4716;
if(cljs.core.truth_(inst_4705)){
var statearr_4725_4745 = state_4716__$1;
(statearr_4725_4745[(1)] = (12));

} else {
var statearr_4726_4746 = state_4716__$1;
(statearr_4726_4746[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (9))){
var state_4716__$1 = state_4716;
var statearr_4727_4747 = state_4716__$1;
(statearr_4727_4747[(2)] = null);

(statearr_4727_4747[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (5))){
var state_4716__$1 = state_4716;
if(cljs.core.truth_(close_QMARK_)){
var statearr_4728_4748 = state_4716__$1;
(statearr_4728_4748[(1)] = (8));

} else {
var statearr_4729_4749 = state_4716__$1;
(statearr_4729_4749[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (14))){
var inst_4710 = (state_4716[(2)]);
var state_4716__$1 = state_4716;
var statearr_4730_4750 = state_4716__$1;
(statearr_4730_4750[(2)] = inst_4710);

(statearr_4730_4750[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (10))){
var inst_4702 = (state_4716[(2)]);
var state_4716__$1 = state_4716;
var statearr_4731_4751 = state_4716__$1;
(statearr_4731_4751[(2)] = inst_4702);

(statearr_4731_4751[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4717 === (8))){
var inst_4699 = cljs.core.async.close_BANG_.call(null,to);
var state_4716__$1 = state_4716;
var statearr_4732_4752 = state_4716__$1;
(statearr_4732_4752[(2)] = inst_4699);

(statearr_4732_4752[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___4738))
;
return ((function (switch__4517__auto__,c__4605__auto___4738){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_4733 = [null,null,null,null,null,null,null,null];
(statearr_4733[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_4733[(1)] = (1));

return statearr_4733;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_4716){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_4716);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e4734){if((e4734 instanceof Object)){
var ex__4521__auto__ = e4734;
var statearr_4735_4753 = state_4716;
(statearr_4735_4753[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4716);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4734;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4754 = state_4716;
state_4716 = G__4754;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_4716){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_4716);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___4738))
})();
var state__4607__auto__ = (function (){var statearr_4736 = f__4606__auto__.call(null);
(statearr_4736[(6)] = c__4605__auto___4738);

return statearr_4736;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___4738))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__4755){
var vec__4756 = p__4755;
var v = cljs.core.nth.call(null,vec__4756,(0),null);
var p = cljs.core.nth.call(null,vec__4756,(1),null);
var job = vec__4756;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__4605__auto___4927 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___4927,res,vec__4756,v,p,job,jobs,results){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___4927,res,vec__4756,v,p,job,jobs,results){
return (function (state_4763){
var state_val_4764 = (state_4763[(1)]);
if((state_val_4764 === (1))){
var state_4763__$1 = state_4763;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4763__$1,(2),res,v);
} else {
if((state_val_4764 === (2))){
var inst_4760 = (state_4763[(2)]);
var inst_4761 = cljs.core.async.close_BANG_.call(null,res);
var state_4763__$1 = (function (){var statearr_4765 = state_4763;
(statearr_4765[(7)] = inst_4760);

return statearr_4765;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4763__$1,inst_4761);
} else {
return null;
}
}
});})(c__4605__auto___4927,res,vec__4756,v,p,job,jobs,results))
;
return ((function (switch__4517__auto__,c__4605__auto___4927,res,vec__4756,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0 = (function (){
var statearr_4766 = [null,null,null,null,null,null,null,null];
(statearr_4766[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__);

(statearr_4766[(1)] = (1));

return statearr_4766;
});
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1 = (function (state_4763){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_4763);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e4767){if((e4767 instanceof Object)){
var ex__4521__auto__ = e4767;
var statearr_4768_4928 = state_4763;
(statearr_4768_4928[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4763);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4767;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4929 = state_4763;
state_4763 = G__4929;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = function(state_4763){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1.call(this,state_4763);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___4927,res,vec__4756,v,p,job,jobs,results))
})();
var state__4607__auto__ = (function (){var statearr_4769 = f__4606__auto__.call(null);
(statearr_4769[(6)] = c__4605__auto___4927);

return statearr_4769;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___4927,res,vec__4756,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__4770){
var vec__4771 = p__4770;
var v = cljs.core.nth.call(null,vec__4771,(0),null);
var p = cljs.core.nth.call(null,vec__4771,(1),null);
var job = vec__4771;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__4376__auto___4930 = n;
var __4931 = (0);
while(true){
if((__4931 < n__4376__auto___4930)){
var G__4774_4932 = type;
var G__4774_4933__$1 = (((G__4774_4932 instanceof cljs.core.Keyword))?G__4774_4932.fqn:null);
switch (G__4774_4933__$1) {
case "compute":
var c__4605__auto___4935 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__4931,c__4605__auto___4935,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (__4931,c__4605__auto___4935,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async){
return (function (state_4787){
var state_val_4788 = (state_4787[(1)]);
if((state_val_4788 === (1))){
var state_4787__$1 = state_4787;
var statearr_4789_4936 = state_4787__$1;
(statearr_4789_4936[(2)] = null);

(statearr_4789_4936[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4788 === (2))){
var state_4787__$1 = state_4787;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4787__$1,(4),jobs);
} else {
if((state_val_4788 === (3))){
var inst_4785 = (state_4787[(2)]);
var state_4787__$1 = state_4787;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4787__$1,inst_4785);
} else {
if((state_val_4788 === (4))){
var inst_4777 = (state_4787[(2)]);
var inst_4778 = process.call(null,inst_4777);
var state_4787__$1 = state_4787;
if(cljs.core.truth_(inst_4778)){
var statearr_4790_4937 = state_4787__$1;
(statearr_4790_4937[(1)] = (5));

} else {
var statearr_4791_4938 = state_4787__$1;
(statearr_4791_4938[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4788 === (5))){
var state_4787__$1 = state_4787;
var statearr_4792_4939 = state_4787__$1;
(statearr_4792_4939[(2)] = null);

(statearr_4792_4939[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4788 === (6))){
var state_4787__$1 = state_4787;
var statearr_4793_4940 = state_4787__$1;
(statearr_4793_4940[(2)] = null);

(statearr_4793_4940[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4788 === (7))){
var inst_4783 = (state_4787[(2)]);
var state_4787__$1 = state_4787;
var statearr_4794_4941 = state_4787__$1;
(statearr_4794_4941[(2)] = inst_4783);

(statearr_4794_4941[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__4931,c__4605__auto___4935,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async))
;
return ((function (__4931,switch__4517__auto__,c__4605__auto___4935,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0 = (function (){
var statearr_4795 = [null,null,null,null,null,null,null];
(statearr_4795[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__);

(statearr_4795[(1)] = (1));

return statearr_4795;
});
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1 = (function (state_4787){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_4787);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e4796){if((e4796 instanceof Object)){
var ex__4521__auto__ = e4796;
var statearr_4797_4942 = state_4787;
(statearr_4797_4942[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4787);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4796;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4943 = state_4787;
state_4787 = G__4943;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = function(state_4787){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1.call(this,state_4787);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__;
})()
;})(__4931,switch__4517__auto__,c__4605__auto___4935,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async))
})();
var state__4607__auto__ = (function (){var statearr_4798 = f__4606__auto__.call(null);
(statearr_4798[(6)] = c__4605__auto___4935);

return statearr_4798;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(__4931,c__4605__auto___4935,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async))
);


break;
case "async":
var c__4605__auto___4944 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__4931,c__4605__auto___4944,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (__4931,c__4605__auto___4944,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async){
return (function (state_4811){
var state_val_4812 = (state_4811[(1)]);
if((state_val_4812 === (1))){
var state_4811__$1 = state_4811;
var statearr_4813_4945 = state_4811__$1;
(statearr_4813_4945[(2)] = null);

(statearr_4813_4945[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4812 === (2))){
var state_4811__$1 = state_4811;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4811__$1,(4),jobs);
} else {
if((state_val_4812 === (3))){
var inst_4809 = (state_4811[(2)]);
var state_4811__$1 = state_4811;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4811__$1,inst_4809);
} else {
if((state_val_4812 === (4))){
var inst_4801 = (state_4811[(2)]);
var inst_4802 = async.call(null,inst_4801);
var state_4811__$1 = state_4811;
if(cljs.core.truth_(inst_4802)){
var statearr_4814_4946 = state_4811__$1;
(statearr_4814_4946[(1)] = (5));

} else {
var statearr_4815_4947 = state_4811__$1;
(statearr_4815_4947[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4812 === (5))){
var state_4811__$1 = state_4811;
var statearr_4816_4948 = state_4811__$1;
(statearr_4816_4948[(2)] = null);

(statearr_4816_4948[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4812 === (6))){
var state_4811__$1 = state_4811;
var statearr_4817_4949 = state_4811__$1;
(statearr_4817_4949[(2)] = null);

(statearr_4817_4949[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4812 === (7))){
var inst_4807 = (state_4811[(2)]);
var state_4811__$1 = state_4811;
var statearr_4818_4950 = state_4811__$1;
(statearr_4818_4950[(2)] = inst_4807);

(statearr_4818_4950[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__4931,c__4605__auto___4944,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async))
;
return ((function (__4931,switch__4517__auto__,c__4605__auto___4944,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0 = (function (){
var statearr_4819 = [null,null,null,null,null,null,null];
(statearr_4819[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__);

(statearr_4819[(1)] = (1));

return statearr_4819;
});
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1 = (function (state_4811){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_4811);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e4820){if((e4820 instanceof Object)){
var ex__4521__auto__ = e4820;
var statearr_4821_4951 = state_4811;
(statearr_4821_4951[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4811);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4820;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4952 = state_4811;
state_4811 = G__4952;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = function(state_4811){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1.call(this,state_4811);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__;
})()
;})(__4931,switch__4517__auto__,c__4605__auto___4944,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async))
})();
var state__4607__auto__ = (function (){var statearr_4822 = f__4606__auto__.call(null);
(statearr_4822[(6)] = c__4605__auto___4944);

return statearr_4822;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(__4931,c__4605__auto___4944,G__4774_4932,G__4774_4933__$1,n__4376__auto___4930,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__4774_4933__$1)].join('')));

}

var G__4953 = (__4931 + (1));
__4931 = G__4953;
continue;
} else {
}
break;
}

var c__4605__auto___4954 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___4954,jobs,results,process,async){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___4954,jobs,results,process,async){
return (function (state_4844){
var state_val_4845 = (state_4844[(1)]);
if((state_val_4845 === (1))){
var state_4844__$1 = state_4844;
var statearr_4846_4955 = state_4844__$1;
(statearr_4846_4955[(2)] = null);

(statearr_4846_4955[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4845 === (2))){
var state_4844__$1 = state_4844;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4844__$1,(4),from);
} else {
if((state_val_4845 === (3))){
var inst_4842 = (state_4844[(2)]);
var state_4844__$1 = state_4844;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4844__$1,inst_4842);
} else {
if((state_val_4845 === (4))){
var inst_4825 = (state_4844[(7)]);
var inst_4825__$1 = (state_4844[(2)]);
var inst_4826 = (inst_4825__$1 == null);
var state_4844__$1 = (function (){var statearr_4847 = state_4844;
(statearr_4847[(7)] = inst_4825__$1);

return statearr_4847;
})();
if(cljs.core.truth_(inst_4826)){
var statearr_4848_4956 = state_4844__$1;
(statearr_4848_4956[(1)] = (5));

} else {
var statearr_4849_4957 = state_4844__$1;
(statearr_4849_4957[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4845 === (5))){
var inst_4828 = cljs.core.async.close_BANG_.call(null,jobs);
var state_4844__$1 = state_4844;
var statearr_4850_4958 = state_4844__$1;
(statearr_4850_4958[(2)] = inst_4828);

(statearr_4850_4958[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4845 === (6))){
var inst_4825 = (state_4844[(7)]);
var inst_4830 = (state_4844[(8)]);
var inst_4830__$1 = cljs.core.async.chan.call(null,(1));
var inst_4831 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_4832 = [inst_4825,inst_4830__$1];
var inst_4833 = (new cljs.core.PersistentVector(null,2,(5),inst_4831,inst_4832,null));
var state_4844__$1 = (function (){var statearr_4851 = state_4844;
(statearr_4851[(8)] = inst_4830__$1);

return statearr_4851;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4844__$1,(8),jobs,inst_4833);
} else {
if((state_val_4845 === (7))){
var inst_4840 = (state_4844[(2)]);
var state_4844__$1 = state_4844;
var statearr_4852_4959 = state_4844__$1;
(statearr_4852_4959[(2)] = inst_4840);

(statearr_4852_4959[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4845 === (8))){
var inst_4830 = (state_4844[(8)]);
var inst_4835 = (state_4844[(2)]);
var state_4844__$1 = (function (){var statearr_4853 = state_4844;
(statearr_4853[(9)] = inst_4835);

return statearr_4853;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4844__$1,(9),results,inst_4830);
} else {
if((state_val_4845 === (9))){
var inst_4837 = (state_4844[(2)]);
var state_4844__$1 = (function (){var statearr_4854 = state_4844;
(statearr_4854[(10)] = inst_4837);

return statearr_4854;
})();
var statearr_4855_4960 = state_4844__$1;
(statearr_4855_4960[(2)] = null);

(statearr_4855_4960[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___4954,jobs,results,process,async))
;
return ((function (switch__4517__auto__,c__4605__auto___4954,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0 = (function (){
var statearr_4856 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_4856[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__);

(statearr_4856[(1)] = (1));

return statearr_4856;
});
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1 = (function (state_4844){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_4844);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e4857){if((e4857 instanceof Object)){
var ex__4521__auto__ = e4857;
var statearr_4858_4961 = state_4844;
(statearr_4858_4961[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4844);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4857;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4962 = state_4844;
state_4844 = G__4962;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = function(state_4844){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1.call(this,state_4844);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___4954,jobs,results,process,async))
})();
var state__4607__auto__ = (function (){var statearr_4859 = f__4606__auto__.call(null);
(statearr_4859[(6)] = c__4605__auto___4954);

return statearr_4859;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___4954,jobs,results,process,async))
);


var c__4605__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto__,jobs,results,process,async){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto__,jobs,results,process,async){
return (function (state_4897){
var state_val_4898 = (state_4897[(1)]);
if((state_val_4898 === (7))){
var inst_4893 = (state_4897[(2)]);
var state_4897__$1 = state_4897;
var statearr_4899_4963 = state_4897__$1;
(statearr_4899_4963[(2)] = inst_4893);

(statearr_4899_4963[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (20))){
var state_4897__$1 = state_4897;
var statearr_4900_4964 = state_4897__$1;
(statearr_4900_4964[(2)] = null);

(statearr_4900_4964[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (1))){
var state_4897__$1 = state_4897;
var statearr_4901_4965 = state_4897__$1;
(statearr_4901_4965[(2)] = null);

(statearr_4901_4965[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (4))){
var inst_4862 = (state_4897[(7)]);
var inst_4862__$1 = (state_4897[(2)]);
var inst_4863 = (inst_4862__$1 == null);
var state_4897__$1 = (function (){var statearr_4902 = state_4897;
(statearr_4902[(7)] = inst_4862__$1);

return statearr_4902;
})();
if(cljs.core.truth_(inst_4863)){
var statearr_4903_4966 = state_4897__$1;
(statearr_4903_4966[(1)] = (5));

} else {
var statearr_4904_4967 = state_4897__$1;
(statearr_4904_4967[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (15))){
var inst_4875 = (state_4897[(8)]);
var state_4897__$1 = state_4897;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4897__$1,(18),to,inst_4875);
} else {
if((state_val_4898 === (21))){
var inst_4888 = (state_4897[(2)]);
var state_4897__$1 = state_4897;
var statearr_4905_4968 = state_4897__$1;
(statearr_4905_4968[(2)] = inst_4888);

(statearr_4905_4968[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (13))){
var inst_4890 = (state_4897[(2)]);
var state_4897__$1 = (function (){var statearr_4906 = state_4897;
(statearr_4906[(9)] = inst_4890);

return statearr_4906;
})();
var statearr_4907_4969 = state_4897__$1;
(statearr_4907_4969[(2)] = null);

(statearr_4907_4969[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (6))){
var inst_4862 = (state_4897[(7)]);
var state_4897__$1 = state_4897;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4897__$1,(11),inst_4862);
} else {
if((state_val_4898 === (17))){
var inst_4883 = (state_4897[(2)]);
var state_4897__$1 = state_4897;
if(cljs.core.truth_(inst_4883)){
var statearr_4908_4970 = state_4897__$1;
(statearr_4908_4970[(1)] = (19));

} else {
var statearr_4909_4971 = state_4897__$1;
(statearr_4909_4971[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (3))){
var inst_4895 = (state_4897[(2)]);
var state_4897__$1 = state_4897;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4897__$1,inst_4895);
} else {
if((state_val_4898 === (12))){
var inst_4872 = (state_4897[(10)]);
var state_4897__$1 = state_4897;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4897__$1,(14),inst_4872);
} else {
if((state_val_4898 === (2))){
var state_4897__$1 = state_4897;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4897__$1,(4),results);
} else {
if((state_val_4898 === (19))){
var state_4897__$1 = state_4897;
var statearr_4910_4972 = state_4897__$1;
(statearr_4910_4972[(2)] = null);

(statearr_4910_4972[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (11))){
var inst_4872 = (state_4897[(2)]);
var state_4897__$1 = (function (){var statearr_4911 = state_4897;
(statearr_4911[(10)] = inst_4872);

return statearr_4911;
})();
var statearr_4912_4973 = state_4897__$1;
(statearr_4912_4973[(2)] = null);

(statearr_4912_4973[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (9))){
var state_4897__$1 = state_4897;
var statearr_4913_4974 = state_4897__$1;
(statearr_4913_4974[(2)] = null);

(statearr_4913_4974[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (5))){
var state_4897__$1 = state_4897;
if(cljs.core.truth_(close_QMARK_)){
var statearr_4914_4975 = state_4897__$1;
(statearr_4914_4975[(1)] = (8));

} else {
var statearr_4915_4976 = state_4897__$1;
(statearr_4915_4976[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (14))){
var inst_4875 = (state_4897[(8)]);
var inst_4877 = (state_4897[(11)]);
var inst_4875__$1 = (state_4897[(2)]);
var inst_4876 = (inst_4875__$1 == null);
var inst_4877__$1 = cljs.core.not.call(null,inst_4876);
var state_4897__$1 = (function (){var statearr_4916 = state_4897;
(statearr_4916[(8)] = inst_4875__$1);

(statearr_4916[(11)] = inst_4877__$1);

return statearr_4916;
})();
if(inst_4877__$1){
var statearr_4917_4977 = state_4897__$1;
(statearr_4917_4977[(1)] = (15));

} else {
var statearr_4918_4978 = state_4897__$1;
(statearr_4918_4978[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (16))){
var inst_4877 = (state_4897[(11)]);
var state_4897__$1 = state_4897;
var statearr_4919_4979 = state_4897__$1;
(statearr_4919_4979[(2)] = inst_4877);

(statearr_4919_4979[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (10))){
var inst_4869 = (state_4897[(2)]);
var state_4897__$1 = state_4897;
var statearr_4920_4980 = state_4897__$1;
(statearr_4920_4980[(2)] = inst_4869);

(statearr_4920_4980[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (18))){
var inst_4880 = (state_4897[(2)]);
var state_4897__$1 = state_4897;
var statearr_4921_4981 = state_4897__$1;
(statearr_4921_4981[(2)] = inst_4880);

(statearr_4921_4981[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4898 === (8))){
var inst_4866 = cljs.core.async.close_BANG_.call(null,to);
var state_4897__$1 = state_4897;
var statearr_4922_4982 = state_4897__$1;
(statearr_4922_4982[(2)] = inst_4866);

(statearr_4922_4982[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto__,jobs,results,process,async))
;
return ((function (switch__4517__auto__,c__4605__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0 = (function (){
var statearr_4923 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4923[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__);

(statearr_4923[(1)] = (1));

return statearr_4923;
});
var cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1 = (function (state_4897){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_4897);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e4924){if((e4924 instanceof Object)){
var ex__4521__auto__ = e4924;
var statearr_4925_4983 = state_4897;
(statearr_4925_4983[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4897);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4924;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4984 = state_4897;
state_4897 = G__4984;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__ = function(state_4897){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1.call(this,state_4897);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__4518__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto__,jobs,results,process,async))
})();
var state__4607__auto__ = (function (){var statearr_4926 = f__4606__auto__.call(null);
(statearr_4926[(6)] = c__4605__auto__);

return statearr_4926;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto__,jobs,results,process,async))
);

return c__4605__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__4986 = arguments.length;
switch (G__4986) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__4989 = arguments.length;
switch (G__4989) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__4992 = arguments.length;
switch (G__4992) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__4605__auto___5041 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___5041,tc,fc){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___5041,tc,fc){
return (function (state_5018){
var state_val_5019 = (state_5018[(1)]);
if((state_val_5019 === (7))){
var inst_5014 = (state_5018[(2)]);
var state_5018__$1 = state_5018;
var statearr_5020_5042 = state_5018__$1;
(statearr_5020_5042[(2)] = inst_5014);

(statearr_5020_5042[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (1))){
var state_5018__$1 = state_5018;
var statearr_5021_5043 = state_5018__$1;
(statearr_5021_5043[(2)] = null);

(statearr_5021_5043[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (4))){
var inst_4995 = (state_5018[(7)]);
var inst_4995__$1 = (state_5018[(2)]);
var inst_4996 = (inst_4995__$1 == null);
var state_5018__$1 = (function (){var statearr_5022 = state_5018;
(statearr_5022[(7)] = inst_4995__$1);

return statearr_5022;
})();
if(cljs.core.truth_(inst_4996)){
var statearr_5023_5044 = state_5018__$1;
(statearr_5023_5044[(1)] = (5));

} else {
var statearr_5024_5045 = state_5018__$1;
(statearr_5024_5045[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (13))){
var state_5018__$1 = state_5018;
var statearr_5025_5046 = state_5018__$1;
(statearr_5025_5046[(2)] = null);

(statearr_5025_5046[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (6))){
var inst_4995 = (state_5018[(7)]);
var inst_5001 = p.call(null,inst_4995);
var state_5018__$1 = state_5018;
if(cljs.core.truth_(inst_5001)){
var statearr_5026_5047 = state_5018__$1;
(statearr_5026_5047[(1)] = (9));

} else {
var statearr_5027_5048 = state_5018__$1;
(statearr_5027_5048[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (3))){
var inst_5016 = (state_5018[(2)]);
var state_5018__$1 = state_5018;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5018__$1,inst_5016);
} else {
if((state_val_5019 === (12))){
var state_5018__$1 = state_5018;
var statearr_5028_5049 = state_5018__$1;
(statearr_5028_5049[(2)] = null);

(statearr_5028_5049[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (2))){
var state_5018__$1 = state_5018;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5018__$1,(4),ch);
} else {
if((state_val_5019 === (11))){
var inst_4995 = (state_5018[(7)]);
var inst_5005 = (state_5018[(2)]);
var state_5018__$1 = state_5018;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5018__$1,(8),inst_5005,inst_4995);
} else {
if((state_val_5019 === (9))){
var state_5018__$1 = state_5018;
var statearr_5029_5050 = state_5018__$1;
(statearr_5029_5050[(2)] = tc);

(statearr_5029_5050[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (5))){
var inst_4998 = cljs.core.async.close_BANG_.call(null,tc);
var inst_4999 = cljs.core.async.close_BANG_.call(null,fc);
var state_5018__$1 = (function (){var statearr_5030 = state_5018;
(statearr_5030[(8)] = inst_4998);

return statearr_5030;
})();
var statearr_5031_5051 = state_5018__$1;
(statearr_5031_5051[(2)] = inst_4999);

(statearr_5031_5051[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (14))){
var inst_5012 = (state_5018[(2)]);
var state_5018__$1 = state_5018;
var statearr_5032_5052 = state_5018__$1;
(statearr_5032_5052[(2)] = inst_5012);

(statearr_5032_5052[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (10))){
var state_5018__$1 = state_5018;
var statearr_5033_5053 = state_5018__$1;
(statearr_5033_5053[(2)] = fc);

(statearr_5033_5053[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5019 === (8))){
var inst_5007 = (state_5018[(2)]);
var state_5018__$1 = state_5018;
if(cljs.core.truth_(inst_5007)){
var statearr_5034_5054 = state_5018__$1;
(statearr_5034_5054[(1)] = (12));

} else {
var statearr_5035_5055 = state_5018__$1;
(statearr_5035_5055[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___5041,tc,fc))
;
return ((function (switch__4517__auto__,c__4605__auto___5041,tc,fc){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_5036 = [null,null,null,null,null,null,null,null,null];
(statearr_5036[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_5036[(1)] = (1));

return statearr_5036;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_5018){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5018);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5037){if((e5037 instanceof Object)){
var ex__4521__auto__ = e5037;
var statearr_5038_5056 = state_5018;
(statearr_5038_5056[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5018);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5037;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5057 = state_5018;
state_5018 = G__5057;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_5018){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_5018);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___5041,tc,fc))
})();
var state__4607__auto__ = (function (){var statearr_5039 = f__4606__auto__.call(null);
(statearr_5039[(6)] = c__4605__auto___5041);

return statearr_5039;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___5041,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__4605__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto__){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto__){
return (function (state_5078){
var state_val_5079 = (state_5078[(1)]);
if((state_val_5079 === (7))){
var inst_5074 = (state_5078[(2)]);
var state_5078__$1 = state_5078;
var statearr_5080_5098 = state_5078__$1;
(statearr_5080_5098[(2)] = inst_5074);

(statearr_5080_5098[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5079 === (1))){
var inst_5058 = init;
var state_5078__$1 = (function (){var statearr_5081 = state_5078;
(statearr_5081[(7)] = inst_5058);

return statearr_5081;
})();
var statearr_5082_5099 = state_5078__$1;
(statearr_5082_5099[(2)] = null);

(statearr_5082_5099[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5079 === (4))){
var inst_5061 = (state_5078[(8)]);
var inst_5061__$1 = (state_5078[(2)]);
var inst_5062 = (inst_5061__$1 == null);
var state_5078__$1 = (function (){var statearr_5083 = state_5078;
(statearr_5083[(8)] = inst_5061__$1);

return statearr_5083;
})();
if(cljs.core.truth_(inst_5062)){
var statearr_5084_5100 = state_5078__$1;
(statearr_5084_5100[(1)] = (5));

} else {
var statearr_5085_5101 = state_5078__$1;
(statearr_5085_5101[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5079 === (6))){
var inst_5058 = (state_5078[(7)]);
var inst_5065 = (state_5078[(9)]);
var inst_5061 = (state_5078[(8)]);
var inst_5065__$1 = f.call(null,inst_5058,inst_5061);
var inst_5066 = cljs.core.reduced_QMARK_.call(null,inst_5065__$1);
var state_5078__$1 = (function (){var statearr_5086 = state_5078;
(statearr_5086[(9)] = inst_5065__$1);

return statearr_5086;
})();
if(inst_5066){
var statearr_5087_5102 = state_5078__$1;
(statearr_5087_5102[(1)] = (8));

} else {
var statearr_5088_5103 = state_5078__$1;
(statearr_5088_5103[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5079 === (3))){
var inst_5076 = (state_5078[(2)]);
var state_5078__$1 = state_5078;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5078__$1,inst_5076);
} else {
if((state_val_5079 === (2))){
var state_5078__$1 = state_5078;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5078__$1,(4),ch);
} else {
if((state_val_5079 === (9))){
var inst_5065 = (state_5078[(9)]);
var inst_5058 = inst_5065;
var state_5078__$1 = (function (){var statearr_5089 = state_5078;
(statearr_5089[(7)] = inst_5058);

return statearr_5089;
})();
var statearr_5090_5104 = state_5078__$1;
(statearr_5090_5104[(2)] = null);

(statearr_5090_5104[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5079 === (5))){
var inst_5058 = (state_5078[(7)]);
var state_5078__$1 = state_5078;
var statearr_5091_5105 = state_5078__$1;
(statearr_5091_5105[(2)] = inst_5058);

(statearr_5091_5105[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5079 === (10))){
var inst_5072 = (state_5078[(2)]);
var state_5078__$1 = state_5078;
var statearr_5092_5106 = state_5078__$1;
(statearr_5092_5106[(2)] = inst_5072);

(statearr_5092_5106[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5079 === (8))){
var inst_5065 = (state_5078[(9)]);
var inst_5068 = cljs.core.deref.call(null,inst_5065);
var state_5078__$1 = state_5078;
var statearr_5093_5107 = state_5078__$1;
(statearr_5093_5107[(2)] = inst_5068);

(statearr_5093_5107[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto__))
;
return ((function (switch__4517__auto__,c__4605__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__4518__auto__ = null;
var cljs$core$async$reduce_$_state_machine__4518__auto____0 = (function (){
var statearr_5094 = [null,null,null,null,null,null,null,null,null,null];
(statearr_5094[(0)] = cljs$core$async$reduce_$_state_machine__4518__auto__);

(statearr_5094[(1)] = (1));

return statearr_5094;
});
var cljs$core$async$reduce_$_state_machine__4518__auto____1 = (function (state_5078){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5078);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5095){if((e5095 instanceof Object)){
var ex__4521__auto__ = e5095;
var statearr_5096_5108 = state_5078;
(statearr_5096_5108[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5078);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5095;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5109 = state_5078;
state_5078 = G__5109;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__4518__auto__ = function(state_5078){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__4518__auto____1.call(this,state_5078);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$reduce_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__4518__auto____0;
cljs$core$async$reduce_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__4518__auto____1;
return cljs$core$async$reduce_$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto__))
})();
var state__4607__auto__ = (function (){var statearr_5097 = f__4606__auto__.call(null);
(statearr_5097[(6)] = c__4605__auto__);

return statearr_5097;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto__))
);

return c__4605__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__4605__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto__,f__$1){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto__,f__$1){
return (function (state_5115){
var state_val_5116 = (state_5115[(1)]);
if((state_val_5116 === (1))){
var inst_5110 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_5115__$1 = state_5115;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5115__$1,(2),inst_5110);
} else {
if((state_val_5116 === (2))){
var inst_5112 = (state_5115[(2)]);
var inst_5113 = f__$1.call(null,inst_5112);
var state_5115__$1 = state_5115;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5115__$1,inst_5113);
} else {
return null;
}
}
});})(c__4605__auto__,f__$1))
;
return ((function (switch__4517__auto__,c__4605__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__4518__auto__ = null;
var cljs$core$async$transduce_$_state_machine__4518__auto____0 = (function (){
var statearr_5117 = [null,null,null,null,null,null,null];
(statearr_5117[(0)] = cljs$core$async$transduce_$_state_machine__4518__auto__);

(statearr_5117[(1)] = (1));

return statearr_5117;
});
var cljs$core$async$transduce_$_state_machine__4518__auto____1 = (function (state_5115){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5115);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5118){if((e5118 instanceof Object)){
var ex__4521__auto__ = e5118;
var statearr_5119_5121 = state_5115;
(statearr_5119_5121[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5115);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5118;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5122 = state_5115;
state_5115 = G__5122;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__4518__auto__ = function(state_5115){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__4518__auto____1.call(this,state_5115);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$transduce_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__4518__auto____0;
cljs$core$async$transduce_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__4518__auto____1;
return cljs$core$async$transduce_$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto__,f__$1))
})();
var state__4607__auto__ = (function (){var statearr_5120 = f__4606__auto__.call(null);
(statearr_5120[(6)] = c__4605__auto__);

return statearr_5120;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto__,f__$1))
);

return c__4605__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__5124 = arguments.length;
switch (G__5124) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__4605__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto__){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto__){
return (function (state_5149){
var state_val_5150 = (state_5149[(1)]);
if((state_val_5150 === (7))){
var inst_5131 = (state_5149[(2)]);
var state_5149__$1 = state_5149;
var statearr_5151_5172 = state_5149__$1;
(statearr_5151_5172[(2)] = inst_5131);

(statearr_5151_5172[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (1))){
var inst_5125 = cljs.core.seq.call(null,coll);
var inst_5126 = inst_5125;
var state_5149__$1 = (function (){var statearr_5152 = state_5149;
(statearr_5152[(7)] = inst_5126);

return statearr_5152;
})();
var statearr_5153_5173 = state_5149__$1;
(statearr_5153_5173[(2)] = null);

(statearr_5153_5173[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (4))){
var inst_5126 = (state_5149[(7)]);
var inst_5129 = cljs.core.first.call(null,inst_5126);
var state_5149__$1 = state_5149;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5149__$1,(7),ch,inst_5129);
} else {
if((state_val_5150 === (13))){
var inst_5143 = (state_5149[(2)]);
var state_5149__$1 = state_5149;
var statearr_5154_5174 = state_5149__$1;
(statearr_5154_5174[(2)] = inst_5143);

(statearr_5154_5174[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (6))){
var inst_5134 = (state_5149[(2)]);
var state_5149__$1 = state_5149;
if(cljs.core.truth_(inst_5134)){
var statearr_5155_5175 = state_5149__$1;
(statearr_5155_5175[(1)] = (8));

} else {
var statearr_5156_5176 = state_5149__$1;
(statearr_5156_5176[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (3))){
var inst_5147 = (state_5149[(2)]);
var state_5149__$1 = state_5149;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5149__$1,inst_5147);
} else {
if((state_val_5150 === (12))){
var state_5149__$1 = state_5149;
var statearr_5157_5177 = state_5149__$1;
(statearr_5157_5177[(2)] = null);

(statearr_5157_5177[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (2))){
var inst_5126 = (state_5149[(7)]);
var state_5149__$1 = state_5149;
if(cljs.core.truth_(inst_5126)){
var statearr_5158_5178 = state_5149__$1;
(statearr_5158_5178[(1)] = (4));

} else {
var statearr_5159_5179 = state_5149__$1;
(statearr_5159_5179[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (11))){
var inst_5140 = cljs.core.async.close_BANG_.call(null,ch);
var state_5149__$1 = state_5149;
var statearr_5160_5180 = state_5149__$1;
(statearr_5160_5180[(2)] = inst_5140);

(statearr_5160_5180[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (9))){
var state_5149__$1 = state_5149;
if(cljs.core.truth_(close_QMARK_)){
var statearr_5161_5181 = state_5149__$1;
(statearr_5161_5181[(1)] = (11));

} else {
var statearr_5162_5182 = state_5149__$1;
(statearr_5162_5182[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (5))){
var inst_5126 = (state_5149[(7)]);
var state_5149__$1 = state_5149;
var statearr_5163_5183 = state_5149__$1;
(statearr_5163_5183[(2)] = inst_5126);

(statearr_5163_5183[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (10))){
var inst_5145 = (state_5149[(2)]);
var state_5149__$1 = state_5149;
var statearr_5164_5184 = state_5149__$1;
(statearr_5164_5184[(2)] = inst_5145);

(statearr_5164_5184[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5150 === (8))){
var inst_5126 = (state_5149[(7)]);
var inst_5136 = cljs.core.next.call(null,inst_5126);
var inst_5126__$1 = inst_5136;
var state_5149__$1 = (function (){var statearr_5165 = state_5149;
(statearr_5165[(7)] = inst_5126__$1);

return statearr_5165;
})();
var statearr_5166_5185 = state_5149__$1;
(statearr_5166_5185[(2)] = null);

(statearr_5166_5185[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto__))
;
return ((function (switch__4517__auto__,c__4605__auto__){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_5167 = [null,null,null,null,null,null,null,null];
(statearr_5167[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_5167[(1)] = (1));

return statearr_5167;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_5149){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5149);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5168){if((e5168 instanceof Object)){
var ex__4521__auto__ = e5168;
var statearr_5169_5186 = state_5149;
(statearr_5169_5186[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5149);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5168;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5187 = state_5149;
state_5149 = G__5187;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_5149){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_5149);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto__))
})();
var state__4607__auto__ = (function (){var statearr_5170 = f__4606__auto__.call(null);
(statearr_5170[(6)] = c__4605__auto__);

return statearr_5170;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto__))
);

return c__4605__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if(((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__4211__auto__ = (((_ == null))?null:_);
var m__4212__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,_);
} else {
var m__4212__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__4212__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m);
} else {
var m__4212__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async5188 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async5188 = (function (ch,cs,meta5189){
this.ch = ch;
this.cs = cs;
this.meta5189 = meta5189;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_5190,meta5189__$1){
var self__ = this;
var _5190__$1 = this;
return (new cljs.core.async.t_cljs$core$async5188(self__.ch,self__.cs,meta5189__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_5190){
var self__ = this;
var _5190__$1 = this;
return self__.meta5189;
});})(cs))
;

cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async5188.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async5188.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta5189","meta5189",1929122805,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async5188.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async5188.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async5188";

cljs.core.async.t_cljs$core$async5188.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async5188");
});})(cs))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async5188.
 */
cljs.core.async.__GT_t_cljs$core$async5188 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async5188(ch__$1,cs__$1,meta5189){
return (new cljs.core.async.t_cljs$core$async5188(ch__$1,cs__$1,meta5189));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async5188(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__4605__auto___5410 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___5410,cs,m,dchan,dctr,done){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___5410,cs,m,dchan,dctr,done){
return (function (state_5325){
var state_val_5326 = (state_5325[(1)]);
if((state_val_5326 === (7))){
var inst_5321 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5327_5411 = state_5325__$1;
(statearr_5327_5411[(2)] = inst_5321);

(statearr_5327_5411[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (20))){
var inst_5224 = (state_5325[(7)]);
var inst_5236 = cljs.core.first.call(null,inst_5224);
var inst_5237 = cljs.core.nth.call(null,inst_5236,(0),null);
var inst_5238 = cljs.core.nth.call(null,inst_5236,(1),null);
var state_5325__$1 = (function (){var statearr_5328 = state_5325;
(statearr_5328[(8)] = inst_5237);

return statearr_5328;
})();
if(cljs.core.truth_(inst_5238)){
var statearr_5329_5412 = state_5325__$1;
(statearr_5329_5412[(1)] = (22));

} else {
var statearr_5330_5413 = state_5325__$1;
(statearr_5330_5413[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (27))){
var inst_5193 = (state_5325[(9)]);
var inst_5268 = (state_5325[(10)]);
var inst_5266 = (state_5325[(11)]);
var inst_5273 = (state_5325[(12)]);
var inst_5273__$1 = cljs.core._nth.call(null,inst_5266,inst_5268);
var inst_5274 = cljs.core.async.put_BANG_.call(null,inst_5273__$1,inst_5193,done);
var state_5325__$1 = (function (){var statearr_5331 = state_5325;
(statearr_5331[(12)] = inst_5273__$1);

return statearr_5331;
})();
if(cljs.core.truth_(inst_5274)){
var statearr_5332_5414 = state_5325__$1;
(statearr_5332_5414[(1)] = (30));

} else {
var statearr_5333_5415 = state_5325__$1;
(statearr_5333_5415[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (1))){
var state_5325__$1 = state_5325;
var statearr_5334_5416 = state_5325__$1;
(statearr_5334_5416[(2)] = null);

(statearr_5334_5416[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (24))){
var inst_5224 = (state_5325[(7)]);
var inst_5243 = (state_5325[(2)]);
var inst_5244 = cljs.core.next.call(null,inst_5224);
var inst_5202 = inst_5244;
var inst_5203 = null;
var inst_5204 = (0);
var inst_5205 = (0);
var state_5325__$1 = (function (){var statearr_5335 = state_5325;
(statearr_5335[(13)] = inst_5243);

(statearr_5335[(14)] = inst_5203);

(statearr_5335[(15)] = inst_5205);

(statearr_5335[(16)] = inst_5204);

(statearr_5335[(17)] = inst_5202);

return statearr_5335;
})();
var statearr_5336_5417 = state_5325__$1;
(statearr_5336_5417[(2)] = null);

(statearr_5336_5417[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (39))){
var state_5325__$1 = state_5325;
var statearr_5340_5418 = state_5325__$1;
(statearr_5340_5418[(2)] = null);

(statearr_5340_5418[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (4))){
var inst_5193 = (state_5325[(9)]);
var inst_5193__$1 = (state_5325[(2)]);
var inst_5194 = (inst_5193__$1 == null);
var state_5325__$1 = (function (){var statearr_5341 = state_5325;
(statearr_5341[(9)] = inst_5193__$1);

return statearr_5341;
})();
if(cljs.core.truth_(inst_5194)){
var statearr_5342_5419 = state_5325__$1;
(statearr_5342_5419[(1)] = (5));

} else {
var statearr_5343_5420 = state_5325__$1;
(statearr_5343_5420[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (15))){
var inst_5203 = (state_5325[(14)]);
var inst_5205 = (state_5325[(15)]);
var inst_5204 = (state_5325[(16)]);
var inst_5202 = (state_5325[(17)]);
var inst_5220 = (state_5325[(2)]);
var inst_5221 = (inst_5205 + (1));
var tmp5337 = inst_5203;
var tmp5338 = inst_5204;
var tmp5339 = inst_5202;
var inst_5202__$1 = tmp5339;
var inst_5203__$1 = tmp5337;
var inst_5204__$1 = tmp5338;
var inst_5205__$1 = inst_5221;
var state_5325__$1 = (function (){var statearr_5344 = state_5325;
(statearr_5344[(14)] = inst_5203__$1);

(statearr_5344[(15)] = inst_5205__$1);

(statearr_5344[(16)] = inst_5204__$1);

(statearr_5344[(17)] = inst_5202__$1);

(statearr_5344[(18)] = inst_5220);

return statearr_5344;
})();
var statearr_5345_5421 = state_5325__$1;
(statearr_5345_5421[(2)] = null);

(statearr_5345_5421[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (21))){
var inst_5247 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5349_5422 = state_5325__$1;
(statearr_5349_5422[(2)] = inst_5247);

(statearr_5349_5422[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (31))){
var inst_5273 = (state_5325[(12)]);
var inst_5277 = done.call(null,null);
var inst_5278 = cljs.core.async.untap_STAR_.call(null,m,inst_5273);
var state_5325__$1 = (function (){var statearr_5350 = state_5325;
(statearr_5350[(19)] = inst_5277);

return statearr_5350;
})();
var statearr_5351_5423 = state_5325__$1;
(statearr_5351_5423[(2)] = inst_5278);

(statearr_5351_5423[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (32))){
var inst_5268 = (state_5325[(10)]);
var inst_5267 = (state_5325[(20)]);
var inst_5266 = (state_5325[(11)]);
var inst_5265 = (state_5325[(21)]);
var inst_5280 = (state_5325[(2)]);
var inst_5281 = (inst_5268 + (1));
var tmp5346 = inst_5267;
var tmp5347 = inst_5266;
var tmp5348 = inst_5265;
var inst_5265__$1 = tmp5348;
var inst_5266__$1 = tmp5347;
var inst_5267__$1 = tmp5346;
var inst_5268__$1 = inst_5281;
var state_5325__$1 = (function (){var statearr_5352 = state_5325;
(statearr_5352[(10)] = inst_5268__$1);

(statearr_5352[(20)] = inst_5267__$1);

(statearr_5352[(11)] = inst_5266__$1);

(statearr_5352[(21)] = inst_5265__$1);

(statearr_5352[(22)] = inst_5280);

return statearr_5352;
})();
var statearr_5353_5424 = state_5325__$1;
(statearr_5353_5424[(2)] = null);

(statearr_5353_5424[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (40))){
var inst_5293 = (state_5325[(23)]);
var inst_5297 = done.call(null,null);
var inst_5298 = cljs.core.async.untap_STAR_.call(null,m,inst_5293);
var state_5325__$1 = (function (){var statearr_5354 = state_5325;
(statearr_5354[(24)] = inst_5297);

return statearr_5354;
})();
var statearr_5355_5425 = state_5325__$1;
(statearr_5355_5425[(2)] = inst_5298);

(statearr_5355_5425[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (33))){
var inst_5284 = (state_5325[(25)]);
var inst_5286 = cljs.core.chunked_seq_QMARK_.call(null,inst_5284);
var state_5325__$1 = state_5325;
if(inst_5286){
var statearr_5356_5426 = state_5325__$1;
(statearr_5356_5426[(1)] = (36));

} else {
var statearr_5357_5427 = state_5325__$1;
(statearr_5357_5427[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (13))){
var inst_5214 = (state_5325[(26)]);
var inst_5217 = cljs.core.async.close_BANG_.call(null,inst_5214);
var state_5325__$1 = state_5325;
var statearr_5358_5428 = state_5325__$1;
(statearr_5358_5428[(2)] = inst_5217);

(statearr_5358_5428[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (22))){
var inst_5237 = (state_5325[(8)]);
var inst_5240 = cljs.core.async.close_BANG_.call(null,inst_5237);
var state_5325__$1 = state_5325;
var statearr_5359_5429 = state_5325__$1;
(statearr_5359_5429[(2)] = inst_5240);

(statearr_5359_5429[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (36))){
var inst_5284 = (state_5325[(25)]);
var inst_5288 = cljs.core.chunk_first.call(null,inst_5284);
var inst_5289 = cljs.core.chunk_rest.call(null,inst_5284);
var inst_5290 = cljs.core.count.call(null,inst_5288);
var inst_5265 = inst_5289;
var inst_5266 = inst_5288;
var inst_5267 = inst_5290;
var inst_5268 = (0);
var state_5325__$1 = (function (){var statearr_5360 = state_5325;
(statearr_5360[(10)] = inst_5268);

(statearr_5360[(20)] = inst_5267);

(statearr_5360[(11)] = inst_5266);

(statearr_5360[(21)] = inst_5265);

return statearr_5360;
})();
var statearr_5361_5430 = state_5325__$1;
(statearr_5361_5430[(2)] = null);

(statearr_5361_5430[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (41))){
var inst_5284 = (state_5325[(25)]);
var inst_5300 = (state_5325[(2)]);
var inst_5301 = cljs.core.next.call(null,inst_5284);
var inst_5265 = inst_5301;
var inst_5266 = null;
var inst_5267 = (0);
var inst_5268 = (0);
var state_5325__$1 = (function (){var statearr_5362 = state_5325;
(statearr_5362[(10)] = inst_5268);

(statearr_5362[(20)] = inst_5267);

(statearr_5362[(11)] = inst_5266);

(statearr_5362[(21)] = inst_5265);

(statearr_5362[(27)] = inst_5300);

return statearr_5362;
})();
var statearr_5363_5431 = state_5325__$1;
(statearr_5363_5431[(2)] = null);

(statearr_5363_5431[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (43))){
var state_5325__$1 = state_5325;
var statearr_5364_5432 = state_5325__$1;
(statearr_5364_5432[(2)] = null);

(statearr_5364_5432[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (29))){
var inst_5309 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5365_5433 = state_5325__$1;
(statearr_5365_5433[(2)] = inst_5309);

(statearr_5365_5433[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (44))){
var inst_5318 = (state_5325[(2)]);
var state_5325__$1 = (function (){var statearr_5366 = state_5325;
(statearr_5366[(28)] = inst_5318);

return statearr_5366;
})();
var statearr_5367_5434 = state_5325__$1;
(statearr_5367_5434[(2)] = null);

(statearr_5367_5434[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (6))){
var inst_5257 = (state_5325[(29)]);
var inst_5256 = cljs.core.deref.call(null,cs);
var inst_5257__$1 = cljs.core.keys.call(null,inst_5256);
var inst_5258 = cljs.core.count.call(null,inst_5257__$1);
var inst_5259 = cljs.core.reset_BANG_.call(null,dctr,inst_5258);
var inst_5264 = cljs.core.seq.call(null,inst_5257__$1);
var inst_5265 = inst_5264;
var inst_5266 = null;
var inst_5267 = (0);
var inst_5268 = (0);
var state_5325__$1 = (function (){var statearr_5368 = state_5325;
(statearr_5368[(10)] = inst_5268);

(statearr_5368[(20)] = inst_5267);

(statearr_5368[(11)] = inst_5266);

(statearr_5368[(21)] = inst_5265);

(statearr_5368[(29)] = inst_5257__$1);

(statearr_5368[(30)] = inst_5259);

return statearr_5368;
})();
var statearr_5369_5435 = state_5325__$1;
(statearr_5369_5435[(2)] = null);

(statearr_5369_5435[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (28))){
var inst_5265 = (state_5325[(21)]);
var inst_5284 = (state_5325[(25)]);
var inst_5284__$1 = cljs.core.seq.call(null,inst_5265);
var state_5325__$1 = (function (){var statearr_5370 = state_5325;
(statearr_5370[(25)] = inst_5284__$1);

return statearr_5370;
})();
if(inst_5284__$1){
var statearr_5371_5436 = state_5325__$1;
(statearr_5371_5436[(1)] = (33));

} else {
var statearr_5372_5437 = state_5325__$1;
(statearr_5372_5437[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (25))){
var inst_5268 = (state_5325[(10)]);
var inst_5267 = (state_5325[(20)]);
var inst_5270 = (inst_5268 < inst_5267);
var inst_5271 = inst_5270;
var state_5325__$1 = state_5325;
if(cljs.core.truth_(inst_5271)){
var statearr_5373_5438 = state_5325__$1;
(statearr_5373_5438[(1)] = (27));

} else {
var statearr_5374_5439 = state_5325__$1;
(statearr_5374_5439[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (34))){
var state_5325__$1 = state_5325;
var statearr_5375_5440 = state_5325__$1;
(statearr_5375_5440[(2)] = null);

(statearr_5375_5440[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (17))){
var state_5325__$1 = state_5325;
var statearr_5376_5441 = state_5325__$1;
(statearr_5376_5441[(2)] = null);

(statearr_5376_5441[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (3))){
var inst_5323 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5325__$1,inst_5323);
} else {
if((state_val_5326 === (12))){
var inst_5252 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5377_5442 = state_5325__$1;
(statearr_5377_5442[(2)] = inst_5252);

(statearr_5377_5442[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (2))){
var state_5325__$1 = state_5325;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5325__$1,(4),ch);
} else {
if((state_val_5326 === (23))){
var state_5325__$1 = state_5325;
var statearr_5378_5443 = state_5325__$1;
(statearr_5378_5443[(2)] = null);

(statearr_5378_5443[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (35))){
var inst_5307 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5379_5444 = state_5325__$1;
(statearr_5379_5444[(2)] = inst_5307);

(statearr_5379_5444[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (19))){
var inst_5224 = (state_5325[(7)]);
var inst_5228 = cljs.core.chunk_first.call(null,inst_5224);
var inst_5229 = cljs.core.chunk_rest.call(null,inst_5224);
var inst_5230 = cljs.core.count.call(null,inst_5228);
var inst_5202 = inst_5229;
var inst_5203 = inst_5228;
var inst_5204 = inst_5230;
var inst_5205 = (0);
var state_5325__$1 = (function (){var statearr_5380 = state_5325;
(statearr_5380[(14)] = inst_5203);

(statearr_5380[(15)] = inst_5205);

(statearr_5380[(16)] = inst_5204);

(statearr_5380[(17)] = inst_5202);

return statearr_5380;
})();
var statearr_5381_5445 = state_5325__$1;
(statearr_5381_5445[(2)] = null);

(statearr_5381_5445[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (11))){
var inst_5224 = (state_5325[(7)]);
var inst_5202 = (state_5325[(17)]);
var inst_5224__$1 = cljs.core.seq.call(null,inst_5202);
var state_5325__$1 = (function (){var statearr_5382 = state_5325;
(statearr_5382[(7)] = inst_5224__$1);

return statearr_5382;
})();
if(inst_5224__$1){
var statearr_5383_5446 = state_5325__$1;
(statearr_5383_5446[(1)] = (16));

} else {
var statearr_5384_5447 = state_5325__$1;
(statearr_5384_5447[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (9))){
var inst_5254 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5385_5448 = state_5325__$1;
(statearr_5385_5448[(2)] = inst_5254);

(statearr_5385_5448[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (5))){
var inst_5200 = cljs.core.deref.call(null,cs);
var inst_5201 = cljs.core.seq.call(null,inst_5200);
var inst_5202 = inst_5201;
var inst_5203 = null;
var inst_5204 = (0);
var inst_5205 = (0);
var state_5325__$1 = (function (){var statearr_5386 = state_5325;
(statearr_5386[(14)] = inst_5203);

(statearr_5386[(15)] = inst_5205);

(statearr_5386[(16)] = inst_5204);

(statearr_5386[(17)] = inst_5202);

return statearr_5386;
})();
var statearr_5387_5449 = state_5325__$1;
(statearr_5387_5449[(2)] = null);

(statearr_5387_5449[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (14))){
var state_5325__$1 = state_5325;
var statearr_5388_5450 = state_5325__$1;
(statearr_5388_5450[(2)] = null);

(statearr_5388_5450[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (45))){
var inst_5315 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5389_5451 = state_5325__$1;
(statearr_5389_5451[(2)] = inst_5315);

(statearr_5389_5451[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (26))){
var inst_5257 = (state_5325[(29)]);
var inst_5311 = (state_5325[(2)]);
var inst_5312 = cljs.core.seq.call(null,inst_5257);
var state_5325__$1 = (function (){var statearr_5390 = state_5325;
(statearr_5390[(31)] = inst_5311);

return statearr_5390;
})();
if(inst_5312){
var statearr_5391_5452 = state_5325__$1;
(statearr_5391_5452[(1)] = (42));

} else {
var statearr_5392_5453 = state_5325__$1;
(statearr_5392_5453[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (16))){
var inst_5224 = (state_5325[(7)]);
var inst_5226 = cljs.core.chunked_seq_QMARK_.call(null,inst_5224);
var state_5325__$1 = state_5325;
if(inst_5226){
var statearr_5393_5454 = state_5325__$1;
(statearr_5393_5454[(1)] = (19));

} else {
var statearr_5394_5455 = state_5325__$1;
(statearr_5394_5455[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (38))){
var inst_5304 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5395_5456 = state_5325__$1;
(statearr_5395_5456[(2)] = inst_5304);

(statearr_5395_5456[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (30))){
var state_5325__$1 = state_5325;
var statearr_5396_5457 = state_5325__$1;
(statearr_5396_5457[(2)] = null);

(statearr_5396_5457[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (10))){
var inst_5203 = (state_5325[(14)]);
var inst_5205 = (state_5325[(15)]);
var inst_5213 = cljs.core._nth.call(null,inst_5203,inst_5205);
var inst_5214 = cljs.core.nth.call(null,inst_5213,(0),null);
var inst_5215 = cljs.core.nth.call(null,inst_5213,(1),null);
var state_5325__$1 = (function (){var statearr_5397 = state_5325;
(statearr_5397[(26)] = inst_5214);

return statearr_5397;
})();
if(cljs.core.truth_(inst_5215)){
var statearr_5398_5458 = state_5325__$1;
(statearr_5398_5458[(1)] = (13));

} else {
var statearr_5399_5459 = state_5325__$1;
(statearr_5399_5459[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (18))){
var inst_5250 = (state_5325[(2)]);
var state_5325__$1 = state_5325;
var statearr_5400_5460 = state_5325__$1;
(statearr_5400_5460[(2)] = inst_5250);

(statearr_5400_5460[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (42))){
var state_5325__$1 = state_5325;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5325__$1,(45),dchan);
} else {
if((state_val_5326 === (37))){
var inst_5193 = (state_5325[(9)]);
var inst_5293 = (state_5325[(23)]);
var inst_5284 = (state_5325[(25)]);
var inst_5293__$1 = cljs.core.first.call(null,inst_5284);
var inst_5294 = cljs.core.async.put_BANG_.call(null,inst_5293__$1,inst_5193,done);
var state_5325__$1 = (function (){var statearr_5401 = state_5325;
(statearr_5401[(23)] = inst_5293__$1);

return statearr_5401;
})();
if(cljs.core.truth_(inst_5294)){
var statearr_5402_5461 = state_5325__$1;
(statearr_5402_5461[(1)] = (39));

} else {
var statearr_5403_5462 = state_5325__$1;
(statearr_5403_5462[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5326 === (8))){
var inst_5205 = (state_5325[(15)]);
var inst_5204 = (state_5325[(16)]);
var inst_5207 = (inst_5205 < inst_5204);
var inst_5208 = inst_5207;
var state_5325__$1 = state_5325;
if(cljs.core.truth_(inst_5208)){
var statearr_5404_5463 = state_5325__$1;
(statearr_5404_5463[(1)] = (10));

} else {
var statearr_5405_5464 = state_5325__$1;
(statearr_5405_5464[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___5410,cs,m,dchan,dctr,done))
;
return ((function (switch__4517__auto__,c__4605__auto___5410,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__4518__auto__ = null;
var cljs$core$async$mult_$_state_machine__4518__auto____0 = (function (){
var statearr_5406 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5406[(0)] = cljs$core$async$mult_$_state_machine__4518__auto__);

(statearr_5406[(1)] = (1));

return statearr_5406;
});
var cljs$core$async$mult_$_state_machine__4518__auto____1 = (function (state_5325){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5325);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5407){if((e5407 instanceof Object)){
var ex__4521__auto__ = e5407;
var statearr_5408_5465 = state_5325;
(statearr_5408_5465[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5325);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5407;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5466 = state_5325;
state_5325 = G__5466;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__4518__auto__ = function(state_5325){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__4518__auto____1.call(this,state_5325);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mult_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__4518__auto____0;
cljs$core$async$mult_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__4518__auto____1;
return cljs$core$async$mult_$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___5410,cs,m,dchan,dctr,done))
})();
var state__4607__auto__ = (function (){var statearr_5409 = f__4606__auto__.call(null);
(statearr_5409[(6)] = c__4605__auto___5410);

return statearr_5409;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___5410,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__5468 = arguments.length;
switch (G__5468) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m);
} else {
var m__4212__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,state_map);
} else {
var m__4212__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,mode);
} else {
var m__4212__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4502__auto__ = [];
var len__4499__auto___5480 = arguments.length;
var i__4500__auto___5481 = (0);
while(true){
if((i__4500__auto___5481 < len__4499__auto___5480)){
args__4502__auto__.push((arguments[i__4500__auto___5481]));

var G__5482 = (i__4500__auto___5481 + (1));
i__4500__auto___5481 = G__5482;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((3) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4503__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__5474){
var map__5475 = p__5474;
var map__5475__$1 = ((((!((map__5475 == null)))?(((((map__5475.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__5475.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__5475):map__5475);
var opts = map__5475__$1;
var statearr_5477_5483 = state;
(statearr_5477_5483[(1)] = cont_block);


var temp__4657__auto__ = cljs.core.async.do_alts.call(null,((function (map__5475,map__5475__$1,opts){
return (function (val){
var statearr_5478_5484 = state;
(statearr_5478_5484[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__5475,map__5475__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__4657__auto__)){
var cb = temp__4657__auto__;
var statearr_5479_5485 = state;
(statearr_5479_5485[(2)] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq5470){
var G__5471 = cljs.core.first.call(null,seq5470);
var seq5470__$1 = cljs.core.next.call(null,seq5470);
var G__5472 = cljs.core.first.call(null,seq5470__$1);
var seq5470__$2 = cljs.core.next.call(null,seq5470__$1);
var G__5473 = cljs.core.first.call(null,seq5470__$2);
var seq5470__$3 = cljs.core.next.call(null,seq5470__$2);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__5471,G__5472,G__5473,seq5470__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,((((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos)))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async5486 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async5486 = (function (out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,meta5487){
this.out = out;
this.cs = cs;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.solo_mode = solo_mode;
this.change = change;
this.changed = changed;
this.pick = pick;
this.calc_state = calc_state;
this.meta5487 = meta5487;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_5488,meta5487__$1){
var self__ = this;
var _5488__$1 = this;
return (new cljs.core.async.t_cljs$core$async5486(self__.out,self__.cs,self__.solo_modes,self__.attrs,self__.solo_mode,self__.change,self__.changed,self__.pick,self__.calc_state,meta5487__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_5488){
var self__ = this;
var _5488__$1 = this;
return self__.meta5487;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error(["Assert failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join('')),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"meta5487","meta5487",18313602,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async5486.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async5486.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async5486";

cljs.core.async.t_cljs$core$async5486.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async5486");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async5486.
 */
cljs.core.async.__GT_t_cljs$core$async5486 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async5486(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta5487){
return (new cljs.core.async.t_cljs$core$async5486(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta5487));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async5486(out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__4605__auto___5650 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___5650,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___5650,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_5590){
var state_val_5591 = (state_5590[(1)]);
if((state_val_5591 === (7))){
var inst_5505 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
var statearr_5592_5651 = state_5590__$1;
(statearr_5592_5651[(2)] = inst_5505);

(statearr_5592_5651[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (20))){
var inst_5517 = (state_5590[(7)]);
var state_5590__$1 = state_5590;
var statearr_5593_5652 = state_5590__$1;
(statearr_5593_5652[(2)] = inst_5517);

(statearr_5593_5652[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (27))){
var state_5590__$1 = state_5590;
var statearr_5594_5653 = state_5590__$1;
(statearr_5594_5653[(2)] = null);

(statearr_5594_5653[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (1))){
var inst_5492 = (state_5590[(8)]);
var inst_5492__$1 = calc_state.call(null);
var inst_5494 = (inst_5492__$1 == null);
var inst_5495 = cljs.core.not.call(null,inst_5494);
var state_5590__$1 = (function (){var statearr_5595 = state_5590;
(statearr_5595[(8)] = inst_5492__$1);

return statearr_5595;
})();
if(inst_5495){
var statearr_5596_5654 = state_5590__$1;
(statearr_5596_5654[(1)] = (2));

} else {
var statearr_5597_5655 = state_5590__$1;
(statearr_5597_5655[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (24))){
var inst_5550 = (state_5590[(9)]);
var inst_5564 = (state_5590[(10)]);
var inst_5541 = (state_5590[(11)]);
var inst_5564__$1 = inst_5541.call(null,inst_5550);
var state_5590__$1 = (function (){var statearr_5598 = state_5590;
(statearr_5598[(10)] = inst_5564__$1);

return statearr_5598;
})();
if(cljs.core.truth_(inst_5564__$1)){
var statearr_5599_5656 = state_5590__$1;
(statearr_5599_5656[(1)] = (29));

} else {
var statearr_5600_5657 = state_5590__$1;
(statearr_5600_5657[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (4))){
var inst_5508 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
if(cljs.core.truth_(inst_5508)){
var statearr_5601_5658 = state_5590__$1;
(statearr_5601_5658[(1)] = (8));

} else {
var statearr_5602_5659 = state_5590__$1;
(statearr_5602_5659[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (15))){
var inst_5535 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
if(cljs.core.truth_(inst_5535)){
var statearr_5603_5660 = state_5590__$1;
(statearr_5603_5660[(1)] = (19));

} else {
var statearr_5604_5661 = state_5590__$1;
(statearr_5604_5661[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (21))){
var inst_5540 = (state_5590[(12)]);
var inst_5540__$1 = (state_5590[(2)]);
var inst_5541 = cljs.core.get.call(null,inst_5540__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_5542 = cljs.core.get.call(null,inst_5540__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_5543 = cljs.core.get.call(null,inst_5540__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_5590__$1 = (function (){var statearr_5605 = state_5590;
(statearr_5605[(12)] = inst_5540__$1);

(statearr_5605[(13)] = inst_5542);

(statearr_5605[(11)] = inst_5541);

return statearr_5605;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_5590__$1,(22),inst_5543);
} else {
if((state_val_5591 === (31))){
var inst_5572 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
if(cljs.core.truth_(inst_5572)){
var statearr_5606_5662 = state_5590__$1;
(statearr_5606_5662[(1)] = (32));

} else {
var statearr_5607_5663 = state_5590__$1;
(statearr_5607_5663[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (32))){
var inst_5549 = (state_5590[(14)]);
var state_5590__$1 = state_5590;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5590__$1,(35),out,inst_5549);
} else {
if((state_val_5591 === (33))){
var inst_5540 = (state_5590[(12)]);
var inst_5517 = inst_5540;
var state_5590__$1 = (function (){var statearr_5608 = state_5590;
(statearr_5608[(7)] = inst_5517);

return statearr_5608;
})();
var statearr_5609_5664 = state_5590__$1;
(statearr_5609_5664[(2)] = null);

(statearr_5609_5664[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (13))){
var inst_5517 = (state_5590[(7)]);
var inst_5524 = inst_5517.cljs$lang$protocol_mask$partition0$;
var inst_5525 = (inst_5524 & (64));
var inst_5526 = inst_5517.cljs$core$ISeq$;
var inst_5527 = (cljs.core.PROTOCOL_SENTINEL === inst_5526);
var inst_5528 = ((inst_5525) || (inst_5527));
var state_5590__$1 = state_5590;
if(cljs.core.truth_(inst_5528)){
var statearr_5610_5665 = state_5590__$1;
(statearr_5610_5665[(1)] = (16));

} else {
var statearr_5611_5666 = state_5590__$1;
(statearr_5611_5666[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (22))){
var inst_5550 = (state_5590[(9)]);
var inst_5549 = (state_5590[(14)]);
var inst_5548 = (state_5590[(2)]);
var inst_5549__$1 = cljs.core.nth.call(null,inst_5548,(0),null);
var inst_5550__$1 = cljs.core.nth.call(null,inst_5548,(1),null);
var inst_5551 = (inst_5549__$1 == null);
var inst_5552 = cljs.core._EQ_.call(null,inst_5550__$1,change);
var inst_5553 = ((inst_5551) || (inst_5552));
var state_5590__$1 = (function (){var statearr_5612 = state_5590;
(statearr_5612[(9)] = inst_5550__$1);

(statearr_5612[(14)] = inst_5549__$1);

return statearr_5612;
})();
if(cljs.core.truth_(inst_5553)){
var statearr_5613_5667 = state_5590__$1;
(statearr_5613_5667[(1)] = (23));

} else {
var statearr_5614_5668 = state_5590__$1;
(statearr_5614_5668[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (36))){
var inst_5540 = (state_5590[(12)]);
var inst_5517 = inst_5540;
var state_5590__$1 = (function (){var statearr_5615 = state_5590;
(statearr_5615[(7)] = inst_5517);

return statearr_5615;
})();
var statearr_5616_5669 = state_5590__$1;
(statearr_5616_5669[(2)] = null);

(statearr_5616_5669[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (29))){
var inst_5564 = (state_5590[(10)]);
var state_5590__$1 = state_5590;
var statearr_5617_5670 = state_5590__$1;
(statearr_5617_5670[(2)] = inst_5564);

(statearr_5617_5670[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (6))){
var state_5590__$1 = state_5590;
var statearr_5618_5671 = state_5590__$1;
(statearr_5618_5671[(2)] = false);

(statearr_5618_5671[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (28))){
var inst_5560 = (state_5590[(2)]);
var inst_5561 = calc_state.call(null);
var inst_5517 = inst_5561;
var state_5590__$1 = (function (){var statearr_5619 = state_5590;
(statearr_5619[(15)] = inst_5560);

(statearr_5619[(7)] = inst_5517);

return statearr_5619;
})();
var statearr_5620_5672 = state_5590__$1;
(statearr_5620_5672[(2)] = null);

(statearr_5620_5672[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (25))){
var inst_5586 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
var statearr_5621_5673 = state_5590__$1;
(statearr_5621_5673[(2)] = inst_5586);

(statearr_5621_5673[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (34))){
var inst_5584 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
var statearr_5622_5674 = state_5590__$1;
(statearr_5622_5674[(2)] = inst_5584);

(statearr_5622_5674[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (17))){
var state_5590__$1 = state_5590;
var statearr_5623_5675 = state_5590__$1;
(statearr_5623_5675[(2)] = false);

(statearr_5623_5675[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (3))){
var state_5590__$1 = state_5590;
var statearr_5624_5676 = state_5590__$1;
(statearr_5624_5676[(2)] = false);

(statearr_5624_5676[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (12))){
var inst_5588 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5590__$1,inst_5588);
} else {
if((state_val_5591 === (2))){
var inst_5492 = (state_5590[(8)]);
var inst_5497 = inst_5492.cljs$lang$protocol_mask$partition0$;
var inst_5498 = (inst_5497 & (64));
var inst_5499 = inst_5492.cljs$core$ISeq$;
var inst_5500 = (cljs.core.PROTOCOL_SENTINEL === inst_5499);
var inst_5501 = ((inst_5498) || (inst_5500));
var state_5590__$1 = state_5590;
if(cljs.core.truth_(inst_5501)){
var statearr_5625_5677 = state_5590__$1;
(statearr_5625_5677[(1)] = (5));

} else {
var statearr_5626_5678 = state_5590__$1;
(statearr_5626_5678[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (23))){
var inst_5549 = (state_5590[(14)]);
var inst_5555 = (inst_5549 == null);
var state_5590__$1 = state_5590;
if(cljs.core.truth_(inst_5555)){
var statearr_5627_5679 = state_5590__$1;
(statearr_5627_5679[(1)] = (26));

} else {
var statearr_5628_5680 = state_5590__$1;
(statearr_5628_5680[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (35))){
var inst_5575 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
if(cljs.core.truth_(inst_5575)){
var statearr_5629_5681 = state_5590__$1;
(statearr_5629_5681[(1)] = (36));

} else {
var statearr_5630_5682 = state_5590__$1;
(statearr_5630_5682[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (19))){
var inst_5517 = (state_5590[(7)]);
var inst_5537 = cljs.core.apply.call(null,cljs.core.hash_map,inst_5517);
var state_5590__$1 = state_5590;
var statearr_5631_5683 = state_5590__$1;
(statearr_5631_5683[(2)] = inst_5537);

(statearr_5631_5683[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (11))){
var inst_5517 = (state_5590[(7)]);
var inst_5521 = (inst_5517 == null);
var inst_5522 = cljs.core.not.call(null,inst_5521);
var state_5590__$1 = state_5590;
if(inst_5522){
var statearr_5632_5684 = state_5590__$1;
(statearr_5632_5684[(1)] = (13));

} else {
var statearr_5633_5685 = state_5590__$1;
(statearr_5633_5685[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (9))){
var inst_5492 = (state_5590[(8)]);
var state_5590__$1 = state_5590;
var statearr_5634_5686 = state_5590__$1;
(statearr_5634_5686[(2)] = inst_5492);

(statearr_5634_5686[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (5))){
var state_5590__$1 = state_5590;
var statearr_5635_5687 = state_5590__$1;
(statearr_5635_5687[(2)] = true);

(statearr_5635_5687[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (14))){
var state_5590__$1 = state_5590;
var statearr_5636_5688 = state_5590__$1;
(statearr_5636_5688[(2)] = false);

(statearr_5636_5688[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (26))){
var inst_5550 = (state_5590[(9)]);
var inst_5557 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_5550);
var state_5590__$1 = state_5590;
var statearr_5637_5689 = state_5590__$1;
(statearr_5637_5689[(2)] = inst_5557);

(statearr_5637_5689[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (16))){
var state_5590__$1 = state_5590;
var statearr_5638_5690 = state_5590__$1;
(statearr_5638_5690[(2)] = true);

(statearr_5638_5690[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (38))){
var inst_5580 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
var statearr_5639_5691 = state_5590__$1;
(statearr_5639_5691[(2)] = inst_5580);

(statearr_5639_5691[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (30))){
var inst_5550 = (state_5590[(9)]);
var inst_5542 = (state_5590[(13)]);
var inst_5541 = (state_5590[(11)]);
var inst_5567 = cljs.core.empty_QMARK_.call(null,inst_5541);
var inst_5568 = inst_5542.call(null,inst_5550);
var inst_5569 = cljs.core.not.call(null,inst_5568);
var inst_5570 = ((inst_5567) && (inst_5569));
var state_5590__$1 = state_5590;
var statearr_5640_5692 = state_5590__$1;
(statearr_5640_5692[(2)] = inst_5570);

(statearr_5640_5692[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (10))){
var inst_5492 = (state_5590[(8)]);
var inst_5513 = (state_5590[(2)]);
var inst_5514 = cljs.core.get.call(null,inst_5513,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_5515 = cljs.core.get.call(null,inst_5513,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_5516 = cljs.core.get.call(null,inst_5513,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_5517 = inst_5492;
var state_5590__$1 = (function (){var statearr_5641 = state_5590;
(statearr_5641[(16)] = inst_5515);

(statearr_5641[(17)] = inst_5516);

(statearr_5641[(7)] = inst_5517);

(statearr_5641[(18)] = inst_5514);

return statearr_5641;
})();
var statearr_5642_5693 = state_5590__$1;
(statearr_5642_5693[(2)] = null);

(statearr_5642_5693[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (18))){
var inst_5532 = (state_5590[(2)]);
var state_5590__$1 = state_5590;
var statearr_5643_5694 = state_5590__$1;
(statearr_5643_5694[(2)] = inst_5532);

(statearr_5643_5694[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (37))){
var state_5590__$1 = state_5590;
var statearr_5644_5695 = state_5590__$1;
(statearr_5644_5695[(2)] = null);

(statearr_5644_5695[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5591 === (8))){
var inst_5492 = (state_5590[(8)]);
var inst_5510 = cljs.core.apply.call(null,cljs.core.hash_map,inst_5492);
var state_5590__$1 = state_5590;
var statearr_5645_5696 = state_5590__$1;
(statearr_5645_5696[(2)] = inst_5510);

(statearr_5645_5696[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___5650,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__4517__auto__,c__4605__auto___5650,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__4518__auto__ = null;
var cljs$core$async$mix_$_state_machine__4518__auto____0 = (function (){
var statearr_5646 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5646[(0)] = cljs$core$async$mix_$_state_machine__4518__auto__);

(statearr_5646[(1)] = (1));

return statearr_5646;
});
var cljs$core$async$mix_$_state_machine__4518__auto____1 = (function (state_5590){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5590);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5647){if((e5647 instanceof Object)){
var ex__4521__auto__ = e5647;
var statearr_5648_5697 = state_5590;
(statearr_5648_5697[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5590);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5647;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5698 = state_5590;
state_5590 = G__5698;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__4518__auto__ = function(state_5590){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__4518__auto____1.call(this,state_5590);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mix_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__4518__auto____0;
cljs$core$async$mix_$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__4518__auto____1;
return cljs$core$async$mix_$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___5650,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__4607__auto__ = (function (){var statearr_5649 = f__4606__auto__.call(null);
(statearr_5649[(6)] = c__4605__auto___5650);

return statearr_5649;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___5650,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__4212__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__5700 = arguments.length;
switch (G__5700) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__5704 = arguments.length;
switch (G__5704) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__3922__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__3922__auto__,mults){
return (function (p1__5702_SHARP_){
if(cljs.core.truth_(p1__5702_SHARP_.call(null,topic))){
return p1__5702_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__5702_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__3922__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async5705 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async5705 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta5706){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta5706 = meta5706;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_5707,meta5706__$1){
var self__ = this;
var _5707__$1 = this;
return (new cljs.core.async.t_cljs$core$async5705(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta5706__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_5707){
var self__ = this;
var _5707__$1 = this;
return self__.meta5706;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__4657__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__4657__auto__)){
var m = temp__4657__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta5706","meta5706",1896224861,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async5705.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async5705.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async5705";

cljs.core.async.t_cljs$core$async5705.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async5705");
});})(mults,ensure_mult))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async5705.
 */
cljs.core.async.__GT_t_cljs$core$async5705 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async5705(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta5706){
return (new cljs.core.async.t_cljs$core$async5705(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta5706));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async5705(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__4605__auto___5825 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___5825,mults,ensure_mult,p){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___5825,mults,ensure_mult,p){
return (function (state_5779){
var state_val_5780 = (state_5779[(1)]);
if((state_val_5780 === (7))){
var inst_5775 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
var statearr_5781_5826 = state_5779__$1;
(statearr_5781_5826[(2)] = inst_5775);

(statearr_5781_5826[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (20))){
var state_5779__$1 = state_5779;
var statearr_5782_5827 = state_5779__$1;
(statearr_5782_5827[(2)] = null);

(statearr_5782_5827[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (1))){
var state_5779__$1 = state_5779;
var statearr_5783_5828 = state_5779__$1;
(statearr_5783_5828[(2)] = null);

(statearr_5783_5828[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (24))){
var inst_5758 = (state_5779[(7)]);
var inst_5767 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_5758);
var state_5779__$1 = state_5779;
var statearr_5784_5829 = state_5779__$1;
(statearr_5784_5829[(2)] = inst_5767);

(statearr_5784_5829[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (4))){
var inst_5710 = (state_5779[(8)]);
var inst_5710__$1 = (state_5779[(2)]);
var inst_5711 = (inst_5710__$1 == null);
var state_5779__$1 = (function (){var statearr_5785 = state_5779;
(statearr_5785[(8)] = inst_5710__$1);

return statearr_5785;
})();
if(cljs.core.truth_(inst_5711)){
var statearr_5786_5830 = state_5779__$1;
(statearr_5786_5830[(1)] = (5));

} else {
var statearr_5787_5831 = state_5779__$1;
(statearr_5787_5831[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (15))){
var inst_5752 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
var statearr_5788_5832 = state_5779__$1;
(statearr_5788_5832[(2)] = inst_5752);

(statearr_5788_5832[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (21))){
var inst_5772 = (state_5779[(2)]);
var state_5779__$1 = (function (){var statearr_5789 = state_5779;
(statearr_5789[(9)] = inst_5772);

return statearr_5789;
})();
var statearr_5790_5833 = state_5779__$1;
(statearr_5790_5833[(2)] = null);

(statearr_5790_5833[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (13))){
var inst_5734 = (state_5779[(10)]);
var inst_5736 = cljs.core.chunked_seq_QMARK_.call(null,inst_5734);
var state_5779__$1 = state_5779;
if(inst_5736){
var statearr_5791_5834 = state_5779__$1;
(statearr_5791_5834[(1)] = (16));

} else {
var statearr_5792_5835 = state_5779__$1;
(statearr_5792_5835[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (22))){
var inst_5764 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
if(cljs.core.truth_(inst_5764)){
var statearr_5793_5836 = state_5779__$1;
(statearr_5793_5836[(1)] = (23));

} else {
var statearr_5794_5837 = state_5779__$1;
(statearr_5794_5837[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (6))){
var inst_5758 = (state_5779[(7)]);
var inst_5710 = (state_5779[(8)]);
var inst_5760 = (state_5779[(11)]);
var inst_5758__$1 = topic_fn.call(null,inst_5710);
var inst_5759 = cljs.core.deref.call(null,mults);
var inst_5760__$1 = cljs.core.get.call(null,inst_5759,inst_5758__$1);
var state_5779__$1 = (function (){var statearr_5795 = state_5779;
(statearr_5795[(7)] = inst_5758__$1);

(statearr_5795[(11)] = inst_5760__$1);

return statearr_5795;
})();
if(cljs.core.truth_(inst_5760__$1)){
var statearr_5796_5838 = state_5779__$1;
(statearr_5796_5838[(1)] = (19));

} else {
var statearr_5797_5839 = state_5779__$1;
(statearr_5797_5839[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (25))){
var inst_5769 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
var statearr_5798_5840 = state_5779__$1;
(statearr_5798_5840[(2)] = inst_5769);

(statearr_5798_5840[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (17))){
var inst_5734 = (state_5779[(10)]);
var inst_5743 = cljs.core.first.call(null,inst_5734);
var inst_5744 = cljs.core.async.muxch_STAR_.call(null,inst_5743);
var inst_5745 = cljs.core.async.close_BANG_.call(null,inst_5744);
var inst_5746 = cljs.core.next.call(null,inst_5734);
var inst_5720 = inst_5746;
var inst_5721 = null;
var inst_5722 = (0);
var inst_5723 = (0);
var state_5779__$1 = (function (){var statearr_5799 = state_5779;
(statearr_5799[(12)] = inst_5723);

(statearr_5799[(13)] = inst_5720);

(statearr_5799[(14)] = inst_5722);

(statearr_5799[(15)] = inst_5745);

(statearr_5799[(16)] = inst_5721);

return statearr_5799;
})();
var statearr_5800_5841 = state_5779__$1;
(statearr_5800_5841[(2)] = null);

(statearr_5800_5841[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (3))){
var inst_5777 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5779__$1,inst_5777);
} else {
if((state_val_5780 === (12))){
var inst_5754 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
var statearr_5801_5842 = state_5779__$1;
(statearr_5801_5842[(2)] = inst_5754);

(statearr_5801_5842[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (2))){
var state_5779__$1 = state_5779;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5779__$1,(4),ch);
} else {
if((state_val_5780 === (23))){
var state_5779__$1 = state_5779;
var statearr_5802_5843 = state_5779__$1;
(statearr_5802_5843[(2)] = null);

(statearr_5802_5843[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (19))){
var inst_5710 = (state_5779[(8)]);
var inst_5760 = (state_5779[(11)]);
var inst_5762 = cljs.core.async.muxch_STAR_.call(null,inst_5760);
var state_5779__$1 = state_5779;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5779__$1,(22),inst_5762,inst_5710);
} else {
if((state_val_5780 === (11))){
var inst_5734 = (state_5779[(10)]);
var inst_5720 = (state_5779[(13)]);
var inst_5734__$1 = cljs.core.seq.call(null,inst_5720);
var state_5779__$1 = (function (){var statearr_5803 = state_5779;
(statearr_5803[(10)] = inst_5734__$1);

return statearr_5803;
})();
if(inst_5734__$1){
var statearr_5804_5844 = state_5779__$1;
(statearr_5804_5844[(1)] = (13));

} else {
var statearr_5805_5845 = state_5779__$1;
(statearr_5805_5845[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (9))){
var inst_5756 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
var statearr_5806_5846 = state_5779__$1;
(statearr_5806_5846[(2)] = inst_5756);

(statearr_5806_5846[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (5))){
var inst_5717 = cljs.core.deref.call(null,mults);
var inst_5718 = cljs.core.vals.call(null,inst_5717);
var inst_5719 = cljs.core.seq.call(null,inst_5718);
var inst_5720 = inst_5719;
var inst_5721 = null;
var inst_5722 = (0);
var inst_5723 = (0);
var state_5779__$1 = (function (){var statearr_5807 = state_5779;
(statearr_5807[(12)] = inst_5723);

(statearr_5807[(13)] = inst_5720);

(statearr_5807[(14)] = inst_5722);

(statearr_5807[(16)] = inst_5721);

return statearr_5807;
})();
var statearr_5808_5847 = state_5779__$1;
(statearr_5808_5847[(2)] = null);

(statearr_5808_5847[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (14))){
var state_5779__$1 = state_5779;
var statearr_5812_5848 = state_5779__$1;
(statearr_5812_5848[(2)] = null);

(statearr_5812_5848[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (16))){
var inst_5734 = (state_5779[(10)]);
var inst_5738 = cljs.core.chunk_first.call(null,inst_5734);
var inst_5739 = cljs.core.chunk_rest.call(null,inst_5734);
var inst_5740 = cljs.core.count.call(null,inst_5738);
var inst_5720 = inst_5739;
var inst_5721 = inst_5738;
var inst_5722 = inst_5740;
var inst_5723 = (0);
var state_5779__$1 = (function (){var statearr_5813 = state_5779;
(statearr_5813[(12)] = inst_5723);

(statearr_5813[(13)] = inst_5720);

(statearr_5813[(14)] = inst_5722);

(statearr_5813[(16)] = inst_5721);

return statearr_5813;
})();
var statearr_5814_5849 = state_5779__$1;
(statearr_5814_5849[(2)] = null);

(statearr_5814_5849[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (10))){
var inst_5723 = (state_5779[(12)]);
var inst_5720 = (state_5779[(13)]);
var inst_5722 = (state_5779[(14)]);
var inst_5721 = (state_5779[(16)]);
var inst_5728 = cljs.core._nth.call(null,inst_5721,inst_5723);
var inst_5729 = cljs.core.async.muxch_STAR_.call(null,inst_5728);
var inst_5730 = cljs.core.async.close_BANG_.call(null,inst_5729);
var inst_5731 = (inst_5723 + (1));
var tmp5809 = inst_5720;
var tmp5810 = inst_5722;
var tmp5811 = inst_5721;
var inst_5720__$1 = tmp5809;
var inst_5721__$1 = tmp5811;
var inst_5722__$1 = tmp5810;
var inst_5723__$1 = inst_5731;
var state_5779__$1 = (function (){var statearr_5815 = state_5779;
(statearr_5815[(12)] = inst_5723__$1);

(statearr_5815[(13)] = inst_5720__$1);

(statearr_5815[(17)] = inst_5730);

(statearr_5815[(14)] = inst_5722__$1);

(statearr_5815[(16)] = inst_5721__$1);

return statearr_5815;
})();
var statearr_5816_5850 = state_5779__$1;
(statearr_5816_5850[(2)] = null);

(statearr_5816_5850[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (18))){
var inst_5749 = (state_5779[(2)]);
var state_5779__$1 = state_5779;
var statearr_5817_5851 = state_5779__$1;
(statearr_5817_5851[(2)] = inst_5749);

(statearr_5817_5851[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5780 === (8))){
var inst_5723 = (state_5779[(12)]);
var inst_5722 = (state_5779[(14)]);
var inst_5725 = (inst_5723 < inst_5722);
var inst_5726 = inst_5725;
var state_5779__$1 = state_5779;
if(cljs.core.truth_(inst_5726)){
var statearr_5818_5852 = state_5779__$1;
(statearr_5818_5852[(1)] = (10));

} else {
var statearr_5819_5853 = state_5779__$1;
(statearr_5819_5853[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___5825,mults,ensure_mult,p))
;
return ((function (switch__4517__auto__,c__4605__auto___5825,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_5820 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5820[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_5820[(1)] = (1));

return statearr_5820;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_5779){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5779);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5821){if((e5821 instanceof Object)){
var ex__4521__auto__ = e5821;
var statearr_5822_5854 = state_5779;
(statearr_5822_5854[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5779);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5821;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5855 = state_5779;
state_5779 = G__5855;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_5779){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_5779);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___5825,mults,ensure_mult,p))
})();
var state__4607__auto__ = (function (){var statearr_5823 = f__4606__auto__.call(null);
(statearr_5823[(6)] = c__4605__auto___5825);

return statearr_5823;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___5825,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__5857 = arguments.length;
switch (G__5857) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__5860 = arguments.length;
switch (G__5860) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__5863 = arguments.length;
switch (G__5863) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__4605__auto___5930 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___5930,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___5930,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_5902){
var state_val_5903 = (state_5902[(1)]);
if((state_val_5903 === (7))){
var state_5902__$1 = state_5902;
var statearr_5904_5931 = state_5902__$1;
(statearr_5904_5931[(2)] = null);

(statearr_5904_5931[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (1))){
var state_5902__$1 = state_5902;
var statearr_5905_5932 = state_5902__$1;
(statearr_5905_5932[(2)] = null);

(statearr_5905_5932[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (4))){
var inst_5866 = (state_5902[(7)]);
var inst_5868 = (inst_5866 < cnt);
var state_5902__$1 = state_5902;
if(cljs.core.truth_(inst_5868)){
var statearr_5906_5933 = state_5902__$1;
(statearr_5906_5933[(1)] = (6));

} else {
var statearr_5907_5934 = state_5902__$1;
(statearr_5907_5934[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (15))){
var inst_5898 = (state_5902[(2)]);
var state_5902__$1 = state_5902;
var statearr_5908_5935 = state_5902__$1;
(statearr_5908_5935[(2)] = inst_5898);

(statearr_5908_5935[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (13))){
var inst_5891 = cljs.core.async.close_BANG_.call(null,out);
var state_5902__$1 = state_5902;
var statearr_5909_5936 = state_5902__$1;
(statearr_5909_5936[(2)] = inst_5891);

(statearr_5909_5936[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (6))){
var state_5902__$1 = state_5902;
var statearr_5910_5937 = state_5902__$1;
(statearr_5910_5937[(2)] = null);

(statearr_5910_5937[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (3))){
var inst_5900 = (state_5902[(2)]);
var state_5902__$1 = state_5902;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5902__$1,inst_5900);
} else {
if((state_val_5903 === (12))){
var inst_5888 = (state_5902[(8)]);
var inst_5888__$1 = (state_5902[(2)]);
var inst_5889 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_5888__$1);
var state_5902__$1 = (function (){var statearr_5911 = state_5902;
(statearr_5911[(8)] = inst_5888__$1);

return statearr_5911;
})();
if(cljs.core.truth_(inst_5889)){
var statearr_5912_5938 = state_5902__$1;
(statearr_5912_5938[(1)] = (13));

} else {
var statearr_5913_5939 = state_5902__$1;
(statearr_5913_5939[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (2))){
var inst_5865 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_5866 = (0);
var state_5902__$1 = (function (){var statearr_5914 = state_5902;
(statearr_5914[(7)] = inst_5866);

(statearr_5914[(9)] = inst_5865);

return statearr_5914;
})();
var statearr_5915_5940 = state_5902__$1;
(statearr_5915_5940[(2)] = null);

(statearr_5915_5940[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (11))){
var inst_5866 = (state_5902[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_5902,(10),Object,null,(9));
var inst_5875 = chs__$1.call(null,inst_5866);
var inst_5876 = done.call(null,inst_5866);
var inst_5877 = cljs.core.async.take_BANG_.call(null,inst_5875,inst_5876);
var state_5902__$1 = state_5902;
var statearr_5916_5941 = state_5902__$1;
(statearr_5916_5941[(2)] = inst_5877);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5902__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (9))){
var inst_5866 = (state_5902[(7)]);
var inst_5879 = (state_5902[(2)]);
var inst_5880 = (inst_5866 + (1));
var inst_5866__$1 = inst_5880;
var state_5902__$1 = (function (){var statearr_5917 = state_5902;
(statearr_5917[(10)] = inst_5879);

(statearr_5917[(7)] = inst_5866__$1);

return statearr_5917;
})();
var statearr_5918_5942 = state_5902__$1;
(statearr_5918_5942[(2)] = null);

(statearr_5918_5942[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (5))){
var inst_5886 = (state_5902[(2)]);
var state_5902__$1 = (function (){var statearr_5919 = state_5902;
(statearr_5919[(11)] = inst_5886);

return statearr_5919;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5902__$1,(12),dchan);
} else {
if((state_val_5903 === (14))){
var inst_5888 = (state_5902[(8)]);
var inst_5893 = cljs.core.apply.call(null,f,inst_5888);
var state_5902__$1 = state_5902;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5902__$1,(16),out,inst_5893);
} else {
if((state_val_5903 === (16))){
var inst_5895 = (state_5902[(2)]);
var state_5902__$1 = (function (){var statearr_5920 = state_5902;
(statearr_5920[(12)] = inst_5895);

return statearr_5920;
})();
var statearr_5921_5943 = state_5902__$1;
(statearr_5921_5943[(2)] = null);

(statearr_5921_5943[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (10))){
var inst_5870 = (state_5902[(2)]);
var inst_5871 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_5902__$1 = (function (){var statearr_5922 = state_5902;
(statearr_5922[(13)] = inst_5870);

return statearr_5922;
})();
var statearr_5923_5944 = state_5902__$1;
(statearr_5923_5944[(2)] = inst_5871);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5902__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5903 === (8))){
var inst_5884 = (state_5902[(2)]);
var state_5902__$1 = state_5902;
var statearr_5924_5945 = state_5902__$1;
(statearr_5924_5945[(2)] = inst_5884);

(statearr_5924_5945[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___5930,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__4517__auto__,c__4605__auto___5930,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_5925 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5925[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_5925[(1)] = (1));

return statearr_5925;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_5902){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5902);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e5926){if((e5926 instanceof Object)){
var ex__4521__auto__ = e5926;
var statearr_5927_5946 = state_5902;
(statearr_5927_5946[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5902);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5926;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5947 = state_5902;
state_5902 = G__5947;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_5902){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_5902);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___5930,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__4607__auto__ = (function (){var statearr_5928 = f__4606__auto__.call(null);
(statearr_5928[(6)] = c__4605__auto___5930);

return statearr_5928;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___5930,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__5950 = arguments.length;
switch (G__5950) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__4605__auto___6004 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___6004,out){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___6004,out){
return (function (state_5982){
var state_val_5983 = (state_5982[(1)]);
if((state_val_5983 === (7))){
var inst_5962 = (state_5982[(7)]);
var inst_5961 = (state_5982[(8)]);
var inst_5961__$1 = (state_5982[(2)]);
var inst_5962__$1 = cljs.core.nth.call(null,inst_5961__$1,(0),null);
var inst_5963 = cljs.core.nth.call(null,inst_5961__$1,(1),null);
var inst_5964 = (inst_5962__$1 == null);
var state_5982__$1 = (function (){var statearr_5984 = state_5982;
(statearr_5984[(7)] = inst_5962__$1);

(statearr_5984[(9)] = inst_5963);

(statearr_5984[(8)] = inst_5961__$1);

return statearr_5984;
})();
if(cljs.core.truth_(inst_5964)){
var statearr_5985_6005 = state_5982__$1;
(statearr_5985_6005[(1)] = (8));

} else {
var statearr_5986_6006 = state_5982__$1;
(statearr_5986_6006[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5983 === (1))){
var inst_5951 = cljs.core.vec.call(null,chs);
var inst_5952 = inst_5951;
var state_5982__$1 = (function (){var statearr_5987 = state_5982;
(statearr_5987[(10)] = inst_5952);

return statearr_5987;
})();
var statearr_5988_6007 = state_5982__$1;
(statearr_5988_6007[(2)] = null);

(statearr_5988_6007[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5983 === (4))){
var inst_5952 = (state_5982[(10)]);
var state_5982__$1 = state_5982;
return cljs.core.async.ioc_alts_BANG_.call(null,state_5982__$1,(7),inst_5952);
} else {
if((state_val_5983 === (6))){
var inst_5978 = (state_5982[(2)]);
var state_5982__$1 = state_5982;
var statearr_5989_6008 = state_5982__$1;
(statearr_5989_6008[(2)] = inst_5978);

(statearr_5989_6008[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5983 === (3))){
var inst_5980 = (state_5982[(2)]);
var state_5982__$1 = state_5982;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5982__$1,inst_5980);
} else {
if((state_val_5983 === (2))){
var inst_5952 = (state_5982[(10)]);
var inst_5954 = cljs.core.count.call(null,inst_5952);
var inst_5955 = (inst_5954 > (0));
var state_5982__$1 = state_5982;
if(cljs.core.truth_(inst_5955)){
var statearr_5991_6009 = state_5982__$1;
(statearr_5991_6009[(1)] = (4));

} else {
var statearr_5992_6010 = state_5982__$1;
(statearr_5992_6010[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5983 === (11))){
var inst_5952 = (state_5982[(10)]);
var inst_5971 = (state_5982[(2)]);
var tmp5990 = inst_5952;
var inst_5952__$1 = tmp5990;
var state_5982__$1 = (function (){var statearr_5993 = state_5982;
(statearr_5993[(10)] = inst_5952__$1);

(statearr_5993[(11)] = inst_5971);

return statearr_5993;
})();
var statearr_5994_6011 = state_5982__$1;
(statearr_5994_6011[(2)] = null);

(statearr_5994_6011[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5983 === (9))){
var inst_5962 = (state_5982[(7)]);
var state_5982__$1 = state_5982;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5982__$1,(11),out,inst_5962);
} else {
if((state_val_5983 === (5))){
var inst_5976 = cljs.core.async.close_BANG_.call(null,out);
var state_5982__$1 = state_5982;
var statearr_5995_6012 = state_5982__$1;
(statearr_5995_6012[(2)] = inst_5976);

(statearr_5995_6012[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5983 === (10))){
var inst_5974 = (state_5982[(2)]);
var state_5982__$1 = state_5982;
var statearr_5996_6013 = state_5982__$1;
(statearr_5996_6013[(2)] = inst_5974);

(statearr_5996_6013[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5983 === (8))){
var inst_5952 = (state_5982[(10)]);
var inst_5962 = (state_5982[(7)]);
var inst_5963 = (state_5982[(9)]);
var inst_5961 = (state_5982[(8)]);
var inst_5966 = (function (){var cs = inst_5952;
var vec__5957 = inst_5961;
var v = inst_5962;
var c = inst_5963;
return ((function (cs,vec__5957,v,c,inst_5952,inst_5962,inst_5963,inst_5961,state_val_5983,c__4605__auto___6004,out){
return (function (p1__5948_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__5948_SHARP_);
});
;})(cs,vec__5957,v,c,inst_5952,inst_5962,inst_5963,inst_5961,state_val_5983,c__4605__auto___6004,out))
})();
var inst_5967 = cljs.core.filterv.call(null,inst_5966,inst_5952);
var inst_5952__$1 = inst_5967;
var state_5982__$1 = (function (){var statearr_5997 = state_5982;
(statearr_5997[(10)] = inst_5952__$1);

return statearr_5997;
})();
var statearr_5998_6014 = state_5982__$1;
(statearr_5998_6014[(2)] = null);

(statearr_5998_6014[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___6004,out))
;
return ((function (switch__4517__auto__,c__4605__auto___6004,out){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_5999 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5999[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_5999[(1)] = (1));

return statearr_5999;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_5982){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_5982);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6000){if((e6000 instanceof Object)){
var ex__4521__auto__ = e6000;
var statearr_6001_6015 = state_5982;
(statearr_6001_6015[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5982);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6000;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6016 = state_5982;
state_5982 = G__6016;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_5982){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_5982);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___6004,out))
})();
var state__4607__auto__ = (function (){var statearr_6002 = f__4606__auto__.call(null);
(statearr_6002[(6)] = c__4605__auto___6004);

return statearr_6002;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___6004,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__6018 = arguments.length;
switch (G__6018) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__4605__auto___6063 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___6063,out){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___6063,out){
return (function (state_6042){
var state_val_6043 = (state_6042[(1)]);
if((state_val_6043 === (7))){
var inst_6024 = (state_6042[(7)]);
var inst_6024__$1 = (state_6042[(2)]);
var inst_6025 = (inst_6024__$1 == null);
var inst_6026 = cljs.core.not.call(null,inst_6025);
var state_6042__$1 = (function (){var statearr_6044 = state_6042;
(statearr_6044[(7)] = inst_6024__$1);

return statearr_6044;
})();
if(inst_6026){
var statearr_6045_6064 = state_6042__$1;
(statearr_6045_6064[(1)] = (8));

} else {
var statearr_6046_6065 = state_6042__$1;
(statearr_6046_6065[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (1))){
var inst_6019 = (0);
var state_6042__$1 = (function (){var statearr_6047 = state_6042;
(statearr_6047[(8)] = inst_6019);

return statearr_6047;
})();
var statearr_6048_6066 = state_6042__$1;
(statearr_6048_6066[(2)] = null);

(statearr_6048_6066[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (4))){
var state_6042__$1 = state_6042;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6042__$1,(7),ch);
} else {
if((state_val_6043 === (6))){
var inst_6037 = (state_6042[(2)]);
var state_6042__$1 = state_6042;
var statearr_6049_6067 = state_6042__$1;
(statearr_6049_6067[(2)] = inst_6037);

(statearr_6049_6067[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (3))){
var inst_6039 = (state_6042[(2)]);
var inst_6040 = cljs.core.async.close_BANG_.call(null,out);
var state_6042__$1 = (function (){var statearr_6050 = state_6042;
(statearr_6050[(9)] = inst_6039);

return statearr_6050;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6042__$1,inst_6040);
} else {
if((state_val_6043 === (2))){
var inst_6019 = (state_6042[(8)]);
var inst_6021 = (inst_6019 < n);
var state_6042__$1 = state_6042;
if(cljs.core.truth_(inst_6021)){
var statearr_6051_6068 = state_6042__$1;
(statearr_6051_6068[(1)] = (4));

} else {
var statearr_6052_6069 = state_6042__$1;
(statearr_6052_6069[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (11))){
var inst_6019 = (state_6042[(8)]);
var inst_6029 = (state_6042[(2)]);
var inst_6030 = (inst_6019 + (1));
var inst_6019__$1 = inst_6030;
var state_6042__$1 = (function (){var statearr_6053 = state_6042;
(statearr_6053[(8)] = inst_6019__$1);

(statearr_6053[(10)] = inst_6029);

return statearr_6053;
})();
var statearr_6054_6070 = state_6042__$1;
(statearr_6054_6070[(2)] = null);

(statearr_6054_6070[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (9))){
var state_6042__$1 = state_6042;
var statearr_6055_6071 = state_6042__$1;
(statearr_6055_6071[(2)] = null);

(statearr_6055_6071[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (5))){
var state_6042__$1 = state_6042;
var statearr_6056_6072 = state_6042__$1;
(statearr_6056_6072[(2)] = null);

(statearr_6056_6072[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (10))){
var inst_6034 = (state_6042[(2)]);
var state_6042__$1 = state_6042;
var statearr_6057_6073 = state_6042__$1;
(statearr_6057_6073[(2)] = inst_6034);

(statearr_6057_6073[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6043 === (8))){
var inst_6024 = (state_6042[(7)]);
var state_6042__$1 = state_6042;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6042__$1,(11),out,inst_6024);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___6063,out))
;
return ((function (switch__4517__auto__,c__4605__auto___6063,out){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_6058 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_6058[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_6058[(1)] = (1));

return statearr_6058;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_6042){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_6042);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6059){if((e6059 instanceof Object)){
var ex__4521__auto__ = e6059;
var statearr_6060_6074 = state_6042;
(statearr_6060_6074[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6042);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6059;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6075 = state_6042;
state_6042 = G__6075;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_6042){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_6042);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___6063,out))
})();
var state__4607__auto__ = (function (){var statearr_6061 = f__4606__auto__.call(null);
(statearr_6061[(6)] = c__4605__auto___6063);

return statearr_6061;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___6063,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async6077 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async6077 = (function (f,ch,meta6078){
this.f = f;
this.ch = ch;
this.meta6078 = meta6078;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_6079,meta6078__$1){
var self__ = this;
var _6079__$1 = this;
return (new cljs.core.async.t_cljs$core$async6077(self__.f,self__.ch,meta6078__$1));
});

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_6079){
var self__ = this;
var _6079__$1 = this;
return self__.meta6078;
});

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async6080 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async6080 = (function (f,ch,meta6078,_,fn1,meta6081){
this.f = f;
this.ch = ch;
this.meta6078 = meta6078;
this._ = _;
this.fn1 = fn1;
this.meta6081 = meta6081;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async6080.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_6082,meta6081__$1){
var self__ = this;
var _6082__$1 = this;
return (new cljs.core.async.t_cljs$core$async6080(self__.f,self__.ch,self__.meta6078,self__._,self__.fn1,meta6081__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async6080.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_6082){
var self__ = this;
var _6082__$1 = this;
return self__.meta6081;
});})(___$1))
;

cljs.core.async.t_cljs$core$async6080.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6080.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async6080.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async6080.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__6076_SHARP_){
return f1.call(null,(((p1__6076_SHARP_ == null))?null:self__.f.call(null,p1__6076_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async6080.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta6078","meta6078",-11882061,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async6077","cljs.core.async/t_cljs$core$async6077",-1328509469,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta6081","meta6081",1504573225,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async6080.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async6080.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async6080";

cljs.core.async.t_cljs$core$async6080.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async6080");
});})(___$1))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async6080.
 */
cljs.core.async.__GT_t_cljs$core$async6080 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async6080(f__$1,ch__$1,meta6078__$1,___$2,fn1__$1,meta6081){
return (new cljs.core.async.t_cljs$core$async6080(f__$1,ch__$1,meta6078__$1,___$2,fn1__$1,meta6081));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async6080(self__.f,self__.ch,self__.meta6078,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__3911__auto__ = ret;
if(cljs.core.truth_(and__3911__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__3911__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6077.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async6077.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta6078","meta6078",-11882061,null)], null);
});

cljs.core.async.t_cljs$core$async6077.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async6077.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async6077";

cljs.core.async.t_cljs$core$async6077.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async6077");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async6077.
 */
cljs.core.async.__GT_t_cljs$core$async6077 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async6077(f__$1,ch__$1,meta6078){
return (new cljs.core.async.t_cljs$core$async6077(f__$1,ch__$1,meta6078));
});

}

return (new cljs.core.async.t_cljs$core$async6077(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async6083 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async6083 = (function (f,ch,meta6084){
this.f = f;
this.ch = ch;
this.meta6084 = meta6084;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_6085,meta6084__$1){
var self__ = this;
var _6085__$1 = this;
return (new cljs.core.async.t_cljs$core$async6083(self__.f,self__.ch,meta6084__$1));
});

cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_6085){
var self__ = this;
var _6085__$1 = this;
return self__.meta6084;
});

cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6083.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async6083.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta6084","meta6084",-1333697018,null)], null);
});

cljs.core.async.t_cljs$core$async6083.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async6083.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async6083";

cljs.core.async.t_cljs$core$async6083.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async6083");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async6083.
 */
cljs.core.async.__GT_t_cljs$core$async6083 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async6083(f__$1,ch__$1,meta6084){
return (new cljs.core.async.t_cljs$core$async6083(f__$1,ch__$1,meta6084));
});

}

return (new cljs.core.async.t_cljs$core$async6083(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async6086 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async6086 = (function (p,ch,meta6087){
this.p = p;
this.ch = ch;
this.meta6087 = meta6087;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_6088,meta6087__$1){
var self__ = this;
var _6088__$1 = this;
return (new cljs.core.async.t_cljs$core$async6086(self__.p,self__.ch,meta6087__$1));
});

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_6088){
var self__ = this;
var _6088__$1 = this;
return self__.meta6087;
});

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async6086.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async6086.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta6087","meta6087",-836630545,null)], null);
});

cljs.core.async.t_cljs$core$async6086.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async6086.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async6086";

cljs.core.async.t_cljs$core$async6086.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async6086");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async6086.
 */
cljs.core.async.__GT_t_cljs$core$async6086 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async6086(p__$1,ch__$1,meta6087){
return (new cljs.core.async.t_cljs$core$async6086(p__$1,ch__$1,meta6087));
});

}

return (new cljs.core.async.t_cljs$core$async6086(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__6090 = arguments.length;
switch (G__6090) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__4605__auto___6130 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___6130,out){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___6130,out){
return (function (state_6111){
var state_val_6112 = (state_6111[(1)]);
if((state_val_6112 === (7))){
var inst_6107 = (state_6111[(2)]);
var state_6111__$1 = state_6111;
var statearr_6113_6131 = state_6111__$1;
(statearr_6113_6131[(2)] = inst_6107);

(statearr_6113_6131[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (1))){
var state_6111__$1 = state_6111;
var statearr_6114_6132 = state_6111__$1;
(statearr_6114_6132[(2)] = null);

(statearr_6114_6132[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (4))){
var inst_6093 = (state_6111[(7)]);
var inst_6093__$1 = (state_6111[(2)]);
var inst_6094 = (inst_6093__$1 == null);
var state_6111__$1 = (function (){var statearr_6115 = state_6111;
(statearr_6115[(7)] = inst_6093__$1);

return statearr_6115;
})();
if(cljs.core.truth_(inst_6094)){
var statearr_6116_6133 = state_6111__$1;
(statearr_6116_6133[(1)] = (5));

} else {
var statearr_6117_6134 = state_6111__$1;
(statearr_6117_6134[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (6))){
var inst_6093 = (state_6111[(7)]);
var inst_6098 = p.call(null,inst_6093);
var state_6111__$1 = state_6111;
if(cljs.core.truth_(inst_6098)){
var statearr_6118_6135 = state_6111__$1;
(statearr_6118_6135[(1)] = (8));

} else {
var statearr_6119_6136 = state_6111__$1;
(statearr_6119_6136[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (3))){
var inst_6109 = (state_6111[(2)]);
var state_6111__$1 = state_6111;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6111__$1,inst_6109);
} else {
if((state_val_6112 === (2))){
var state_6111__$1 = state_6111;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6111__$1,(4),ch);
} else {
if((state_val_6112 === (11))){
var inst_6101 = (state_6111[(2)]);
var state_6111__$1 = state_6111;
var statearr_6120_6137 = state_6111__$1;
(statearr_6120_6137[(2)] = inst_6101);

(statearr_6120_6137[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (9))){
var state_6111__$1 = state_6111;
var statearr_6121_6138 = state_6111__$1;
(statearr_6121_6138[(2)] = null);

(statearr_6121_6138[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (5))){
var inst_6096 = cljs.core.async.close_BANG_.call(null,out);
var state_6111__$1 = state_6111;
var statearr_6122_6139 = state_6111__$1;
(statearr_6122_6139[(2)] = inst_6096);

(statearr_6122_6139[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (10))){
var inst_6104 = (state_6111[(2)]);
var state_6111__$1 = (function (){var statearr_6123 = state_6111;
(statearr_6123[(8)] = inst_6104);

return statearr_6123;
})();
var statearr_6124_6140 = state_6111__$1;
(statearr_6124_6140[(2)] = null);

(statearr_6124_6140[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6112 === (8))){
var inst_6093 = (state_6111[(7)]);
var state_6111__$1 = state_6111;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6111__$1,(11),out,inst_6093);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___6130,out))
;
return ((function (switch__4517__auto__,c__4605__auto___6130,out){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_6125 = [null,null,null,null,null,null,null,null,null];
(statearr_6125[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_6125[(1)] = (1));

return statearr_6125;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_6111){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_6111);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6126){if((e6126 instanceof Object)){
var ex__4521__auto__ = e6126;
var statearr_6127_6141 = state_6111;
(statearr_6127_6141[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6111);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6126;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6142 = state_6111;
state_6111 = G__6142;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_6111){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_6111);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___6130,out))
})();
var state__4607__auto__ = (function (){var statearr_6128 = f__4606__auto__.call(null);
(statearr_6128[(6)] = c__4605__auto___6130);

return statearr_6128;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___6130,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__6144 = arguments.length;
switch (G__6144) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__4605__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto__){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto__){
return (function (state_6207){
var state_val_6208 = (state_6207[(1)]);
if((state_val_6208 === (7))){
var inst_6203 = (state_6207[(2)]);
var state_6207__$1 = state_6207;
var statearr_6209_6247 = state_6207__$1;
(statearr_6209_6247[(2)] = inst_6203);

(statearr_6209_6247[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (20))){
var inst_6173 = (state_6207[(7)]);
var inst_6184 = (state_6207[(2)]);
var inst_6185 = cljs.core.next.call(null,inst_6173);
var inst_6159 = inst_6185;
var inst_6160 = null;
var inst_6161 = (0);
var inst_6162 = (0);
var state_6207__$1 = (function (){var statearr_6210 = state_6207;
(statearr_6210[(8)] = inst_6159);

(statearr_6210[(9)] = inst_6162);

(statearr_6210[(10)] = inst_6161);

(statearr_6210[(11)] = inst_6184);

(statearr_6210[(12)] = inst_6160);

return statearr_6210;
})();
var statearr_6211_6248 = state_6207__$1;
(statearr_6211_6248[(2)] = null);

(statearr_6211_6248[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (1))){
var state_6207__$1 = state_6207;
var statearr_6212_6249 = state_6207__$1;
(statearr_6212_6249[(2)] = null);

(statearr_6212_6249[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (4))){
var inst_6148 = (state_6207[(13)]);
var inst_6148__$1 = (state_6207[(2)]);
var inst_6149 = (inst_6148__$1 == null);
var state_6207__$1 = (function (){var statearr_6213 = state_6207;
(statearr_6213[(13)] = inst_6148__$1);

return statearr_6213;
})();
if(cljs.core.truth_(inst_6149)){
var statearr_6214_6250 = state_6207__$1;
(statearr_6214_6250[(1)] = (5));

} else {
var statearr_6215_6251 = state_6207__$1;
(statearr_6215_6251[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (15))){
var state_6207__$1 = state_6207;
var statearr_6219_6252 = state_6207__$1;
(statearr_6219_6252[(2)] = null);

(statearr_6219_6252[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (21))){
var state_6207__$1 = state_6207;
var statearr_6220_6253 = state_6207__$1;
(statearr_6220_6253[(2)] = null);

(statearr_6220_6253[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (13))){
var inst_6159 = (state_6207[(8)]);
var inst_6162 = (state_6207[(9)]);
var inst_6161 = (state_6207[(10)]);
var inst_6160 = (state_6207[(12)]);
var inst_6169 = (state_6207[(2)]);
var inst_6170 = (inst_6162 + (1));
var tmp6216 = inst_6159;
var tmp6217 = inst_6161;
var tmp6218 = inst_6160;
var inst_6159__$1 = tmp6216;
var inst_6160__$1 = tmp6218;
var inst_6161__$1 = tmp6217;
var inst_6162__$1 = inst_6170;
var state_6207__$1 = (function (){var statearr_6221 = state_6207;
(statearr_6221[(8)] = inst_6159__$1);

(statearr_6221[(14)] = inst_6169);

(statearr_6221[(9)] = inst_6162__$1);

(statearr_6221[(10)] = inst_6161__$1);

(statearr_6221[(12)] = inst_6160__$1);

return statearr_6221;
})();
var statearr_6222_6254 = state_6207__$1;
(statearr_6222_6254[(2)] = null);

(statearr_6222_6254[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (22))){
var state_6207__$1 = state_6207;
var statearr_6223_6255 = state_6207__$1;
(statearr_6223_6255[(2)] = null);

(statearr_6223_6255[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (6))){
var inst_6148 = (state_6207[(13)]);
var inst_6157 = f.call(null,inst_6148);
var inst_6158 = cljs.core.seq.call(null,inst_6157);
var inst_6159 = inst_6158;
var inst_6160 = null;
var inst_6161 = (0);
var inst_6162 = (0);
var state_6207__$1 = (function (){var statearr_6224 = state_6207;
(statearr_6224[(8)] = inst_6159);

(statearr_6224[(9)] = inst_6162);

(statearr_6224[(10)] = inst_6161);

(statearr_6224[(12)] = inst_6160);

return statearr_6224;
})();
var statearr_6225_6256 = state_6207__$1;
(statearr_6225_6256[(2)] = null);

(statearr_6225_6256[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (17))){
var inst_6173 = (state_6207[(7)]);
var inst_6177 = cljs.core.chunk_first.call(null,inst_6173);
var inst_6178 = cljs.core.chunk_rest.call(null,inst_6173);
var inst_6179 = cljs.core.count.call(null,inst_6177);
var inst_6159 = inst_6178;
var inst_6160 = inst_6177;
var inst_6161 = inst_6179;
var inst_6162 = (0);
var state_6207__$1 = (function (){var statearr_6226 = state_6207;
(statearr_6226[(8)] = inst_6159);

(statearr_6226[(9)] = inst_6162);

(statearr_6226[(10)] = inst_6161);

(statearr_6226[(12)] = inst_6160);

return statearr_6226;
})();
var statearr_6227_6257 = state_6207__$1;
(statearr_6227_6257[(2)] = null);

(statearr_6227_6257[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (3))){
var inst_6205 = (state_6207[(2)]);
var state_6207__$1 = state_6207;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6207__$1,inst_6205);
} else {
if((state_val_6208 === (12))){
var inst_6193 = (state_6207[(2)]);
var state_6207__$1 = state_6207;
var statearr_6228_6258 = state_6207__$1;
(statearr_6228_6258[(2)] = inst_6193);

(statearr_6228_6258[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (2))){
var state_6207__$1 = state_6207;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6207__$1,(4),in$);
} else {
if((state_val_6208 === (23))){
var inst_6201 = (state_6207[(2)]);
var state_6207__$1 = state_6207;
var statearr_6229_6259 = state_6207__$1;
(statearr_6229_6259[(2)] = inst_6201);

(statearr_6229_6259[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (19))){
var inst_6188 = (state_6207[(2)]);
var state_6207__$1 = state_6207;
var statearr_6230_6260 = state_6207__$1;
(statearr_6230_6260[(2)] = inst_6188);

(statearr_6230_6260[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (11))){
var inst_6173 = (state_6207[(7)]);
var inst_6159 = (state_6207[(8)]);
var inst_6173__$1 = cljs.core.seq.call(null,inst_6159);
var state_6207__$1 = (function (){var statearr_6231 = state_6207;
(statearr_6231[(7)] = inst_6173__$1);

return statearr_6231;
})();
if(inst_6173__$1){
var statearr_6232_6261 = state_6207__$1;
(statearr_6232_6261[(1)] = (14));

} else {
var statearr_6233_6262 = state_6207__$1;
(statearr_6233_6262[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (9))){
var inst_6195 = (state_6207[(2)]);
var inst_6196 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_6207__$1 = (function (){var statearr_6234 = state_6207;
(statearr_6234[(15)] = inst_6195);

return statearr_6234;
})();
if(cljs.core.truth_(inst_6196)){
var statearr_6235_6263 = state_6207__$1;
(statearr_6235_6263[(1)] = (21));

} else {
var statearr_6236_6264 = state_6207__$1;
(statearr_6236_6264[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (5))){
var inst_6151 = cljs.core.async.close_BANG_.call(null,out);
var state_6207__$1 = state_6207;
var statearr_6237_6265 = state_6207__$1;
(statearr_6237_6265[(2)] = inst_6151);

(statearr_6237_6265[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (14))){
var inst_6173 = (state_6207[(7)]);
var inst_6175 = cljs.core.chunked_seq_QMARK_.call(null,inst_6173);
var state_6207__$1 = state_6207;
if(inst_6175){
var statearr_6238_6266 = state_6207__$1;
(statearr_6238_6266[(1)] = (17));

} else {
var statearr_6239_6267 = state_6207__$1;
(statearr_6239_6267[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (16))){
var inst_6191 = (state_6207[(2)]);
var state_6207__$1 = state_6207;
var statearr_6240_6268 = state_6207__$1;
(statearr_6240_6268[(2)] = inst_6191);

(statearr_6240_6268[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6208 === (10))){
var inst_6162 = (state_6207[(9)]);
var inst_6160 = (state_6207[(12)]);
var inst_6167 = cljs.core._nth.call(null,inst_6160,inst_6162);
var state_6207__$1 = state_6207;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6207__$1,(13),out,inst_6167);
} else {
if((state_val_6208 === (18))){
var inst_6173 = (state_6207[(7)]);
var inst_6182 = cljs.core.first.call(null,inst_6173);
var state_6207__$1 = state_6207;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6207__$1,(20),out,inst_6182);
} else {
if((state_val_6208 === (8))){
var inst_6162 = (state_6207[(9)]);
var inst_6161 = (state_6207[(10)]);
var inst_6164 = (inst_6162 < inst_6161);
var inst_6165 = inst_6164;
var state_6207__$1 = state_6207;
if(cljs.core.truth_(inst_6165)){
var statearr_6241_6269 = state_6207__$1;
(statearr_6241_6269[(1)] = (10));

} else {
var statearr_6242_6270 = state_6207__$1;
(statearr_6242_6270[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto__))
;
return ((function (switch__4517__auto__,c__4605__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__4518__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__4518__auto____0 = (function (){
var statearr_6243 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_6243[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__4518__auto__);

(statearr_6243[(1)] = (1));

return statearr_6243;
});
var cljs$core$async$mapcat_STAR__$_state_machine__4518__auto____1 = (function (state_6207){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_6207);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6244){if((e6244 instanceof Object)){
var ex__4521__auto__ = e6244;
var statearr_6245_6271 = state_6207;
(statearr_6245_6271[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6207);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6244;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6272 = state_6207;
state_6207 = G__6272;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__4518__auto__ = function(state_6207){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__4518__auto____1.call(this,state_6207);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mapcat_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__4518__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__4518__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto__))
})();
var state__4607__auto__ = (function (){var statearr_6246 = f__4606__auto__.call(null);
(statearr_6246[(6)] = c__4605__auto__);

return statearr_6246;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto__))
);

return c__4605__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__6274 = arguments.length;
switch (G__6274) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__6277 = arguments.length;
switch (G__6277) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__6280 = arguments.length;
switch (G__6280) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__4605__auto___6327 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___6327,out){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___6327,out){
return (function (state_6304){
var state_val_6305 = (state_6304[(1)]);
if((state_val_6305 === (7))){
var inst_6299 = (state_6304[(2)]);
var state_6304__$1 = state_6304;
var statearr_6306_6328 = state_6304__$1;
(statearr_6306_6328[(2)] = inst_6299);

(statearr_6306_6328[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6305 === (1))){
var inst_6281 = null;
var state_6304__$1 = (function (){var statearr_6307 = state_6304;
(statearr_6307[(7)] = inst_6281);

return statearr_6307;
})();
var statearr_6308_6329 = state_6304__$1;
(statearr_6308_6329[(2)] = null);

(statearr_6308_6329[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6305 === (4))){
var inst_6284 = (state_6304[(8)]);
var inst_6284__$1 = (state_6304[(2)]);
var inst_6285 = (inst_6284__$1 == null);
var inst_6286 = cljs.core.not.call(null,inst_6285);
var state_6304__$1 = (function (){var statearr_6309 = state_6304;
(statearr_6309[(8)] = inst_6284__$1);

return statearr_6309;
})();
if(inst_6286){
var statearr_6310_6330 = state_6304__$1;
(statearr_6310_6330[(1)] = (5));

} else {
var statearr_6311_6331 = state_6304__$1;
(statearr_6311_6331[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6305 === (6))){
var state_6304__$1 = state_6304;
var statearr_6312_6332 = state_6304__$1;
(statearr_6312_6332[(2)] = null);

(statearr_6312_6332[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6305 === (3))){
var inst_6301 = (state_6304[(2)]);
var inst_6302 = cljs.core.async.close_BANG_.call(null,out);
var state_6304__$1 = (function (){var statearr_6313 = state_6304;
(statearr_6313[(9)] = inst_6301);

return statearr_6313;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6304__$1,inst_6302);
} else {
if((state_val_6305 === (2))){
var state_6304__$1 = state_6304;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6304__$1,(4),ch);
} else {
if((state_val_6305 === (11))){
var inst_6284 = (state_6304[(8)]);
var inst_6293 = (state_6304[(2)]);
var inst_6281 = inst_6284;
var state_6304__$1 = (function (){var statearr_6314 = state_6304;
(statearr_6314[(7)] = inst_6281);

(statearr_6314[(10)] = inst_6293);

return statearr_6314;
})();
var statearr_6315_6333 = state_6304__$1;
(statearr_6315_6333[(2)] = null);

(statearr_6315_6333[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6305 === (9))){
var inst_6284 = (state_6304[(8)]);
var state_6304__$1 = state_6304;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6304__$1,(11),out,inst_6284);
} else {
if((state_val_6305 === (5))){
var inst_6281 = (state_6304[(7)]);
var inst_6284 = (state_6304[(8)]);
var inst_6288 = cljs.core._EQ_.call(null,inst_6284,inst_6281);
var state_6304__$1 = state_6304;
if(inst_6288){
var statearr_6317_6334 = state_6304__$1;
(statearr_6317_6334[(1)] = (8));

} else {
var statearr_6318_6335 = state_6304__$1;
(statearr_6318_6335[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6305 === (10))){
var inst_6296 = (state_6304[(2)]);
var state_6304__$1 = state_6304;
var statearr_6319_6336 = state_6304__$1;
(statearr_6319_6336[(2)] = inst_6296);

(statearr_6319_6336[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6305 === (8))){
var inst_6281 = (state_6304[(7)]);
var tmp6316 = inst_6281;
var inst_6281__$1 = tmp6316;
var state_6304__$1 = (function (){var statearr_6320 = state_6304;
(statearr_6320[(7)] = inst_6281__$1);

return statearr_6320;
})();
var statearr_6321_6337 = state_6304__$1;
(statearr_6321_6337[(2)] = null);

(statearr_6321_6337[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___6327,out))
;
return ((function (switch__4517__auto__,c__4605__auto___6327,out){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_6322 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_6322[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_6322[(1)] = (1));

return statearr_6322;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_6304){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_6304);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6323){if((e6323 instanceof Object)){
var ex__4521__auto__ = e6323;
var statearr_6324_6338 = state_6304;
(statearr_6324_6338[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6304);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6323;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6339 = state_6304;
state_6304 = G__6339;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_6304){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_6304);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___6327,out))
})();
var state__4607__auto__ = (function (){var statearr_6325 = f__4606__auto__.call(null);
(statearr_6325[(6)] = c__4605__auto___6327);

return statearr_6325;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___6327,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__6341 = arguments.length;
switch (G__6341) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__4605__auto___6407 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___6407,out){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___6407,out){
return (function (state_6379){
var state_val_6380 = (state_6379[(1)]);
if((state_val_6380 === (7))){
var inst_6375 = (state_6379[(2)]);
var state_6379__$1 = state_6379;
var statearr_6381_6408 = state_6379__$1;
(statearr_6381_6408[(2)] = inst_6375);

(statearr_6381_6408[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (1))){
var inst_6342 = (new Array(n));
var inst_6343 = inst_6342;
var inst_6344 = (0);
var state_6379__$1 = (function (){var statearr_6382 = state_6379;
(statearr_6382[(7)] = inst_6343);

(statearr_6382[(8)] = inst_6344);

return statearr_6382;
})();
var statearr_6383_6409 = state_6379__$1;
(statearr_6383_6409[(2)] = null);

(statearr_6383_6409[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (4))){
var inst_6347 = (state_6379[(9)]);
var inst_6347__$1 = (state_6379[(2)]);
var inst_6348 = (inst_6347__$1 == null);
var inst_6349 = cljs.core.not.call(null,inst_6348);
var state_6379__$1 = (function (){var statearr_6384 = state_6379;
(statearr_6384[(9)] = inst_6347__$1);

return statearr_6384;
})();
if(inst_6349){
var statearr_6385_6410 = state_6379__$1;
(statearr_6385_6410[(1)] = (5));

} else {
var statearr_6386_6411 = state_6379__$1;
(statearr_6386_6411[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (15))){
var inst_6369 = (state_6379[(2)]);
var state_6379__$1 = state_6379;
var statearr_6387_6412 = state_6379__$1;
(statearr_6387_6412[(2)] = inst_6369);

(statearr_6387_6412[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (13))){
var state_6379__$1 = state_6379;
var statearr_6388_6413 = state_6379__$1;
(statearr_6388_6413[(2)] = null);

(statearr_6388_6413[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (6))){
var inst_6344 = (state_6379[(8)]);
var inst_6365 = (inst_6344 > (0));
var state_6379__$1 = state_6379;
if(cljs.core.truth_(inst_6365)){
var statearr_6389_6414 = state_6379__$1;
(statearr_6389_6414[(1)] = (12));

} else {
var statearr_6390_6415 = state_6379__$1;
(statearr_6390_6415[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (3))){
var inst_6377 = (state_6379[(2)]);
var state_6379__$1 = state_6379;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6379__$1,inst_6377);
} else {
if((state_val_6380 === (12))){
var inst_6343 = (state_6379[(7)]);
var inst_6367 = cljs.core.vec.call(null,inst_6343);
var state_6379__$1 = state_6379;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6379__$1,(15),out,inst_6367);
} else {
if((state_val_6380 === (2))){
var state_6379__$1 = state_6379;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6379__$1,(4),ch);
} else {
if((state_val_6380 === (11))){
var inst_6359 = (state_6379[(2)]);
var inst_6360 = (new Array(n));
var inst_6343 = inst_6360;
var inst_6344 = (0);
var state_6379__$1 = (function (){var statearr_6391 = state_6379;
(statearr_6391[(7)] = inst_6343);

(statearr_6391[(10)] = inst_6359);

(statearr_6391[(8)] = inst_6344);

return statearr_6391;
})();
var statearr_6392_6416 = state_6379__$1;
(statearr_6392_6416[(2)] = null);

(statearr_6392_6416[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (9))){
var inst_6343 = (state_6379[(7)]);
var inst_6357 = cljs.core.vec.call(null,inst_6343);
var state_6379__$1 = state_6379;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6379__$1,(11),out,inst_6357);
} else {
if((state_val_6380 === (5))){
var inst_6347 = (state_6379[(9)]);
var inst_6343 = (state_6379[(7)]);
var inst_6352 = (state_6379[(11)]);
var inst_6344 = (state_6379[(8)]);
var inst_6351 = (inst_6343[inst_6344] = inst_6347);
var inst_6352__$1 = (inst_6344 + (1));
var inst_6353 = (inst_6352__$1 < n);
var state_6379__$1 = (function (){var statearr_6393 = state_6379;
(statearr_6393[(11)] = inst_6352__$1);

(statearr_6393[(12)] = inst_6351);

return statearr_6393;
})();
if(cljs.core.truth_(inst_6353)){
var statearr_6394_6417 = state_6379__$1;
(statearr_6394_6417[(1)] = (8));

} else {
var statearr_6395_6418 = state_6379__$1;
(statearr_6395_6418[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (14))){
var inst_6372 = (state_6379[(2)]);
var inst_6373 = cljs.core.async.close_BANG_.call(null,out);
var state_6379__$1 = (function (){var statearr_6397 = state_6379;
(statearr_6397[(13)] = inst_6372);

return statearr_6397;
})();
var statearr_6398_6419 = state_6379__$1;
(statearr_6398_6419[(2)] = inst_6373);

(statearr_6398_6419[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (10))){
var inst_6363 = (state_6379[(2)]);
var state_6379__$1 = state_6379;
var statearr_6399_6420 = state_6379__$1;
(statearr_6399_6420[(2)] = inst_6363);

(statearr_6399_6420[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6380 === (8))){
var inst_6343 = (state_6379[(7)]);
var inst_6352 = (state_6379[(11)]);
var tmp6396 = inst_6343;
var inst_6343__$1 = tmp6396;
var inst_6344 = inst_6352;
var state_6379__$1 = (function (){var statearr_6400 = state_6379;
(statearr_6400[(7)] = inst_6343__$1);

(statearr_6400[(8)] = inst_6344);

return statearr_6400;
})();
var statearr_6401_6421 = state_6379__$1;
(statearr_6401_6421[(2)] = null);

(statearr_6401_6421[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___6407,out))
;
return ((function (switch__4517__auto__,c__4605__auto___6407,out){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_6402 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_6402[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_6402[(1)] = (1));

return statearr_6402;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_6379){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_6379);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6403){if((e6403 instanceof Object)){
var ex__4521__auto__ = e6403;
var statearr_6404_6422 = state_6379;
(statearr_6404_6422[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6379);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6403;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6423 = state_6379;
state_6379 = G__6423;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_6379){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_6379);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___6407,out))
})();
var state__4607__auto__ = (function (){var statearr_6405 = f__4606__auto__.call(null);
(statearr_6405[(6)] = c__4605__auto___6407);

return statearr_6405;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___6407,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__6425 = arguments.length;
switch (G__6425) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__4605__auto___6495 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__4605__auto___6495,out){
return (function (){
var f__4606__auto__ = (function (){var switch__4517__auto__ = ((function (c__4605__auto___6495,out){
return (function (state_6467){
var state_val_6468 = (state_6467[(1)]);
if((state_val_6468 === (7))){
var inst_6463 = (state_6467[(2)]);
var state_6467__$1 = state_6467;
var statearr_6469_6496 = state_6467__$1;
(statearr_6469_6496[(2)] = inst_6463);

(statearr_6469_6496[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (1))){
var inst_6426 = [];
var inst_6427 = inst_6426;
var inst_6428 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_6467__$1 = (function (){var statearr_6470 = state_6467;
(statearr_6470[(7)] = inst_6428);

(statearr_6470[(8)] = inst_6427);

return statearr_6470;
})();
var statearr_6471_6497 = state_6467__$1;
(statearr_6471_6497[(2)] = null);

(statearr_6471_6497[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (4))){
var inst_6431 = (state_6467[(9)]);
var inst_6431__$1 = (state_6467[(2)]);
var inst_6432 = (inst_6431__$1 == null);
var inst_6433 = cljs.core.not.call(null,inst_6432);
var state_6467__$1 = (function (){var statearr_6472 = state_6467;
(statearr_6472[(9)] = inst_6431__$1);

return statearr_6472;
})();
if(inst_6433){
var statearr_6473_6498 = state_6467__$1;
(statearr_6473_6498[(1)] = (5));

} else {
var statearr_6474_6499 = state_6467__$1;
(statearr_6474_6499[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (15))){
var inst_6457 = (state_6467[(2)]);
var state_6467__$1 = state_6467;
var statearr_6475_6500 = state_6467__$1;
(statearr_6475_6500[(2)] = inst_6457);

(statearr_6475_6500[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (13))){
var state_6467__$1 = state_6467;
var statearr_6476_6501 = state_6467__$1;
(statearr_6476_6501[(2)] = null);

(statearr_6476_6501[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (6))){
var inst_6427 = (state_6467[(8)]);
var inst_6452 = inst_6427.length;
var inst_6453 = (inst_6452 > (0));
var state_6467__$1 = state_6467;
if(cljs.core.truth_(inst_6453)){
var statearr_6477_6502 = state_6467__$1;
(statearr_6477_6502[(1)] = (12));

} else {
var statearr_6478_6503 = state_6467__$1;
(statearr_6478_6503[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (3))){
var inst_6465 = (state_6467[(2)]);
var state_6467__$1 = state_6467;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_6467__$1,inst_6465);
} else {
if((state_val_6468 === (12))){
var inst_6427 = (state_6467[(8)]);
var inst_6455 = cljs.core.vec.call(null,inst_6427);
var state_6467__$1 = state_6467;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6467__$1,(15),out,inst_6455);
} else {
if((state_val_6468 === (2))){
var state_6467__$1 = state_6467;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_6467__$1,(4),ch);
} else {
if((state_val_6468 === (11))){
var inst_6435 = (state_6467[(10)]);
var inst_6431 = (state_6467[(9)]);
var inst_6445 = (state_6467[(2)]);
var inst_6446 = [];
var inst_6447 = inst_6446.push(inst_6431);
var inst_6427 = inst_6446;
var inst_6428 = inst_6435;
var state_6467__$1 = (function (){var statearr_6479 = state_6467;
(statearr_6479[(7)] = inst_6428);

(statearr_6479[(11)] = inst_6447);

(statearr_6479[(8)] = inst_6427);

(statearr_6479[(12)] = inst_6445);

return statearr_6479;
})();
var statearr_6480_6504 = state_6467__$1;
(statearr_6480_6504[(2)] = null);

(statearr_6480_6504[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (9))){
var inst_6427 = (state_6467[(8)]);
var inst_6443 = cljs.core.vec.call(null,inst_6427);
var state_6467__$1 = state_6467;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_6467__$1,(11),out,inst_6443);
} else {
if((state_val_6468 === (5))){
var inst_6435 = (state_6467[(10)]);
var inst_6428 = (state_6467[(7)]);
var inst_6431 = (state_6467[(9)]);
var inst_6435__$1 = f.call(null,inst_6431);
var inst_6436 = cljs.core._EQ_.call(null,inst_6435__$1,inst_6428);
var inst_6437 = cljs.core.keyword_identical_QMARK_.call(null,inst_6428,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_6438 = ((inst_6436) || (inst_6437));
var state_6467__$1 = (function (){var statearr_6481 = state_6467;
(statearr_6481[(10)] = inst_6435__$1);

return statearr_6481;
})();
if(cljs.core.truth_(inst_6438)){
var statearr_6482_6505 = state_6467__$1;
(statearr_6482_6505[(1)] = (8));

} else {
var statearr_6483_6506 = state_6467__$1;
(statearr_6483_6506[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (14))){
var inst_6460 = (state_6467[(2)]);
var inst_6461 = cljs.core.async.close_BANG_.call(null,out);
var state_6467__$1 = (function (){var statearr_6485 = state_6467;
(statearr_6485[(13)] = inst_6460);

return statearr_6485;
})();
var statearr_6486_6507 = state_6467__$1;
(statearr_6486_6507[(2)] = inst_6461);

(statearr_6486_6507[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (10))){
var inst_6450 = (state_6467[(2)]);
var state_6467__$1 = state_6467;
var statearr_6487_6508 = state_6467__$1;
(statearr_6487_6508[(2)] = inst_6450);

(statearr_6487_6508[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_6468 === (8))){
var inst_6435 = (state_6467[(10)]);
var inst_6427 = (state_6467[(8)]);
var inst_6431 = (state_6467[(9)]);
var inst_6440 = inst_6427.push(inst_6431);
var tmp6484 = inst_6427;
var inst_6427__$1 = tmp6484;
var inst_6428 = inst_6435;
var state_6467__$1 = (function (){var statearr_6488 = state_6467;
(statearr_6488[(14)] = inst_6440);

(statearr_6488[(7)] = inst_6428);

(statearr_6488[(8)] = inst_6427__$1);

return statearr_6488;
})();
var statearr_6489_6509 = state_6467__$1;
(statearr_6489_6509[(2)] = null);

(statearr_6489_6509[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__4605__auto___6495,out))
;
return ((function (switch__4517__auto__,c__4605__auto___6495,out){
return (function() {
var cljs$core$async$state_machine__4518__auto__ = null;
var cljs$core$async$state_machine__4518__auto____0 = (function (){
var statearr_6490 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_6490[(0)] = cljs$core$async$state_machine__4518__auto__);

(statearr_6490[(1)] = (1));

return statearr_6490;
});
var cljs$core$async$state_machine__4518__auto____1 = (function (state_6467){
while(true){
var ret_value__4519__auto__ = (function (){try{while(true){
var result__4520__auto__ = switch__4517__auto__.call(null,state_6467);
if(cljs.core.keyword_identical_QMARK_.call(null,result__4520__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__4520__auto__;
}
break;
}
}catch (e6491){if((e6491 instanceof Object)){
var ex__4521__auto__ = e6491;
var statearr_6492_6510 = state_6467;
(statearr_6492_6510[(5)] = ex__4521__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_6467);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e6491;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__4519__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__6511 = state_6467;
state_6467 = G__6511;
continue;
} else {
return ret_value__4519__auto__;
}
break;
}
});
cljs$core$async$state_machine__4518__auto__ = function(state_6467){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__4518__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__4518__auto____1.call(this,state_6467);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__4518__auto____0;
cljs$core$async$state_machine__4518__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__4518__auto____1;
return cljs$core$async$state_machine__4518__auto__;
})()
;})(switch__4517__auto__,c__4605__auto___6495,out))
})();
var state__4607__auto__ = (function (){var statearr_6493 = f__4606__auto__.call(null);
(statearr_6493[(6)] = c__4605__auto___6495);

return statearr_6493;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__4607__auto__);
});})(c__4605__auto___6495,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;


//# sourceMappingURL=async.js.map
